2013-10-25  Erik Ogenvik  <erik@ogenvik.org>

	* NEWS: Update NEWS announcement for release.

	* Release 0.6.2

2013-10-25  Erik Ogenvik  <erik@ogenvik.org>

	* Fixed Segfault when character wielding entity was destroyed.

	* New spawner property

2013-09-21  Erik Ogenvik  <erik@ogenvik.org>

	* NEWS: Update NEWS announcement for release.

	* Release 0.6.1

2013-09-21  Erik Ogenvik  <erik@ogenvik.org>

	* New authoring, inspection and persistence of minds.
	
	* Improvements to goals, making forester and lumberjack more lively.
	
	* Full persistence of world, along with minds, at shutdown.
	
	* Internal rewrites of many core functions.

2012-11-11  Alistair Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.6.0

2012-11-08  Alistair Riddoch  <alriddoch@googlemail.com>

	* New game systems by Jekin Trivedi implementing earthworks, and
	  prototypes of baking, rope making and other crafting.

	* New game systems by Elminster starting work on metal smelting.

	* New game systems by Anthony Pesce implementing pioneering.

	* New prototype game system for magic spells.

	* Almost all the core code has been touched in some way over the last
	  18 months in changes which have increased robustness, flexibility,
	  performance and reliability.

2011-03-01  Alistair Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.26

2011-02-28  Alistair Riddoch  <alriddoch@googlemail.com>

	* Update the shape classes and wrappers to allow scaling and other
	  math operations.

	* Add terrain areas to mods created in tasks for better visualisation.

	* Modify the attribute API to allow properties to be handled better.

2011-02-17  Alistair Riddoch  <alriddoch@googlemail.com>

	* Add support for connecting between servers, and moving entities
	  between servers.

	* Re-write terrain mod handling so it handles in place modification.

	* Add a bunch of scripting API to allow task scripts to do more
	  with terrain.

	* Improve the test boilerplate so code is tested more thoroughly in
	  non-debug builds.

	* Lots of bug fixes.

2010-11-16  Alistair Riddoch  <alriddoch@googlemail.com>

	* server/ScriptFactory.h, server/TaskScriptFactory.h,
	  server/Ruleset.cpp: Fix bug where an error in a new Python
	  script caused the server to get into an inconsistent state.

2010-11-16  Alistair Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.25

2010-11-12  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/binreloc.c, common/binreloc.h, common/globals.cpp,
	  common/prefix.c, common/prefix.h, common/system_prefix.cpp:
	  Update to a newer version of the binreloc code.

	* physics/Collision.h:
	  Update for more recent compiler versions.

	* modules/TerrainContext.cpp, modules/TerrainContext.h,
	  rulesets/InnerTerrainMod_impl.h,
	  rulesets/Py_Property.cpp, rulesets/Py_Property.h,
	  rulesets/Py_TerrainModProperty.cpp, rulesets/Py_TerrainProperty.cpp,
	  rulesets/Python_API.cpp,
	  rulesets/TerrainMod.cpp, rulesets/TerrainMod.h,
	  rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h,
	  rulesets/TerrainMod_impl.h,
	  rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h,
	  rulesets/mason/world/tasks/Delve.py,
	  server/CorePropertyManager.cpp, server/EntityBuilder.cpp:
	  Implement creating quarry objects in Delve task by adding
	  features to track the entity associated with a terrain mod
	  and exposing terrain mods to the terrain property interface.

	* rulesets/Entity.h: Update iostream output of Location for clarity.

	* rulesets/basic/editor.py, rulesets/mason/benchmarks.py,
	  rulesets/mason/define_world.py, rulesets/mason/regression.py,
	  rulesets/mason/terrain.py, rulesets/mason/tests.py:
	  Change the client script interface to be way more flexible allowing
	  OOG operations in scripts.

	* server/CommServer.cpp: Fix a corner case for testing where fd for
	  epoll wasn't initialised.

2010-08-29  Alistair Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.24

2010-08-19  Alistair Riddoch  <alriddoch@googlemail.com>

	* Refactor client code to make it way more flexible.

	* Fix up to compile on windows.

	* Add a bunch of new fish species.

	* Add a number of buildings related to castle construction,
	  and furniture.

	* Massively improve test coverage.

2009-01-03  Alistair Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.23

2010-01-03  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/BaseWorld.h, common/Property.cpp, common/debug.cpp,
	  rulesets/AreaProperty.cpp, rulesets/AreaProperty.h,
	  rulesets/SpawnProperty.cpp, rulesets/SpawnProperty.h,
	  server/Account.cpp, server/Account.h,
	  server/CorePropertyManager.cpp,
	  server/Spawn,cpp, server/Spawn.h, server/SpawnEntity.cpp,
	  server/SpawnEntity.h, server/WorldRouter.cpp, server/WorldRouter.h:
	  Implement configurable data driven spawn points.

2009-12-29  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/AtlasStreamClient.h: Add an accessor for errors reported
	  server communication.

	* client/BaseClient.cpp: Improve error reporting using the accessor.

	* client/ObserverClient.cpp: Report when an error fails making a
	  local connection.

	* common/AtlasStreamClient.cpp: Improve handling of reply and error
	  flags. Fix a bug in how the account type was picked up on
	  successful login. Correctly tidy up tasks which fail on setup.

	* common/ClientTask.h, tools/Flusher.cpp, tools/OperationMonitor.cpp:
	  Add a description to all tasks.

	* common/globals.cpp: Change the point at which option post-processing
	  is done to ensure all options have been read so related options
	  get the right value.

	* common/log.cpp: Improve the way log levels are output to use
	  iostream operators, making it more flexible.

	* rulesets/Creator.cpp: Enable Talk ops for the creator, giving it
	  an opportunity to control AIs. Add confirmation of in-game
	  operations puppeted to other entities which otherwise might not
	  be visible.

	* server/Admin.cpp: Modify some error reporting to only report an
	  error to the client, and not log the error on the server.

	* server/Connection.cpp: Support returning an error if account
	  creation fails.

	* tests/Connectiontest.cpp, tests/TrustedConnectiontest.cpp: Fix
	  a bug which can cause a crash when a map was modified while
	  iterating over it.

	* tools/MultiLineListFormatter.cpp, tools/MultiLineListFormatter.h,
	  tools/cydumprules.cpp
	  Move a class for formatting Atlas XML data in a good readable way
	  into its own file for reuse.

	* tools/Interactive.cpp, tools/WorldDumper.cpp, tools/WorldDumper.h,
	  tools/WorldLoader.cpp, tools/WorldLoader.h: 
	  Add new commands for dumping and restoring world data. Suppress
	  displaying lots of options when a task is running. Add more data
	  to the prompt, including task descriptions.

	* tools/cycmd.cpp: Simplify the logic around logging in in the common
	  case.

2009-12-04  Alistair Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.22

2009-11-28  Alistair Riddoch  <alriddoch@googlemail.com>

	* client/BaseClient.cpp, client/CharacterClient.cpp,
	  client/ClientConnection.cpp, client/ClientConnection.h.
	  common/AtlasStreamClient.cpp, common/AtlasStreamClient.h,
	  common/ClientTask.cpp, common/ClientTask.h,
	  tools/AdminClient.cpp, tools/AdminClient.h,
	  tools/AdminTask.cpp, tools/AdminTask.h,
	  tools/Interactive.cpp, tools/Interactive.h,
	  tools/Flusher.h, tools/OperationMonitor.h:
	  Clean up client code, moving all generic functionality into
	  a common class, with features available to all tools and clients.

2009-11-27  Alistair Riddoch  <alriddoch@googlemail.com>

	* tools/AdminTask.cpp, tools/AdminTask.h,
	* tools/Flusher.cpp, tools/Flusher.h,
	* tools/Interactive.cpp, tools/Interactive.h,
	* tools/OperationMonitor.cpp, tools/OperationMonitor.h,
	* tools/cycmd.cpp: Break out classes into separate files for
	  better maintainability. Move more functionality into base
	  classes.

2009-11-26  Alistair Riddoch  <alriddoch@googlemail.com>

	* client/BaseClient.cpp, client/BaseClient.h,
	  client/ObserverClient.cpp:
	  Clean up and use the Atlas-C++ API a bit better.

	* common/AtlasStreamClient.cpp, common/AtlasStreamClient.h, 
	  client/ClientConnection.cpp, client/ClientConnection.h,
	  tools/AdminClient.cpp, tools/AdminClient.h,
	  tools/cyaddrules.cpp, tools/cycmd.cpp:
	  Create a new base class, and move common functionality from
	  tools and clients which connect to a server to it.
	  Remove unused functions.

	* client/Py_CreatorClient.cpp: Fix some bugs with the creation
	  and cleanup of this wrapper.

	* client/Py_CreatorClient.cpp, client/Py_ObserverClient.cpp,
	  client/Py_ObserverClient.h, rulesets/Python_API.h:
	  Implement a wrapper for ObserverClient, and a function
	  which calls the Main function of the Python interpretter.

	* client/client.cpp: Handle setup of client objects better.
	  Implement interactive mode which gives the user a Python
	  prompt.

	* common/globals.cpp: Add documentation for the added client
	  interactive option.

	* common/Inheritance.h, common/Inheritance.cpp: Provide a mechanism
	  for types to be updated in the tree.

	* common/custom.cpp: Add a type definition for the missing Connect
	  operation.

	* rulesets/Entity.cpp, rulesets/Entity.h: Improve the setProperty()
	  interface making it more useful.

	* rulesets/Entity.cpp: Fix a segfault when at entity with no type
	  is represented in Atlas.

	* rulesets/Py_Location.cpp: Remove obsolete support for the
	  remove way of supporting entity scripts.

	* rulesets/Py_Message.cpp: Clean up the way an error is reported.

	* rulesets/Py_Operation.cpp: Convert to using the latest Atlas-C++
	  API properly and fix some places where error conditions were not
	  correctly returned.

	* rulesets/Py_Oplist.cpp: Return error conditions in some places
	  where they were missed.

	* rulesets/Py_Point3D.cpp: Remove pointless _print operator.
	  It is never called.

	* rulesets/Py_Quaternion.cpp: Remove unnecessary type check from
	  comparison operator.

	* rulesets/Py_RootEntity.cpp: Don't set an error when the Python
	  API function will already have set it.

	* rulesets/Py_Task.cpp: Remove a useless, unused function.

	* rulesets/Py_TerrainProperty.cpp: Add null checks for all
	  pointers in the object to the assertion checks.

	* rulesets/Py_Thing.cpp: Allow type to be set by the Python API,
	  as long as has not been set already.

	* rulesets/Py_Vector3D.cpp: Return errors in a bunch of places
	  where it was missed. Remove pointless _print operator.

	* rulesets/PythonEntityScript.cpp: DECREF in the right place.

	* scripts/run_coverage_tests.sh: Update to handle files in
	  the tree that are no longer in the build.

	* server/Account.cpp, server/Admin.cpp: Initialise pointers better,
	  and be more tolerant of non-fatal error conditions.

	* server/Account.h: Make members protected as they should be.

	* server/CommServer.cpp, server/CommServer.h: Report errors when
	  adding a socket fails.

	* server/CommUnixListener.cpp: Add unix socket based user
	  authentication as implemented in the new client socket class,
	  so that all local connections can be locked down, thus making
	  it easier to grant them privs.

	* server/Connection.cpp, server/Connection.h: Expand the interface
	  for account creation so the kind of account can be specified.
	  Remove support for the legacy protocol, now many years obsolete.
	  Move handling of persistent accounts into the ServerRouting
	  object which owns them.

	* server/Persistence.cpp: Access the protected members of Account
	  correctly.

	* server/Player.cpp: Remove support for libstdc++ API from about
	  a decade ago.

	* server/Ruleset.cpp: Check updated types way more thoroughly,
	  and push the updated Atlas descritpion into the Inheritance tree.

	* server/ServerRouting.cpp, server/ServerRouting.h: Handle account
	  persistence here.

	* server/TrustedConnection.cpp, server/TrustedConnection.h:
	  Override account creation so extra privs are available to local
	  connections.

	* tools/cycmd.cpp: Make commands for querying objects and types
	  more coherant and consistent. Add command for IG looks.

2009-11-06  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/log.cpp, common/log.h: Add a function to log multiline
	  strings more cleanly.

	* tests/logtest.cpp: Add tests for new log functionality.

	* common/Database.cpp: Clean up logging of errors and notices.

	* scripts/mingw32_configure.sh: Add a script to configure for
	  mingw cross-compiling.

	* common/globals.cpp, common/log.cpp, common/log.h,
	  configure.ac, rulesets/HandlerProperty.cpp,
	  rulesets/MultiHandlerProperty.cpp:
	  Add headers and cleanups required by some obscure systems.

	* server/CommMDNSPublisher.cpp: Add cassert include to the right
	  place, so this file compiles no matter which MDNS backend is
	  selected.

	* server/CommStreamClient.cpp, server/CommMetaClient.cpp:
	  Use the correct C++ library way of checking for eof.

	* server/Persistence.cpp, server/Persistence.h,
	  server/Ruleset.cpp, server/Ruleset.h: Fully implement rule
	  persistence.

	* tests/Rulesettest.cpp: Update Ruleset tests.

	* tools/cyaddrules.cpp, tools/cydumprules.cpp,
	  tools/cyloadrules.cpp: Update tools to produce cleaner output,
	  and report what they have done more sanely.

2009-09-08  Alistair Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.21

2009-09-08  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/Monitors.cpp, common/Monitors.h,
	  common/Variable.cpp, common/Variable.h: Move monitor variables
	  into their own file.

	* server/EntityBuilder.cpp, server/ServerRouting.cpp,
	  server/StorageManager.cpp, server/WorldRouter.cpp:
	  Update code that exposes variables as monitors.

	* server/Account.h, server/Lobby.cpp, server/Lobby.h,
	  server/ServerRouting.cpp, server/ServerRouting.h,
	  server/UpdateTester.cpp: Clean up the account header,
	  using inline where appropriate.

2009-08-26  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/Motion.cpp: Ensure full details are reported when a
	  collision does not work as expected.

2009-08-25  Alistair Riddoch  <alriddoch@googlemail.com>

	* data/animals.xml, data/tasks.xml, data/terrain.xml, data/tools.xml:
	  Add fish classes, and the tools and tasks required for fishing.

	* rulesets/basic/mind/goals/animal/herd.py: Add a new non-functional
	  school goal for fish.

	* rulesets/basic/mind/goals/common/misc_goal.py: Add a random movement
	  goal for fish.

	* rulesets/basic/mind/panlingua/interlinguish.py: Add new verbs for
	  fish.

	* rulesets/mason/define_world.py: Add some shoals of fish into the
	  world, and make fishing tools available at the market stall.

	* rulesets/mason/world/objects/Weather.py: Make the weather affect
	  the moistness of the terrain for the bait gathering goals.

	* rulesets/mason/world/tasks/Sift.py: The new task for bait gathering.

	* rulesets/mason/world/tasks/Fishing.py: The new task for fishing.

2009-08-25  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/ArithmeticFactory.cpp, rulesets/ArithmeticFactory.h,
	  server/EntityFactory.cpp, server/EntityFactory.h,
	  server/ScriptFactory.cpp, server/ScriptFactory.h,
	  server/TaskFactory.cpp, server/TaskFactory.h,
	  server/TaskScriptFactory.cpp, server/TaskScriptFactory.h:
	  Rename abstract factory classes to use the Kit suffix for
	  consistency. Re-work the code path for task scripts so it works
	  the same way as it does for entity scripts.

	* rulesets/Character.cpp: Add an error message if a task looks like
	  it has stalled.

	* rulesets/Domain.cpp: Add crude support for the "floating" mode.

	* rulesets/Py_TerrainProperty.cpp, rulesets/TerrainProperty.cpp,
	  rulesets/TerrainProperty.h:
	  Clean up the methods involved in retrieving height and normal
	  data from the terrain. Fix a few issues and make them more
	  efficient.

	* rulesets/World.cpp, rulesets/World.h: Remove some hardcoded
	  terrain related functions and depend on properties for terrain data.

	* rulesets/mason/tests.py: Add a test method for fish.

	* server/Admin.cpp, server/EntityBuilder.cpp, server/EntityBuilder.h,
	  server/Ruleset.cpp, server/Ruleset.h, server/server.cpp: Move code
	  for loading rules from files or database and parsing the Atlas
	  data out of EntituBuilder into a class of its own called Ruleset.
	  Implement re-loading and updating of task classes.

	* tests/EntityBuildertest.cpp, tests/Rulesettest.cpp:
	  Update the tests now that the functionality has been broken up.

	* Comprehensively review and remove unnecessary includes, and add
	  doc comments.

2009-08-05  Alistair Riddoch  <alriddoch@googlemail.com>

	* server/WorldRouter.cpp, rulesets/Domain.cpp: Fix mode handling and
	  make "fixed" work again.

	* rulesets/LocatedEntity.cpp: Fix implementation of hasAttr so that
	  it checks type defaults as well as instance attributes.

2009-08-05  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/PythonEntityScript.cpp, rulesets/Python_API.cpp:
	  Clear up a couple of locations where new Python objects are not
	  checked for NULL.

2009-08-04  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/op_switch.h, rulesets/Character.cpp,
	  rulesets/Entity.h, rulesets/Entity.cpp: Move Task operations
	  from being set up in the mind filter to being handled at the
	  Entity level, so they can be initiated remotely.

	* rulesets/BaseMind.h, rulesets/BaseMind.cpp: Handle Unseen operations
	  in the core C++ code.

	* rulesets/Character.h, rulesets/Character.cpp: Re-factor the
	  way tasks are started adding a higher level, consistent and
	  more efficient method to start them. Remove idiosyncrasies in
	  the way task updates are handled.

	* rulesets/Py_Thing.cpp: Update the wrappers for the task creation
	  function.

	* rulesets/Py_BBox.cpp: Box corners are points, so expose them
	  to Python using the Point type to cut down mangling and copies.

	* rulesets/Py_Map.cpp, tools/AdminClient.cpp:
	  Add necessary try/catch blocks around calls to createObject.

	* rulesets/Py_Map.cpp: Remove some unnecessary null checks.

	* rulesets/Py_Operation.cpp: Allow operations of any type to be
	  created, not just those classes registered with the Atlas-C++
	  factory, so the client can inject arbitrary operations.

	* rulesets/Task.h, rulesets/Task.cpp, rulesets/Py_Task.cpp:
	  Expose underlying soft attributes in the task object.

	* rulesets/TasksProperty.cpp: Handle retrieving task data
	  when no task is running more cleanly.

	* 

2009-07-23  Alexey Torkhov  <atorkhov@gmail.com>

	* rulesets/Task.cpp, rulesets/Task.h: Add support for freefrom task
	  attributes.

	* rulesets/TaskProperties.cpp: Expose task attributes to Set
	  operations.

	* tests/PropertyCoverage.cpp, tests/PropertyCoverage.h: Add
	  functionality for testing character specific property
	  functionality.

2009-07-23  Amey Parulekar  <amey.par@gmail.com>

	* rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h:
	  Add a method to query the normal at a point on the terrain.

	* rulesets/Py_TerrainProperty.cpp: Add Python binding for the
	  normal querying method.

2009-07-23  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/DynamicProperty.cpp, common/DynamicProperty.h,
	  common/DynamicProperty_impl.h: Remove some long obsolete files.

	* common/custom.cpp, common/custom.h: Clean up the way custom
	  ops are defined so there is not so much header clutter.

	* common/terrain_utils.cpp: Remove an unused file.

	* common/type_utils.cpp, common/type_utils.h,
	  common/types_utils_impl.h: Don't inline heavyweight code.

	* rulesets/Character.cpp, rulesets/Character.h: Add stub handlers
	  for debug operations from AI code.

	* rulesets/EntityProperties.cpp: Add checks so that malformed data
	  does not cause a crash.

	* rulesets/LineProperty.h: Include template implementation so code
	  is generated for type conversion function templates.


	* rulesets/PythonEntityScript.cpp: Add better reporting of errors
	  from Python scripts.

	* rulesets/basic/min/goals/animal/herd.py: Try and clean up the
	  flock goal.

	* rulesets/mason/define_world.py: Disable flock for chickens.
	  It was just too broken.

	* rulesets/mason/test.py: Add tests for chickens, and fire entity
	  containment.

	* scripts/run_coverage_tests.sh: Add better reporting when tests
	  fail to report coverage, and allow for files with no executable
	  code.

2009-07-05  Alistair Riddoch  <alriddoch@googlemail.com>

	* client/Py_CreatorClient.cpp, client/client.cpp,
	  rulesets/Py_BBox.cpp, rulesets/Py_Location.cpp, rulesets/Py_Map.cpp,
	  rulesets/My_Message.cpp, rulesets/My_Mind.cpp,
	  rulesets/Py_Operation.cpp, rulesets/Py_Operation.h,
	  rulesets/Py_Oplist.cpp, rulesets/Py_Point3D.cpp,
	  rulesets/Py_Property.cpp, rulesets/Py_Quaternion.cpp,
	  rulesets/Py_RootEntity.cpp, rulesets/Py_Task.cpp,
	  rulesets/Py_TerrainProperty.cpp, rulesets/Py_Thing.cpp,
	  rulesets/Py_Vector3D.cpp, rulesets/Py_World.cpp,
	  rulesets/Py_WorldTime.cpp, rulesets/PythonEntityScript.cpp,
	  rulesets/Python_API.h, tests/Py_CreatorClienttest.cpp:
	  Always check for NULL when creating new Python objects.
	  Clean up bindings to make sure all conform to modern Python
	  API conventions, and remove obsolete commented out allocation
	  code all round.

2009-07-02  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/Python_API.cpp, rulesets/Python_Script_Utils.h:
	  Add generic functions for loading python modules and classes.

	* server/TaskFactory.cpp, server/TaskFactory.h,
	  server/EntityBuilder.cpp: Amend the convention for task script
	  module names to match that for entity scripts.

	* data/tasks.xml: Update all the tasks to the new convention.

	* rulesets/ArithmeticFactory.cpp, rulesets/ArithmeticFactory.h,
	  server/ScriptFactory.cpp, server/TaskFactory.cpp:
	  Use the new generic functions for loading Python modules and
	  classes.

	* rulesets/Py_Operation.cpp: Re-implement accessing arguments as
	  a sequence so the index is used directly, being much more efficient.

	* rulesets/Py_Mind.cpp, rulesets/Py_Task.cpp: Simplify method and
	  attribute lookup by using the method table entry of the type
	  structure.

2009-07-02  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/TaskFactory.cpp: Convert an assert that could cause a crash
	  into a runtime check.

	* client/Py_CreatorClient.cpp, rulesets/Py_Location.cpp,
	  rulesets/Py_Mind.cpp, rulesets/Py_Task.cpp, rulesets/Py_Thing.cpp,
	  rulesets/Py_Thing.h, rulesets/PythonArithmeticScript.cpp,
	  rulesets/PythonEntityScript.cpp, rulesets/PythonEntityScript.h,
	  rulesets/PythonScript.cpp, rulesets/PythonScript.h,
	  rulesets/Python_API.cpp: Modify all types used as wrappers for
	  core objects which are also extended by scripts into base classes
	  so both functions can be handled by a single Python object
	  inheriting from a class implemented in the core.

	* server/TaskFactory.cpp, server/ScriptFactory.cpp: Modify the
	  reference counting when setting up wrappers and extension scripts
	  so they work more consistently and simply.

	* Convert all Python scripts over to the new extension model.

2009-06-29  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Fix a typo in the debug output.

2009-06-28  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/BaseMind.h: Add a missing word to doc comments.

	* rulesets/Character.h: Add an accessor exposing the task pointer
	  so a property can track it.

	* rulesets/TasksProperty.cpp, rulesets/TasksProperty.h: Add a new
	  property to handle exposing and updating task data.

	* rulesets/Character.cpp: Update task handling to use the task
	  property.

	* rulesets/Entity.h: Update property access templates so that
	  when a new property is added it is installed and applied
	  correctly.

	* rulesets/basic/mind/NPCMind.py: Correct some doc strings.

2009-06-16  Alistair Riddoch  <alriddoch@googlemail.com>

	* server/Account.cpp: Add detection and filtering of client
	  operations that will modify task attributes.

2009-06-10  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_Location.cpp: Allow argument passed to Location
	  binding constructor to be any kind of Entity.

2009-06-09  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/custom.cpp, common/operations.cpp: Add new operations
	  for thought and goal_info used heavily by the AI code.

	* rulesets/BaseMind.cpp: Add a check to avoid a crash caused by
	  an invalid smart pointer.

	* rulesets/Entity.cpp: Remove an unnecessary dynamic cast.

	* rulesets/Entity.h: Add a check to the ostream output operator
	  for Location so an invalid location does not crash.

	* rulesets/MemMap.h: Make all private members protected so they
	  can be exposed for testing.

	* rulesets/PythonEntityScript.h, rulesets/PythonScript.h,
	  rulesets/PythonWrapper.h, rulesets/Script.h: Add a doxygen group
	  for these related classes.

	* rulesets/Py_BBox.cpp, rulesets/Py_Location.cpp, rulesets/Py_Map.cpp,
	  rulesets/Py_Message.cpp, rulesets/Py_Message.h,
	  rulesets/Py_Mind.cpp, rulesets/Py_Object.cpp, rulesets/Py_Object.h,
	  rulesets/Py_Operation.cpp, rulesets/Py_Oplist.cpp,
	  rulesets/Py_Point3D.cpp, rulesets/Py_Quaternion.cpp,
	  rulesets/Py_RootEntity.cpp, rulesets/Py_Task.cpp,
	  rulesets/Py_TerrainProperty.cpp, rulesets/Py_Thing.cpp,
	  rulesets/Py_Thing.h, rulesets/Py_Vector3D.cpp, rulesets/Py_World.cpp,
	  rulesets/Py_WorldTime.cpp, client/Py_CreatorClient.cpp:
	  Rework all the python bindings to conform with the modern ABI
	  since Python 2.2. Rationalise type and file names.

	* Update all python scripts to use modified API exposed by the
	  server core.

	* tests/DateTimetest.cpp: Fix a cstdio include missing from this
	  test.

	* tests/AtlasPropertiestest.cpp, tests/BaseMindtest.cpp,
	  tests/Domaintest.cpp, tests/MemEntitytest.cpp,
	  tests/MemMaptest.cpp, tests/Movementtest.cpp,
	  tests/Pedestriantest.cpp, tests/PropertyCoverage.cpp:
	  Add coverage tests for a number of classes.

	* tests/Py_BBoxtest.cpp, tests/Py_Locationtest.cpp,
	  tests/Py_Maptest.cpp, tests/Py_Messagetest.cpp,
	  tests/Py_Mindtest.cpp, tests/Py_Operationtest.cpp,
	  tests/Py_Oplisttest.cpp, tests/Py_Point3Dtest.cpp,
	  tests/Py_Quaterniontest.cpp, tests/Py_RootEntitytest.cpp,
	  tests/Py_Tasktest.cpp, tests/Py_Thingtest.cpp,
	  tests/Py_Vector3Dtest.cpp, tests/Py_Worldtest.cpp,
	  tests/Py_WorldTimetest.cpp, tests/Python_APItest.cpp:
	  Add coverage tests to as much of the python bindings as possible,
	  to verify while refactoring as documented above.

2009-05-14  Alistair Riddoch  <alriddoch@googlemail.com>

	* rulesets/TerrainProperty.cpp: Clean up segment calculation and
	  add assertion checks.

2009-05-14  Alistair Riddoch  <alriddoch@googlemail.com>

	* common/BaseWorld.h: Remove height constraint functionality.

	* common/Property.h, common/Property.cpp, rulesets/AreaProperty.h,
	  rulesets/BBoxProperty.cpp, rulsets/CalendarProperty.cpp,
	  rulesets/CalendarProperty.h, rulesets/EntityProperty.cpp,
	  rulesets/InternalProperties.cpp, rulesets/LineProperty.cpp,
	  rulesets/OutfitProperty.cpp, SolidProperty.cpp,
	  rulesets/StatisticsProperty.cpp, rulesets/TerrainModProperty.cpp,
	  server/ExternalProperty.cpp: Simplify the base class constructor
	  as default values flags are almost never specified.

	* rulesets/Domain.cpp, rulesets/Domain.h: Add a new singleton class
	  to handle computation relating to movement in a coordinate space.

	* rulesets/Entity.h, rulesets/Entity.cpp: Add a member function to
	  get the movement domain for an Entity.

	* rulesets/Pedestrian.cpp, rulesets/Thing.cpp, server/WorldRouter.cpp,
	  server/WorldRouter.h: Call the Domain to handle height constraint.

	* TerrainProperty.cpp, TerrainProperty.h: Move storing the terrain
	  into this property so the World code can be cleaner.

	* rulesets/World.cpp rulesets/World.h: Clear out all the terrain code
	  and forward calls relating to it to the TerrainProperty.

	* tests: Update tests to handle Property API changes. Use World for
	  the tlve when exercising entities.

2009-05-11  Alistair Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.20

2009-05-11  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/TerrainMod_impl.h: Fix header guards.

	* common/Database.cpp: Remove debug output for maintenence queries.

	* common/globals.cpp: Remove debug output when looking for settings
	  in the config.

	* server/ExternalMind.cpp: Remove debug output when removing an
	  unused PC from the world.

	* rulesets/basic/mind/NPCMind.py: Jitter AI ticks so things look more
	  natural.

	* tests/*: Do a major update to coverage of the tests.

	* modules/DateTime.cpp: Fix the format of date string output.

	* common/Monitors.cpp, common/Monitors.h: Add dustructor to clean up
	  monitors.

	* common/FormattedXMLWriter.cpp: Fix an exception thrown when the
	  Atlas data is odd.

	* rulesets/Motion.cpp: Add an assert to check for the collision flag.
	  Assert that position and velocity are valid when resolving
	  collisions.

	* rulesets/LineProperty.h: Fix a missing header dependency.

	* rulesets/StatisticsProperty.cpp: Return so there is no crash if
	  finding the script fails.

	* common/globals.h, common/globals.cpp, modules/DateTime.cpp:
	  Add constants for default calender, and remove the depency
	  on DateTime from globals.

2009-04-09  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.cpp: Explicitly instantiate a template to work
	  around compiler weirdness. Only give an error about invalid
	  options if they are on the command line.

2009-04-08  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.cpp, common/globals.h, client/client.cpp,
	  server/ServerRouting.cpp, server/ServerRouting.h,
	  server/server.cpp, tools/cyaddrules.cpp:
	  Move a bunch more options to the new mechanism.

2009-04-08  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.cpp, common/globals.h: Add necessary support for
	  special socket address config options, by adding support
	  for code to be called when an option is missing, and postprocessing
	  on the option data.

	* common/sockets.h, common/client_socket.cpp: Add new files for
	  socket config data moved from globals.

	* client/ObserverClient.cpp, server/CommMDNSPublisher.cpp,
	  server/server.cpp, tools/AdminClient.cpp, tools/AdminClient.h,
	  tools/cyaddrules.cpp, tools/cycmd.cpp, tools/cypython.cpp:
	  Update the rest of the code to use the new header.

2009-04-08  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommServer.cpp, server/CommServer.h: Create a setup
	  function and move initialisation that can fail into there from
	  the constructor.

	* server/server.cpp: Use the CommServer setup function, and fail
	  earlier if it doesn't work.

2009-04-07  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.cpp, common/globals.h, server/CommPeer.cpp,
	  server/CommPeer.h, server/server.cpp: Remove the old peer port
	  setting, and handle it via the new mechanism.

2009-04-07  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.cpp, common/globals.h: Add infrastructure for
	  embedding config options in the code rather than having a
	  central place for them.

	* server/server.cpp: Use the new option system for the http port.

2009-04-07  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Update the test link objects to match name
	  changes.

2009-03-24  Al Riddoch  <alriddoch@googlemail.com>

	* server/Account.cpp, server/Admin.h, server/Connection.cpp,
	  server/EntityBuilder.cpp, server/Persistence.cpp,
	  server/Persistence.h, server/server.cpp, server/slave.cpp:
	  Correct the spelling of persistence.

2009-03-23  Al Riddoch  <alriddoch@googlemail.com>

	* configure.ac: Increment version to 0.5.19 for release.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.19

2009-03-22  Al Riddoch  <alriddoch@googlemail.com>

	* common/FormattedXMLWriter.h, rulesets/HandlerProperty_impl.h,
	  rulesets/MultiHandlerProperty_impl.h, server/CommClientFactory.h:
	  Add missing header guards.

2009-03-22  Al Riddoch  <alriddoch@googlemail.com>

	* common/Monitors.h, common/types.h, rulesets/SolidProperty.h:
	  Manually fix up header guards which don't match fully.

2009-03-22  Al Riddoch  <alriddoch@googlemail.com>

	* aiclient/ClientAccount.h, aiclient/ClientConnection.h,
	  aiclient/client.h, client/ClientConnection.h,
	  client/Py_CreatorClient.h, common/Database.h, modules/DateTime.h,
	  physics/BBox.h, rulesets/BBoxProperty.h, rulesets/Py_BBox.h,
	  rulesets/Py_Point3D.h, rulesets/Py_RootEntity.h,
	  rulesets/Py_Vector3D.h, rulesets/Py_WorldTime.h,
	  rulesets/PythonEntityScript.h, rulesets/TerrainModProperty.h,
	  server/server.h, tests/Fell.h, tests/TestPropertyManager.h:
	  Use scripts/check_header_guards.sh to correct the header guards
	  on many files.

2009-03-22  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/PythonEntityScript.cpp, rulesets/PythonEntityScript.h:
	  Rename PythingThingScript files to match the class.

	* rulesets/Python_API.cpp, server/ScriptFactory.cpp,
	  server/TaskFactory.cpp: Update everything to take account of the
	  file rename.

2009-03-22  Al Riddoch  <alriddoch@googlemail.com>

	* common/Router.cpp, common/Router.h: Rename files from Identified
	  to Router to match the class name.

	* rulesets/LocatedEntity.h, server/Account.h, server/Connection.h,
	  server/ExternalMind.h, server/ExternalProperty.cpp,
	  server/Master.h, server/Peer.h, server/ServerRouting.h,
	  server/SlaveClientConnection.h: Update everything to take account
	  of the file rename.

2009-03-22  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityBuilder.cpp, server/EntityBuilder.h,
	  server/EntityFactory.cpp, server/EntityFactory.h,
	  server/EntityFactory_impl.h: Rename ThingFactory to EntityFactory
	  and rename the file from the archaic PersistantThingFactory.

	* tests/EntityBuildertest.cpp: Update the tests.

2009-03-20  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cydb.cpp: Add support for changing account passwords.

2009-03-20  Al Riddoch  <alriddoch@googlemail.com>

	* common/Inheritance.cpp, common/Inheritance.h: Rename these files
	  to match the class name.

	* common/AccountBase.cpp, common/AccountBase.h,
	  common/Inheritance.cpp, common/custom.cpp,
	  rulesets/BaseMind.cpp, rulesets/MemMap.cpp,
	  rulesets/Python_API.cpp, rulesets/World.cpp,
	  server/Account.cpp, server/Admin.cpp,
	  server/Connection.cpp, server/EntityBuilder.cpp,
	  server/UpdateTester.cpp, server/WorldRouter.cpp,
	  server/server.cpp, server/slave.cpp,
	  tests/EntityBuildertest.cpp, tests/PropertyExerciser.cpp,
	  tests/inheritancetest.cpp: Use the new name for the Inheritance
	  header.

2009-03-20  Al Riddoch  <alriddoch@googlemail.com>

	* tests/accountbasetest.cpp: Update includes of AccountBase.h to the
	  correct case.

2009-03-20  Al Riddoch  <alriddoch@googlemail.com>

	* common/AccountBase.h, common/AccountBase.cpp: Rename these files
	  to match the class name.

	* tools/cydb.cpp, tools/cypasswd.cpp: Use the new name for the
	  AccountBase header.

2009-03-19  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cydb.cpp: Add tools to delete accounts and rules, and to list
	  and modify user accounts.

2009-03-18  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cydb.cpp: Clean up the command system mechanism to be
	  fully flexible and generic. Implement the command to purge
	  world data.

2009-03-14  Al Riddoch  <alriddoch@googlemail.com>

	* tests/EntityBuildertest.cpp, tests/PropertyFlagtest.cpp,
	  tests/Makefile.am: Update tests for renamed EntityBuilder filenames.

2009-03-12  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityBuilder.h, server/EntityBuilder.cpp: Rename the
	  files to match the class rename that happened some time ago.

	* server/Admin.cpp, server/PersistantThingFactory.cpp,
	  server/server.cpp, server/slave.cpp, server/StorageManager.cpp,
	  server/WorldRouter.cpp: Correct includes of EntityBuilder.h.

	* scripts/check_class_names.sh: Add a script which checks that class
	  names match the names of the header file they are in.

2009-03-11  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cydb.cpp: Fill out the subsystem mechanism.

2009-03-10  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/extract_revision.sh: A new script to extract a build ID
	  revision number differently depending on what source control
	  is being used.

	* Makefile.am: Add the new script to dist.

	* server/Makefile.am: Use the new script, and add the generated
	  buildid.cpp to the distributed sources.

2009-03-04  Al Riddoch  <alriddoch@googlemail.com>

	* common/Property.h: Add flag for class properties which must be
	  converted to instance properties on installation as they require
	  per-entity state.

2009-02-25  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/ArithmeticScript.h, rulesets/PythonArithmeticScript.cpp,
	  rulesets/PythonArithmeticScript.h: Change set() method to return
	  void as there is nothing to report.

2009-02-25  Al Riddoch  <alriddoch@googlemail.com>

	* cyphesis.spec.in: Fix the included docs to be consistent with other
	  packages.

2009-02-21  Al Riddoch  <alriddoch@googlemail.com>

	* client/BaseClient.h, client/ClientConnection.cpp,
	  client/ClientConnection.h, client/ObserverClient.cpp,
	  client/client.cpp: Clean up the way sockets are handled and errors
	  are reported.

2009-02-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Motion.cpp, rulesets/Motion.h: Remove the support for
	  hierarchical location model from the collision system. From
	  now on there will be a flat movement space.

2009-02-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Movement.h: Remove commented out obsolete code. Add
	  documentation comments.

2009-02-09  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cypython.cpp: Add history to the readline functionality.

2009-02-09  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cypython.cpp: Ensure varconf types are fully defined when
	  the object gets deleted.

2009-02-09  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cypython.cpp: Add a tool to inject python lines into the
	  server.

2009-02-09  Al Riddoch  <alriddoch@googlemail.com>

	* server/server.cpp: Switch the python listener over to using a
	  unix socket using the configuration setting.

2009-02-09  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/PythonContext.cpp: Improve error reporting of the
	  python interpreter return status.

2009-02-09  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.h, common/globals.cpp: Add config settings for the
	  python socket.

2009-02-06  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cycmd.cpp: Get rid of crazy template code and replace with
	  straightforward generic client code with two connect methods.

2009-02-02  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Fix the linkage of tests affected new
	  classes added to the tree recently.

2009-02-02  Al Riddoch  <alriddoch@googlemail.com>

	* common/Identified.cpp, common/Identified.h:
	  Flatten down the base classes into one called Router.

	* client/CharacterClient.cpp, client/CreatorClient.cpp,
	  rulesets/BaseMind.cpp, rulesets/Character.cpp,
	  rulesets/Creator.cpp, rulesets/Entity.cpp,
	  rulesets/LocatedEntity.cpp, rulesets/MemEntity.cpp,
	  rulesets/Plant.cpp, rulesets/Stackable.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp,
	  server/Account.cpp, server/Admin.cpp,
	  server/Connection.cpp, server/ExternalMind.cpp,
	  server/Lobby.cpp, server/Master.cpp,
	  server/Peer.cpp, server/Player.cpp,
	  server/ServerRouting.cpp, server/SlaveClientConnection.cpp,
	  server/TrustedConnection.cpp, tests/LocatedEntitytest.cpp,
	  tests/ThingupdatePropertiestest.cpp: Update all the operation
	  routing classes to use the modified base class correctly.

2009-01-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Python_API.cpp, rulesets/Python_API.h: Remove the
	  now obsolete unused function for running trivial Python
	  command line.

2009-01-31  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommPythonClient.cpp, server/CommPythonClient.h:
	  Modify the client connection to use the new Python context class.

2009-01-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/PythonContext.cpp, rulesets/PythonContext.h,
	  rulesets/Makefile.am: Add new class to encapsulate a command
	  line context for Python.

2009-01-30  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Python_API.cpp, rulesets/Python_API.h: Hack in a quick
	  function for executing python commands.

	* server/CommPythonClient.cpp: Pass input from the client straight
	  into the python interpretter and see what happens.

2009-01-30  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommClientFactory.cpp, server/CommClientFactory.h,
	  server/server.cpp: Add in test support for the python client.

2009-01-30  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommPythonClient.cpp, server/CommPythonClient.h:
	  Stub class to handle python commands over a socket connection.

2009-01-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommHttpClient.h: Correct the description in the doc
	  comments.

2009-01-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/Makefile.am: Update the optional cyslave build.

2009-01-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommClient.cpp, server/CommClient.h,
	  server/CommHttpClient.cpp, server/CommHttpClient.h:
	  Convert two stream classes to use the stream base class.

2009-01-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommStreamClient.cpp, server/CommStreamClient.h:
	  New base class for client socket objects using skstream tcp
	  streams.

2009-01-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommHttpListener.cpp, server/CommHttpListener.h,
	  server/CommListener.cpp, server/CommListener.h,
	  server/CommSlaveListener.cpp, server/CommSlaveListener.h:
	  Remove a bunch of unused listener classes made obsolete by
	  moving their functionality into the base class.

2009-01-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommClientFactory.cpp, server/CommClientFactory.h: Add a
	  new factory for http client objects.

	* server/CommStreamListener.cpp, server/CommStreamListener.h:
	  Move the client factory behavior into this base class
	  as all listners will now be using it.

	* server/CommTCPListener.cpp, server/CommTCPListener.h,
	  server/CommUnixListener.cpp, server/CommUnixListener.h:
	  Require a client factory reference and pass to the base class
	  which uses it.

	* server/Makefile.am: Remove obsolete special purpose listeners.

	* server/server.cpp: Use straight TCP listeners for everything
	  as no special purpose listener functionality is required any more.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommListener.cpp, server/CommListener.h,
	  server/server.cpp: Rename class to CommAtlasListener.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommLocalClient.cpp, server/CommLocalClient.h,
	  server/CommPeerListener.cpp, server/CommPeerListener.h,
	  server/CommRemoteClient.cpp, server/CommRemoteClient.h,
	  server/CommSlaveClient.cpp, server/CommSlaveClient.h:
	  Delete obsolete removed code.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommMaster.cpp, server/CommMaster.h,
	  server/Makefile.am, server/Master.cpp, server/Master.h,
	  server/slave.cpp: Clean up the bitrot in the optional cyslave
	  target.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommLocalClient.cpp, server/CommLocalClient.h,
	  server/CommRemoteClient.cpp, server/CommRemoteClient.h,
	  server/CommSlaveClient.cpp, server/CommSlaveClient.h:
	  Mark these files as removed form the build.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommPeer.h, server/CommPeer.cpp: Re-factor CommPeer to
	  only be used for initiating peer connections.

	* server/Admin.cpp: Use the modified CommPeer constructor.

	* server/CommClient.h, server/CommClient.cpp: Make the connection
	  a pointer rather than a reference, and pass it in during setup.

	* server/CommClientFactory.h, server/CommClientFactory.cpp: Re-factor
	  the commclient factory to take connection type as a template param,
	  and create the client and connection objects separately.

	* server/server.cpp: Use the modified CommClientFactory parameter.

	* server/Makefile.am: Remove the different kinds of client class
	  from the build.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommSlaveClient.cpp, server/SlaveClientConnection.cpp,
	  server/SlaveClientConnection.h: Re-factor the constructor interface
	  to be consistent.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommLocalClient.h, server/CommRemoteClient.h,
	  server/CommSlaveClient.h: Clean up the interface formatting so
	  these class look the same.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommLocalClient.cpp, server/CommLocalClient.h: Fix the
	  constructor interface to match that used by the factory.

	* server/CommClientFactory.cpp: Add support for CommLocalClient.

	* server/CommUnixListener.cpp, server/CommUnixListener.h:
	  Convert the unix listener to use the CommClientFactory to remove
	  duplicated code.

	* server/server.cpp: Use the new style of listener API on the unix
	  socket.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommClientFactory.cpp: Add support for CommSlaveClient.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommListener.cpp, server/CommListener.h: Refactor from
	  a template to a regular class that uses the factories.

	* server/server.cpp: Fix usage of CommListener.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommSlaveClient.h, server/CommSlaveClient.cpp,
	  server/Makefile.am: Fix the constructor interface to match
	  that of other client socket classes.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/SlaveClientConnection.cpp, server/SlaveClientConnection.h:
	  Fix to build with changes to the parent classes.

2009-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommClientFactory.cpp, server/CommClientFactory.h,
	  server/Makefile.am: A new experimental way to create socket objects.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommListener.h, server/CommListener.cpp: Make the
	  Atlas listener a template for handling the various types
	  of socket to use.

	* server/server.cpp: Use the CommListener template correctly.

	* server/CommPeerListener.cpp, server/CommPeerListener.h,
	  server/Makefile.am: Remove the obsolete explicit peer listener
	  from the build.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommTCPListener.h, server/CommTCPListener.cpp,
	  server/CommListener.h, server/CommListener.cpp: Move the generic
	  TCP accept code into the base class.

	* server/CommHttpListener.h, server/CommHttpListener.cpp: Use the
	  simpler generic TCP listener rather than overriding the class
	  designed for listening to Atlas.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommUnixListener.h: accept() should be virtual.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommStreamListener.cpp, server/CommStreamListener.h:
	  Remove tcp specific code forcing other classes to use
	  the tcp specific class.

	* server/CommListener.cpp, server/CommListener.h: Inherit from the
	  tcp base class.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommUnixListener.cpp, server/CommUnixListener.h,
	  server/Makefile.am: Use the stream base class for this, to
	  re-use common code.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommTCPListener.cpp, server/CommTCPListener.h: Add another
	  new base class with the TCP specific listener code in.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommListener.cpp, server/CommListener.h: Adapt the Atlas
	  client listener code to use the new base class for listeners.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommStreamListener.cpp, server/CommStreamListener.h:
	  Add a new more abstract base class for listen sockets.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* common/log.cpp: Modify the log time stamps to be a single column
	  in ISO format.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* autopackage/default.apspec.in: Expand the full name used in the
	  autopackage.

2009-01-27  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/goals/humanoid/mason.py: Fix a potential issue
	  with goals not having full dependencies imported.

2009-01-15  Al Riddoch  <alriddoch@googlemail.com>

	* server/server.cpp: Add commented out code to set up the
	  UpdateTester.

2009-01-15  Al Riddoch  <alriddoch@googlemail.com>

	* server/Makefile.am, server/UpdateTester.cpp, server/UpdateTester.h:
	  Add a generic class for injecting test operations, and set it up
	  to test type updates.

2009-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* physics/BBox.cpp, rulesets/BBoxProperty.h, rulesets/Py_BBox.h:
	  Include more wfmath headers as it makes better use of forward
	  declarations.

2009-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* physics/BBox.h: Use wfmath forward declarations.

	* modules/Location.h, physics/BBox.cpp, rulesets/BBoxProperty.h,
	  rulesets/Py_BBox.h: Include axisbox.h definition where required.

2009-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* physics/Vector3D.h: Use sqrtf to ensure efficient use of floats.

2009-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Fix linking the tests to get functions which
	  are no longer inlined.

2009-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* physics/Quaternion.h: Use forward declarations.

	* physics/Quaternion.cpp, rulesets/Py_Quaternion.h: Include
	  quaternion definition where required.

2009-01-11  Al Riddoch  <alriddoch@googlemail.com>

	* physics/Vector3D.h, physics/Vector3D.cpp: Move a bunch of inline
	  functions in the header to be non-inline in the body. Use
	  the forward declaraions in wfmath/const.h instead of having to
	  include the full headers.

	* rulesets/Motion.cpp, rulesets/Motion.h, rulesets/Movement.h,
	  rulesets/Py_Point3D.h, rulesets/Py_Vector3D.h: Include wfmath
	  headers as required.

2009-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Motion.cpp: Add assertions for consistency of the entity
	  we are colliding with before resolving the collision.

2009-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Motion.cpp: Move the assertions before the debug output,
	  as otherwise the asserts won't catch things that could make the
	  debug code crash.

2009-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/MemMap.cpp: Add an assert as getAdd() is supposed to
	  always return non-zero.

2009-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp: Add an assert to make sure entity is
	  part of an intact container tree.

2009-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* server/ExternalMind.cpp: Extend the time before nuking player
	  characters to an hour.

2008-12-16  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/TransientProperty.cpp: Remove some debug output.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/define_world.py: Make everything with goals
	  transient for now, so it can be replaced by a run of cyclient
	  after restore from database.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/define_world.py, rulesets/mason/tests.py: Clean up
	  the imports, and add the correct copyright notices.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/benchmarks.py: Add a client script which exercises
	  entity creation, destruction and all connected subsystems.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* client/Py_CreatorClient.cpp, client/CreatorClient.h,
	  client/CreatorClient.cpp, rulesets/basic/editor.py: Make a delete
	  method available to the client editor interface.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/define_world.py: Add checks for NPCs and their
	  owner structures before adding them. This script can now be run
	  repeatedly without cluttering the world.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/TransientProperty.cpp: If the transient property has
	  a negative value, don't expire the object, just leave it is
	  ephemeral.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* client/CreatorClient.cpp: Avoid an error report when there
	  is an Unseen response to a Look.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/define_world.py: Clean up and restructure more.
	  Add checks to ensure fixed features only get added once.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* client/CreatorClient.cpp: Include the type when reporting things
	  the client has searched for on the server, making client output
	  clearer.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/define_world.py, rulesets/mason/tests.py: Move all
	  the test client functions into their own file.

2008-12-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/define_world.py: Clean up and modularise the setup,
	  moving the parts that are made less necessary by persistence
	  dependent on the current world state.

2008-12-14  Al Riddoch  <alriddoch@googlemail.com>

	* client/CreatorClient.cpp, client/Py_CreatorClient.cpp: Fix
	  look_for so that it can fail safely.

2008-12-14  Al Riddoch  <alriddoch@googlemail.com>

	* server/ExternalMind.cpp, server/ExternalMind.h: Operations have
	  to be injected directly into the world, not returned, or it
	  won't work on non-prived characters. Add a check that removes
	  characters completely after they've been unused for a while, to
	  cut down server clogging.

2008-12-14  Al Riddoch  <alriddoch@googlemail.com>

	* server/ExternalMind.cpp, server/ExternalMind.h: Purge the inventory
	  of deleted characters when they are deleted by disconnection.

2008-12-11  Al Riddoch  <alriddoch@googlemail.com>

	* server/server.cpp: Improve the message on a security check failure.

2008-12-10  Al Riddoch  <alriddoch@googlemail.com>

	* server/ExternalMind.h, server/ExternalMind.cpp: Improve the
	  interface to make it cleaner, and add a way to track the time
	  at which the character lost it's connection to the client.

	* server/Connection.cpp: Change to use the cleaner ExternalMind
	  interface.

2008-12-10  Al Riddoch  <alriddoch@googlemail.com>

	* server/ExternalMind.h: Make all the member variables protected,
	  and create an API to expose as needed.

	* server/Connection.cpp: Update the code to use the interface to
	  interact with ExternalMind.

2008-12-10  Al Riddoch  <alriddoch@googlemail.com>

	* server/Connection.cpp: Remove some of the debug output.

2008-12-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Creator.h, rulesets/Creator.cpp: Remove the special
	  case for sending to the mind of Creator, as the difference
	  is now handled by ExternalMind itself in a more general way.

2008-12-10  Al Riddoch  <alriddoch@googlemail.com>

	* common/Identified.cpp, common/Identified.h, rulesets/Character.h,
	  rulesets/LocatedEntity.h, server/Account.h, server/Admin.cpp,
	  server/CommClient.cpp, server/CommClient.h, server/Connection.cpp,
	  server/Connection.h, server/ExternalMind.h,
	  server/ExternalProperty.cpp, server/ExternalProperty.h,
	  server/Lobby.h, server/Master.h, server/Peer.h,
	  server/ServerRouting.h, server/SlaveClientConnection.h:
	  Rename IdentifiedRouter to Router as it's the base class
	  for pretty much all routers.

2008-12-09  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Creator.cpp: Remove code for removing Creators once
	  they've been disconnected, and simply mark them as ephemeral.

	* server/ExternalMind.h, server/ExternalMind.cpp: Change
	  the external mind so it stores a reference to the character it
	  is the mind for, and stores a pointer to the connection rather
	  than a reference so it can be nulled when the connection is
	  removed on unsubscribed. Implement removing an ephemeral avatar
	  character on disconnection.

	* server/Connection.cpp: Re-work the connection code to deal with
	  a character still having an external mind on connection, and not
	  removing the external mind at disconnection.

2008-12-07  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cydb.cpp: Add code for handle db connection.

2008-12-07  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/NPCMind.py: Remove a few chunks of unused code.
	  Clean up and simplify the logic when dealing with converting plain
	  talk ops into structured interlinguish. Add some doc strings and
	  comments.

2008-12-07  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_Operation.cpp: Don't create a message list when
	  adding an operation to none, just return the operation. This
	  should result in a small performance improvement.

2008-12-07  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Character.h: Remove an unused flag
	  used to signal a character is dead.

2008-12-01  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cydb.cpp: Add the ground work for a new tool to perform
	  various admin tasks on the database.

2008-11-30  Al Riddoch  <alriddoch@googlemail.com>

	* configure.ac: Increment version to 0.5.18 for release.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.18

2008-11-30  Al Riddoch  <alriddoch@googlemail.com>

	* server/Account.cpp: Don't give names to items in the default
	  inventory.

	* rulesets/mason/world/objects/buildings/House3.py: Don't give
	  names to the invisible wall objects.

2008-11-30  Al Riddoch  <alriddoch@googlemail.com>

	* tests/AllPropertytest.cpp: Statistics property no longer needs
	  to be connected to a character.

	* tests/Makefile.am: Remove deleted object files from server.

2008-11-30  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/PythonArithmeticScript.cpp,
	  rulesets/StatisticsProperty.cpp: Remove the debug output.

	* rulesets/mason/world/statistics/Statistics.py: Get rid of the
	  useless del property, and clean up debug output.

2008-11-30  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/world/statistics/Statistics.py: Make this a new
	  style class so properties work right, and implement it all
	  as properties.


	* rulesets/StatisticsProperty.cpp: Move the setup of the script
	  instance into apply rather than install, otherwise it doesn't get
	  called in the right place.

	* rulesets/ArithmeticScript.h: Add a set method to the interface.

	* rulesets/PythonArithmeticScript.cpp,
	  rulesets/PythonArithmeticScript.h: Implement getting using
	  PyObject_GenericGetAttr() as it works. Add a completely new set
	  function.

	* rulesets/Entity.cpp: When a new property is installed it needs
	  to be applied.

2008-11-30  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Makefile.am: Add ArithmeticFactory to the build in this
	  directory.

	* data/characters.xml: Add test statistics to the class.

	* rulesets/StatisticsProperty.cpp, rulesets/StatisticsProperty.h:
	  Add an install method which creates a script instance.

	* rulesets/mason/world/statistics/Statistics.py: Make the reference
	  to the owner optional.

	* server/CorePropertyManager.cpp: Add "statistics" to the factory.

	* server/Makefile.am, server/ArithmeticFactory.cpp,
	  server/ArithmeticFactory.h: Remove unused ArithmeticFactory code
	  from the build.

2008-11-30  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.h: Remove obsolete forward declaration.

2008-11-29  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/ArithmeticFactory.h, rulesets/ArithmeticFactory.cpp:
	  Fix up ArithmeticFactory code to be in rulesets, and allow
	  for the case where there is no owner for the script.

2008-11-29  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Character.h: Remove all traces
	  of the hard coded statistics property from Character.

	* rulesets/Py_Property.cpp: Don't use Py_StatisticsProperty as the
	  default wrapper for a statistics property because it will no
	  longer work this way.

	* rulesets/Python_API.cpp: Remove the setup for the Statistics
	  wrapper.

	* rulesets/StatisticsProperty.cpp, rulesets/StatisticsProperty.h:
	  Change the footprint of this class so it is no longer hooked
	  into part of the Character class, and instead handles looking
	  up values from the script directly, and owns the script itself.

	* server/ArithmeticFactory.cpp, server/ArithmeticFactory.h,
	  server/EntityFactory.cpp, server/EntityFactory.h,
	  server/PersistantThingFactory.cpp: Remove setup of hard coded
	  statistics property.

	* rulesets/Statistics.h, rulesets/Statistics.cpp,
	  rulesets/Py_Statistics.h, rulesets/Py_Statistics.cpp,
	  rulesets/Makefile.am: Remove clases that are no longer used.

2008-11-24  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Remove the hard coded property for wielding
	  as it will always be handled dynamically as required.

2008-11-21  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Use std::strings rather the literals for
	  property names.

2008-11-20  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Hook restored entities to the update
	  functions, or they never get subsequent updates.

2008-11-18  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Remove some debug output, improve
	  error checking and reporting.

2008-11-18  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Disable purging the database on startup.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Plant.cpp: Ensure a useful default value is in place
	  for status.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Fill gaps so world is now completely
	  restored from database. Currently incredibly verbose and buggy.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Add some improved debug messages, and
	  set the value of restored properties.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/server.cpp: Add the call to the storage system restoring
	  the world.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/World.cpp: Improve error reporting.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Attempt to recontruct the entities
	  and properties being restored.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Clean up error messages using more
	  concise types.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* modules/Location.cpp: Clean up data types.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* modules/Location.h, modules/Location.cpp: Add a new function for
	  reading location data from an Atlas message.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Dump more debug info about data from
	  the database.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Dump database results to stdout.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp, server/StorageManager.h: Sketch out
	  the algorithm for reading entity data from the database.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp, common/Database.h: Implement queries required
	  to read entity and properties from the database.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/server.cpp: Use the variable for the default instance
	  name.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.h: Correct a FIXME about leaking a property
	  when requiring one of a given type.

	* tests/PropertyFlagtest.cpp: Add a note for test coverage that
	  will be required.

2008-11-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Fix referrential integrity now that inherited
	  tables are not being used. Removes FIXMEs relating to that and
	  the database maintenance code which have now been fixed.

2008-11-16  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Clean up the formatting of a number of query
	  strings.

2008-11-16  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Re-enable referential integrity on relational
	  tables. Clean up the query generation code.

	* server/Persistance.cpp: Correct the table names used for the
	  relation used to store character ownership.

2008-11-16  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Remove the commented out code for handling
	  tables for the obsolete removed persistence system.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* common/const.h: I guess the name length limit for identifiers
	  should be unsigned.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Use the name length constant in checks.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* common/const.h: Add a constant for the name length limit of
	  rule IDs and property names.

	* common/Database.cpp: Use the name length constant for database
	  fields that will store the name.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Check class names do not violate a
	  32 character limit before installing them, so they never get
	  as far as the database limit.

	* common/Database.cpp: Modify the rules table so it limits
	  the ID to the right size.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/BaseMind.cpp, rulesets/Character.cpp,
	  rulesets/EntityProperty.cpp, rulesets/Stackable.cpp:
	  Remove a bunch of stray debug output.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>


	* common/Database.cpp: Remove some left over debug output.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Remove some debug output.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Change database column types to varchar to make
	  them cheaper to update.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Actually update the location information,
	  rather than just pretending.

2008-11-13  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Handle things correctly if scheduling an update
	  or insert query while the database is offline. Just ignore it and
	  keep the query queued.

2008-11-11  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Back off a change which was intended
	  to suppress a warning, but did not work.

2008-11-11  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Clean up some unused declarations and
	  headers.

	* rulesets/Plant.cpp, rulesets/Thing.cpp: Remove some unused
	  includes.

2008-11-10  Al Riddoch  <alriddoch@googlemail.com>

	* data/characters.xml: Add default stamina to all mobile entities.

2008-11-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.h, rulesets/Character.cpp: Replace hard coded
	  stamina value with a property.

2008-11-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.h, rulesets/Character.cpp: Replace hard
	  coded maximum mass with an attribute check.

2008-11-10  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.cpp: Fix usage information for dynamic port range
	  options.

2008-11-10  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Fix a problem where existing database tables
	  weren't added to the set for maintenance cycles. This should fix a
	  lot of major performance issues.

2008-11-09  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Suppress a warning about unused members.

2008-11-09  Al Riddoch  <alriddoch@googlemail.com>

	* server/server.cpp: Improve error reporting, and add settings
	  information to most of the socket failure errors.

2008-11-09  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.h, common/globals.cpp: Add a global for the http port
	  setting. Move the dynamic port range where there is likely to be
	  more space.

2008-11-07  Al Riddoch  <alriddoch@googlemail.com>

	* common/log.cpp: Use a format string rather than using the raw
	  contents of the message and hoping there is no formatting in it.

2008-11-07  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cyaddrules.cpp: Switch varconf/Config.h to the lower
	  case name.

2008-11-07  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp: Check the result of fwrite() when writing a
	  keyfile to disk.

2008-11-07  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Comment out some half written code that
	  was causing a warning.

2008-11-07  Al Riddoch  <alriddoch@googlemail.com>

	* common/globals.cpp: Modify the way socket paths are handled
	  and allow them to be specified as absolute paths.

	* client/ClientConnection.cpp, server/CommUnixListener.cpp,
	  tools/cyaddrules.cpp, tools/cycmd.cpp: Don't build the complete
	  socket path here, as it is now determined in the config.

2008-11-07  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommMetaClient.cpp: Remove some compile time debug.

2008-11-06  Al Riddoch  <alriddoch@googlemail.com>

	* configure.ac: Link the test program which checks for res_init() as
	  on some platforms it's not in the default libraries.

2008-11-04  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Add the new storage tables to those that
	  are vacuumed regularly. Add an index to the name of properties
	  to make them massively more efficient to update.

2008-11-03  Al Riddoch  <alriddoch@googlemail.com>

	* tests/systemtest.cpp: Make security test functions are always
	  run, even in a non-debug build.

2008-11-03  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp, common/system.h: Add security_init(), a
	  function to initialise any security or crypto related libraries
	  used. This is required by recent version of libgcrypt when
	  using hash functions.

	* server/server.cpp, tests/systemtest.cpp, tools/cypasswd.cpp:
	  Call security_init() in all programs that use security related
	  functions.

2008-11-03  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp, server/StorageManager.h: Add a bunch
	  of metrics about the database performance.

2008-11-01  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp: Free a temporary buffer used to store
	  intermediate data when hashing a password.

2008-10-28  Al Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.17

2008-10-28  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/cyphesis-setup.sh: Fix a mistake in the calling of
	  cyloadrules.

2008-10-27  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/cyphesis-setup.sh: Ensure there are no errors because
	  of permissions on the source directory. Shorten some variable
	  names to clean up formatting. Clean up error handling with database
	  commands.

2008-10-27  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/cyphesis-setup.sh: Add checks for a whole bunch of
	  environment variables which could contain the calling user's
	  username after sudo or su have been run. Improve some of the
	  messages.

2008-10-27  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Plant.cpp: Fix the bbox property name.

2008-10-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommMetaClient.cpp: Remove some debug output.

2008-10-27  Al Riddoch  <alriddoch@googlemail.com>

	* configure.ac: Add a check for res_init().

	* server/CommMetaClient.cpp, server/CommMetaClient.h: Refactor
	  the metaserver related code so it retries resolving the address
	  of the metaserver, and then uses the address established later
	  than init time. This provisionally fixes bug #283763 which was
	  that cyphesis would never talk to the metaserver if the name
	  resolution at startup failed.

	* server/server.cpp: Modify the way MetaClient is set up as it
	  is now not an open socket after initial setup.

2008-10-22  Al Riddoch  <alriddoch@googlemail.com>


	* common/TypeNode.h, common/TypeNode.cpp: Add a destructor to clear
	  out all the default property objects.

2008-10-22  Al Riddoch  <alriddoch@googlemail.com>

	* server/Makefile.am, tools/Makefile.am: Update the static libraries
	  required for relocatable portable binaries.

2008-10-21  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/NPCMind.py: Avoid a tight loop by more
	  fully checking an entity is ready to be added to posessions
	  before trying to add it.

2008-10-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp: Fix a bug where new instance properties
	  weren't added to the Entity instance.

2008-10-14  Al Riddoch  <alriddoch@googlemail.com>

	* tests/PropertyFlagtest.cpp: Remove a check which tests for
	  functionality that is not there yet.

2008-10-14  Al Riddoch  <alriddoch@googlemail.com>

	* configure.ac, NEWS: Increment version to 0.5.17 for release soon.

2008-10-14  Al Riddoch  <alriddoch@googlemail.com>

	* tests/PropertyFlagtest.cpp: Test that property flags work correctly.

2008-10-14  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp, rulesets/Entity.h: Add a doc group for
	  Entity flags, and document them all in it.

2008-10-14  Al Riddoch  <alriddoch@googlemail.com>

	* common/Property.cpp, common/Property.h: Add a doc group for
	  Property flags, and document them all in it.

2008-10-09  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Makefile.am: Add an __init__.py to the scripts directory
	  to make sure the directory is treated as a module.

2008-10-09  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Remove a check used during refactoring
	  and debugging.

2008-10-01  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.h: Properly document propery modification
	  functions.

2008-10-01  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h: Make all the
	  property access functions that should never be used to modify a
	  property const. Remove requirePropertyClass() as it pretty much
	  can't be const.

	* rulesets/Entity.cpp, rulesets/Entity.h: Make overriden
	  getProperty() const as it is in the base class. Add new
	  property access functions for code that needs to modify the
	  properties which ensures class properties never get modified
	  through the Entity interface.

	* rulesets/Character.cpp, rulesets/Plant.cpp, rulesets/Py_Thing.cpp,
	  rulesets/TerrainModProperty.cpp, server/CorePropertyManager.cpp:
	  Change all the code that accesses properties to use the right
	  functions.

2008-10-01  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.h: Rename some member functions and templates
	  to make more sense and be consistent.

	* rulesets/Character.cpp, rulesets/Plant.cpp,
	  server/CorePropertyManager.cpp: Fix the code to use the new names.

2008-10-01  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Thing.cpp, rulesets/Thing.h: Fix updateProperties() to be
	  not const, so it now compiles.

2008-10-01  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Thing.cpp: When properties have been updated,
	  mark them to be stored in the Database, and emit the necessary
	  signal.

2008-09-30  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Return early to avoid scheduling deleted
	  Entities for an update.

2008-09-30  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.h: Update a doc comment.

2008-09-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/CorePropertyManager.cpp: Update operation handlers to access
	  properties in the cleanest most type safe way possible.

2008-09-29  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Plant.cpp, rulesets/Plant.h:
	  Update the metabolism code to access properties in the cleanest
	  most type safe way possible.

2008-09-29  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.h, rulesets/LocatedEntity.cpp: Add two
	  new methods which make it easier to retrieve property data
	  in a type safe way.

2008-09-29  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/BaseMind.cpp: Remove some obsolete includes.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* tests/TestPropertyManager.h, tests/TestPropertyManager.cpp:
	  Implement the updated interface.

	* tests/Makefile.am: Add the necessary properties as used by
	  Plant.

	* tests/Stackabletest.cpp: Update which properties are expected
	  by default.

	* tests/AllPropertytest.cpp, tests/Propertytest.cpp: Update tests
	  now the core property classes have all changed.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* common/DynamicProperty.h, common/DynamicProperty_impl.h,
	  common/Makefile.am: Remove obsolete DynamicProperty from the
	  build.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Now that the property manager always
	  creates something, there is no longer any need to deal with it
	  returning 0.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/CorePropertyManager.cpp, server/CorePropertyManager.h:
	  Re-work the property manager to always create a property,
	  using closest match specialisations of the template where
	  possible. Replace all factories which did create DynamicProperty
	  objects with Property objects instead, as they are now functionaly
	  the same.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Entity.cpp, rulesets/Plant.cpp,
	  rulesets/Stackable.cpp: Fix up places that use the property
	  manager interface. Fix explicit reference to DynamicProperty.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/StatusProperty.cpp, rulesets/StatusProperty.h:
	  Use the template base class for properties.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/AtlasProperties.cpp, rulesets/AtlasProperties.h: Fix
	  the few property classes that needed to use references and be
	  immutable to implement it locally, as there are no longer
	  templates for that.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/EntityProperties.cpp: Remove a huge bunch of property
	  template specialisations that aren't used. Fix the ones left.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LineProperty.h, rulesets/LineProperty.cpp: Make
	  LineProperty store its own data.

	* rulesets/AreaProperty.cpp: Adapt the way AreaProperty uses
	  LineProperty to take account of it storing data.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* common/PropertyFactory.cpp: Remove DynamicProperty include.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/TransientProperty.h, rulesets/MultiHandlerProperty.h,
	  rulesets/MultiHandlerProperty.cpp, rulesets/MindProperty.h,
	  rulesets/InternalProperties.h, rulesets/HandlerProperty.h,
	  rulesets/HandlerProperty.cpp: Switch a bunch of pretty simple
	  property classes over to using Propery<> rather than
	  DynamicProperty<>.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* common/Property.h, common/Property_impl.h, common/Property.cpp:
	  Re-write the core property classes to embed their own data,
	  rather than refer to it. This makes DynamicProperty obsolete.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* client/ClientPropertyManager.cpp, client/ClientPropertyManager.h:
	  Amend the client Property manager to implement the new interface.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* common/PropertyManager.h: Modify the Property factory interface
	  so the required basic data type can be specified, allowing the
	  factory to create generic properties if something more specific
	  is not available.

2008-09-27  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Add an error check when escaping strings for
	  SQL queries.

2008-09-26  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Plant.h, rulesets/Plant.cpp: Re-write plant metabolism
	  to modify property values in place, and use Update operations
	  to propagate.

2008-09-26  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/StatusProperty.h: Add data accessor.

2008-09-26  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.h: Only initialise a required property
	  if a value is given.

2008-09-26  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/BBoxProperty.h: Add data accessor.

2008-09-26  Al Riddoch  <alriddoch@googlemail.com>

	* common/DynamicProperty.h: Add data accessor to all properties.

2008-09-23  Al Riddoch  <alriddoch@googlemail.com>

	* common/Property.h: Add a flag to indicate a properties value
	  has been changed, but the new value has not been broadcast.

	* rulesets/Thing.cpp: Re-write the Update handler to ignore the
	  operation arguments, and broadcast an update for all properties
	  marked as unsent.

	* rulesets/Character.cpp: Update all code which sent an update
	  operation so that it sets the flags rather than naming them
	  in the argument.

2008-09-18  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/goals/animal/domestic.py,
	  rulesets/basic/mind/goals/animal/herd.py,
	  rulesets/basic/mind/goals/common/misc_goal.py,
	  rulesets/basic/mind/goals/common/trigger.py,
	  rulesets/basic/mind/goals/dynamic/add_unique_goal.py,
	  rulesets/basic/mind/goals/humanoid/construction.py,
	  rulesets/basic/mind/goals/humanoid/fire.py,
	  rulesets/basic/mind/goals/humanoid/mason.py,
	  rulesets/basic/mind/goals/humanoid/transaction.py:
	  Add nominal doc strings to some goal classes.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/goals/common/move.py: Add nominal doc strings
	  to some goal classes.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/world/objects/animals/Pig.py,
	  rulesets/mason/world/objects/plants/seeds/Acorn.py,
	  rulesets/mason/world/objects/plants/seeds/Apple.py,
	  rulesets/mason/world/objects/plants/seeds/Fircone.py,
	  rulesets/mason/world/objects/plants/seeds/Seed.py: Add nominal
	  doc strings to some entity classes.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/goals/common/common.py,
	  rulesets/basic/mind/goals/common/move.py,
	  rulesets/basic/mind/goals/humanoid/build_home.py,
	  rulesets/basic/mind/goals/humanoid/fire.py,
	  rulesets/basic/mind/goals/humanoid/mason.py,
	  rulesets/basic/mind/goals/humanoid/transaction.py:
	  Clean up the way goals are imported so it makes more sense,
	  and doxygen has an easier time with it.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* dox/cyphesis/Thing.py, dox/cyphesis/__init__.py: Add a tree of
	  stub python files used to document the API exposed by the C++ core.

	* Doxyfile-python: Trim the directories down to the top level, and
	  turn on recursion.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/__init__.py, rulesets/mason/__init__.py,
	  rulesets/Makefile.am: These are no longer module directories,
	  so don't need __init__.py files.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* client/BaseClient.cpp: Remove the Look operation as Creator no
	  longer needs to be perceptive to get responses back from the
	  server.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Creator.cpp: Add a short path for the results of an
	  operation from an external mind to be returned to the external
	  mind, removing the need for remote admin clients to become
	  perceptive.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/NPCMind.py: Add a mechanism to detect when
	  the mind is assigned ownership of something it has not yet seen,
	  and postpone adding it to owned things until later.

2008-09-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/MemMap.cpp: Use a type node with empty name for
	  entities which don't yet have an assigned type.

2008-09-16  Al Riddoch  <alriddoch@googlemail.com>

	* Doxyfile, Makefile.am, configure.ac, index.dox,
	  data/architecture.dox, dox/Makefile.am, dox/architecture.dox,
	  dox/index.dox: Move the non-embedded documentation into its
	  own directory to keep the root a bit cleaner.

2008-09-16  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Remove tests for the hard coded Structure
	  class.

2008-09-16  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Makefile.am, rulesets/Structure.cpp, rulesets/Structure.h,
	  server/PersistantThingFactory.cpp: Remove the hard coded Structure
	  class from the build.

2008-09-16  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Remove the hard coded Structure class.

	* data/buildings.xml: Add a soft structure class which sets the simple
	  flag to 0.

2008-09-16  Al Riddoch  <alriddoch@googlemail.com>

	* server/CorePropertyManager.cpp: Add the simple property to the
	  property manager.

2008-09-16  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/InternalProperties.cpp, rulesets/InternalProperties.h:
	  Add a new property class to handle the simple flag on Location.

2008-09-16  Al Riddoch  <alriddoch@googlemail.com>

	* common/DynamicProperty.cpp: Add some explicit template
	  instantiations as this was breaking the optimised build.

2008-09-15  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cycmd.cpp: Add a new command to allow the creation of
	  more arbitrary in game entities.

2008-09-15  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/define_world.py: Add a flat_terrain function to
	  create a large area of flat terrain.

2008-09-13  Al Riddoch  <alriddoch@googlemail.com>

	* tests/IGEntityExerciser.h: Remove Setup from the tests.

2008-09-13  Al Riddoch  <alriddoch@googlemail.com>

	* data/basic.xml, data/characters.xml, data/mason.xml: Add tick
	  properties to a bunch of entity classes so they no longer need
	  a setup operation to get them going.

	* rulesets/mason/world/objects/Weather.py,
	  rulesets/mason/world/objects/elements/Fire.py,
	  rulesets/mason/world/objects/plants/seeds/Apple.py: Remove setup
	  handlers from a bunch of scripts as it is now handled by
	  properties.

	* data/buildings.xml: Add setup property to entity classes which
	  really need a setup op at startup.

	* client/BaseClient.cpp: Send a look when creating the avatar, so
	  that notifications get back without the need for a special case.

	* common/op_switch.h, rulesets/Creator.cpp, rulesets/Entity.cpp,
	  rulesets/Entity.h, server/WorldRouter.cpp:
	  Remove the setup operation sent to all entities on startup by
	  default. Get rid of some special cases that depended on it.

	* rulesets/InternalProperties.cpp, rulesets/InternalProperties.h:
	  Make the tick property schedule the operation on apply(), and
	  use the property value as the time to schedule it.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Character.h: Remove the setup
	  handler which used to install minds and send tick, as this is
	  all handled by properties now.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* server/Account.cpp: Set the mind property to empty on character
	  entities controlled by remote clients.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Re-order the setup of class and instance
	  properties on an Entity so they are installed and applied correctly.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/MindProperty.cpp, rulesets/MindProperty.h: Implement
	  adding a mind to a character entity when the property
	  is applied.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* data/animals.xml, data/characters.xml: Make "mobile" the base class
	  for everything that has mind. Add a default mind class property,
	  and a tick class property.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Plant.cpp, rulesets/Plant.h, data/plants.xml:
	  Add a tick class property to the base class for trees, and
	  remove the setup handler from the core base class as it is no
	  longer needed.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/MindProperty.h: Correct the documentation
	  string for the class.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Makefile.am: Add InternaProperties to the build.

2008-09-12  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/InternalProperties.cpp, rulesets/InternalProperties.h,
	  server/CorePropertyManager.cpp: Add a pair of new property classes,
	  one to schedule an immediate setup operation, and one to schedule
	  an immediate tick operation.

2008-09-11  Al Riddoch  <alriddoch@googlemail.com>

	* server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h: Remove the factory classes
	  now unused that were part of the old persistence mechanism. Rename
	  the new entity function to make more sense.

2008-09-11  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp, server/EntityFactory.h: Remove all code
	  relating to the old persistence mechanism.

2008-09-11  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Don't use the enable_persistence
	  flag to see if persistence is enabled. It's always false.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Add a check to see if database
	  is enabled before hooking into the Entity builder, and exporting
	  monitors.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: When tasks cause defaults to be changed,
	  also propagate the changes to the class properties.
	  Fixes https://bugs.launchpad.net/bugs/268725

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Remove debug output.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Set the class flag on class properties.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Makefile.am: Add MindProperty to the build.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h,
	  server/CorePropertyManager.cpp: Re-work part of the way
	  terrain mod properties are set up, removing the need for
	  a setup handler, and using install instead.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Motion.cpp: Add a check which bypasses the collision
	  code for entities without a bbox, and prevents a later crash.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/MindProperty.cpp, rulesets/MindProperty.h: A new
	  property class which will add a mind to an entity.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* modules/Location.h, modules/Location.cpp: Remove unused
	  acceleration and angular velocity variables.

2008-09-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/TransientProperty.cpp, rulesets/TransientProperty.h:
	  Re-work so an explicit handler is no longer required, and
	  the timed operation to delete the entity is scheduled directly
	  when the property is applied.

2008-09-09  Al Riddoch  <alriddoch@googlemail.com>

	* data/characters.xml: Add bboxes as class properties to most
	  character classes.

2008-09-09  Al Riddoch  <alriddoch@googlemail.com>

	* server/CorePropertyManager.cpp: Replace the old transient property
	  and handler with the new one.

2008-09-09  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Makefile.am, rulesets/TransientProperty.cpp,
	  rulesets/TransientProperty.h: New more encapsulated way to handle
	  transient.

2008-09-09  Al Riddoch  <alriddoch@googlemail.com>

	* Doxyfile, index.dox, data/architecture.dox: Start expanding the more
	  hand written docs.

2008-09-09  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Make statistics ephemeral. Remove hard
	  coded bbox.

2008-09-09  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Implement propagating changes in the
	  default attributes of a class to the class's children.

2008-09-09  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Planttest.cpp: Fix the test now that the hard coded
	  properties have removed from plant.

2008-09-09  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/AtlasProperties.cpp: Mark contains property as ephemeral
	  so it doesn't get stored.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* data/characters.xml, data/mason.xml, data/terrain.xml,
	  rulesets/mason/define_world.py: Remove instance attribute values
	  in favor of class defaults for stake.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* data/construction.xml, rulesets/mason/define_world.py: Remove
	  instance attribute values in favor of class defaults for stake.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Plant.cpp: Don't add a name to fruits/seeds as they
	  should not need one.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* data/plants.xml, rulesets/Plant.cpp, rulesets/Plant.h: Remove the
	  last of the hard coded properties from Plant. Replace with soft
	  class properties in the data.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Plant.cpp, rulesets/Plant.h: Remove hard radius
	  and fruitName properties, and get the values by reading via
	  the standard mechanism. Add some debug output, and remove
	  needless complexity from the position calculation for dropped
	  fruit.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Add queries which purge the world state on
	  startup to prevent the tables from getting clogged up. Fix the
	  syntax of the query which removes deleted entity rows.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* data/basic.xml, data/characters.xml, data/plants.xml: Remove some
	  obsolete classes which have no role in the world, and no media
	  to represent them.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* common/inheritance.cpp: Set the instance pointer to null on
	  deletion, so it can be cleanly instanced again.

	* rulesets/Entity.cpp, rulesets/Entity.h: Override getProperty()
	  so it returns defaults.

	* tests/TestPropertyManager.cpp, tests/TestPropertyManager.h:
	  Amend the test property manager to match changes to the interface
	  it implements.

	* tests/Areatest.cpp, tests/Creatortest.cpp, tests/Entitytest.cpp,
	  tests/Planttest.cpp, tests/Stackabletest.cpp,
	  tests/Structuretest.cpp, tests/Thingtest.cpp, tests/Worldtest.cpp:
	  Remove "bbox" from the set of properties tests expect all entities
	  to have by default, as it is now much more optional.

	* tests/EntityFactorytest.cpp: Flush inheritance tree after each
	  test case, as it interferes with the EntityBuilder initialisation.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/ActivePropertyFactory_impl.h: Re-work the active property
	  factories so they just pass handler information to the property
	  classes rather than installing it themselves, so the property
	  can now handle installing the handlers each time they are installed
	  on an entity, making class default properties work.

	* client/ClientPropertyManager.cpp, client/ClientPropertyManager.h,
	  common/PropertyFactory.h, common/PropertyFactory_impl.h,
	  common/PropertyManager.h, rulesets/ActivePropertyFactory.h,
	  server/CorePropertyManager.cpp, server/CorePropertyManager.h:
	  Modify the property manager and property factory interfaces so they
	  do not take a pointer to the owner, as this is never required any
	  more.

	* rulesets/Character.cpp, rulesets/Entity.cpp: Modify code that uses
	  property managers to use the new interface.

	* rulesets/SolidProperty.cpp, rulesets/SolidProperty.h: Make use of
	  the bool flag to implement this, preventing it from being tied to
	  having a pointer to the owner at creation time.

	* rulesets/StatusProperty.cpp, rulesets/StatusProperty.h: Remove
	  the need for an owner pointer at construction time by using the
	  apply method.

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h:
	  Use new MultiActivePropertyManager and install method to handle
	  installing handlers rather than relying on the factory to do it.

	* server/CorePropertyManager.cpp: Change many of the property
	  factories now that none get get an owner pointer.

	* server/EntityFactory.cpp: Set up default properties on all type
	  nodes when a new class is installed, and don't apply instance
	  properties based on class defaults, relying on class properties.

	* rulesets/Entity.cpp: Remove hard coded BBox property now that the
	  functionality is handled by a more special property.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Disable debug output.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/BBoxProperty.cpp, rulesets/BBoxProperty.h: A new property
	  to make BBOX optional and more dynamic.

	* rulesets/MultiHandlerProperty.cpp, rulesets/MultiHandlerProperty.h,
	  rulesets/MultiHandlerProperty_impl.h: A new property for those
	  generic properties that need many handlers.

2008-09-08  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Only do property inserts if there are
	  some to be inserted. Limit the number of queries per tick. Improve
	  database debug output.

2008-09-06  Al Riddoch  <alriddoch@googlemail.com>

	* common/Property.h: Add two more flags, one to indicate a property
	  is stored in the class, and one used to implement boolean
	  properties very efficiently.

2008-09-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp: Call the property install and apply methods
	  where required when properties are set.

2008-09-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/define_world.py: Add a test function to create a
	  simple oak entity.

2008-09-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Makefile.am: Add HandlerProperty to the build.

2008-09-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/HandlerProperty.h, rulesets/HandlerProperty_impl.h,
	  rulesets/HandlerProperty.cpp: New property class which uses the
	  install method it insert an operation handler function
	  instead of using a messy active property factory as we have done
	  so far.

2008-09-06  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Use PYTHON_LINKER_FLAGS rather than hard coding
	  architecture dependant flags.

2008-09-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp: Include default properties from the
	  type node when making an Atlas representation of an Entity.

2008-09-04  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.h: Add an accessor for the size of the queue of
	  database queries yet to be launched.

2008-09-04  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Expand the query for bootstrapping the world
	  database entry, so it more completely populates the row.

2008-09-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Plant.cpp: Increase the range of jitter on plant ticks
	  to ensure load is evenly spread.

2008-09-04  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp, server/StorageManager.h: Add a queue
	  of deleted entity IDs, and implement deleting entries from
	  this queue from the database.

2008-09-04  Al Riddoch  <alriddoch@googlemail.com>

	* server/WorldRouter.cpp: Emit the updated signal when an entity
	  is destroyed and removed from the world, so that the store
	  can remove it.

2008-09-04  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp, common/Database.h: Add method to remove
	  entities from the database store. Remove the foreign key index
	  constraint from the LOC column.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Bootstrap the world entry in the entity
	  database table at creation time.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* server/Persistance.cpp: Correct seem seriously wrong error
	  messages.

	* server/StorageManager.cpp: Add debug output for the number of
	  Database inserts and updates going on per tick.

	* rulesets/LocatedEntity.cpp: Add OBJTYPE to the set of immutable
	  entity properties.

	* server/CorePropertyManager.cpp: Assert that a property with
	  the name 'objtype' cannot be created.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Plant.cpp: Add a small random variation to plant simulation
	  tick time, so updates don't coincide.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Add checks so that ephemeral
	  entities are not written to the database, and ephemeral properties
	  are not inserted or updated. Postpone connecting the updated
	  signal until after the initial insert.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.h: Add a new flag for ephemeral entities.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/AtlasProperties.cpp: Set the ephemeral flag on ID property.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Add hooks so that updates to the world
	  get persisted.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Thing.cpp: Correct the logic when checking whether
	  the entity has changed.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp: Mark properties as dirty when they are
	  set.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Fix the SQL syntax when updating properties.

2008-09-03  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Remove debug output.

2008-09-02  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Escape strings before inserting them into
	  the database.

2008-09-02  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Disable debug output.

2008-09-01  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp, server/PersistantThingFactory.cpp,
	  server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h:
	  Add a count to each factory of the number of entities
	  it has created, and add a monitor watch to each one.

	* server/StorageManager.cpp, server/StorageManager.h: Add counters
	  for the various types of database query, and add monitor watches
	  for them.

2008-09-01  Al Riddoch  <alriddoch@googlemail.com>

	* common/Monitors.cpp, common/Monitors.h: Add dynamic variable
	  monitor functionality, allowing arbitrary variables to appear
	  in the monitors output.

	* server/ServerRouting.cpp: Use the new monitor functionality for
	  variables prebviously pushed to monitors once.

	* server/WorldRouter.cpp, server/WorldRouter.h: Add a count of
	  in-game entities. Expose it to the monitors.

2008-08-30  Al Riddoch  <alriddoch@googlemail.com>

	* common/Monitors.cpp: Remove the testing values for monitors.

	* server/ServerRouting.cpp: Add a bunch of server constants to the
	  monitors.

2008-08-30  Al Riddoch  <alriddoch@googlemail.com>

	* common/Monitors.cpp, common/Monitors.h: Add a new class to handle
	  storing key value pairs useful in monitoring the state of a server.

	* server/HttpCache.cpp, server/HttpCache.h: Add a function argument
	  to allow the content type to be controlled in the header.
	  Expose the Monitors class under /monitors URL.

2008-08-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/HttpCache.cpp, server/HttpCache.h: A caching file to handle
	  http data requests.

	* server/CommHttpClient.cpp, server/CommHttpClient.h: Move most of
	  the functionality into HttpCache.

2008-08-29  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommHttpListener.cpp, server/CommHttpListener.h: New
	  class to listen for http connections.

	* server/CommHttpClient.cpp, server/CommHttpClient.h: New class to
	  handle http requests.

	* server/server.cpp: Hack in a http listen socket on 6780.

2008-08-28  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Add the location data to the database
	  insert query.

	* server/Persistance.cpp: Modify the entity database table so it
	  has the right columns.

	* server/StorageManager.cpp: Correctly check the orientation
	  valid flag before using it.

2008-08-28  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp, common/Database.h: Modify the Entity database
	  functions to include a chunk of text for location data.

	* server/StorageManager.cpp: Implement naive storage of location
	  data to the database.

2008-08-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/ScriptFactory.cpp: Simplify way the name of a class
	  is determined by removing the hack to upercase the type name.

	* server/EntityFactory.cpp: Break python type name on the last
	  . making the name of the class independant of the Atlas type.

	* data/basic.xml, data/buildings.xml, data/characters.xml,
	  data/clothing.xml, data/mason.xml, data/plants.xml,
	  data/tools.xml, data/weapons.xml, data/werewolf.xml: Modify all
	  python type names in the classes to include the name of the class
	  explicitly.

2008-08-27  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp, server/StorageManager.h: Encode
	  properties as rather messy Atlas, and store them in the
	  database.

2008-08-26  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp, server/StorageManager.h: Move code
	  that inserts and updates Entities in the database into their own
	  functions.

2008-08-25  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp, server/StorageManager.h,
	  server/servery.cpp: Add a stub function to be used to bootstrap
	  world persistence.

2008-08-25  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Mark old functions relating to
	  bootstrapping world persistence as deprecated.

2008-08-24  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Implement updating modified properties.

	* server/StorageManager.cpp: Tweak test properties values
	  so we can tell if one has been updated.

2008-08-24  Al Riddoch  <alriddoch@googlemail.com>

	* tools/cycmd.cpp: Add a cast so the compiler does not warn about
	  string constants.

2008-08-24  Al Riddoch  <alriddoch@googlemail.com>

	* server/ServerRouting.cpp: Remove an unused global variable.

2008-08-24  Al Riddoch  <alriddoch@googlemail.com>

	* server/CommServer.cpp: Add () to make some logic more readable,
	  and get rid of a warning.

2008-08-24  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/PythonArithmeticScript.cpp, rulesets/PythonThingScript.cpp:
	  Add casts when passing string constants to Python calls which take
	  char *. I am confident this is safe, and the functions have no
	  need to modify the strings, so could take const char *, but somehow
	  don't.

2008-08-24  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp: Return 0 from a function stub that should
	  return something.

2008-08-24  Al Riddoch  <alriddoch@googlemail.com>

	* acinclude.m4: Fix the postgresql check to run without generating
	  warnings.

2008-08-23  Al Riddoch  <alriddoch@googlemail.com>

	* common/Property.h: Add helper functions to make it easy and clear
	  to manipulate flags.

	* common/Database.cpp, common/Database.h: Expand the entity database
	  table to include LOC and update sequence number. Implement new
	  functions that insert test entity data into entity and property
	  tables.

	* rulesets/LocatedEntity.h: Add an accessor providing direct access to
	  the properties dictionary for persistence.

	* server/Persistance.cpp: Remove the bounding box chunk from the
	  entity table schema.

	* server/StorageManager.cpp: Implement inserting and updating rows
	  into the Entity and Propertiy tables.

2008-08-22  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp: Put in very basic code framework for
	  scheduling update and insert queries to the database.

2008-08-22  Al Riddoch  <alriddoch@googlemail.com>

	* server/IdleConnector.cpp, server/IdleConnector.h: A generic sigc++
	  based class for functions which need to be called regularly.

	* server/StorageManager.cpp, server/StorageManager.h: Add a method
	  to be called once a second from the idler.

	* server/server.cpp: Hook the idler up to storage manager.

2008-08-22  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.h: Make flags protected, and add convenient methods
	  to set and clear flags. Add a flag for indicating that the entity
	  is queued for a storage update.

	* rulesets/Entity.cpp: Reset the clean flag correcly when the entity
	  is made dirty.

	* server/StorageManager.cpp: Hook up Entity::updated, and implement
	  queueing things for update and making sure they only get added once.

2008-08-22  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.h: Move entity flags to the top of the header.
	  Replace destroyed and perceptive booleans with flag values,
	  and re-work check methods accordingly.

	* rulesets/Entity.cpp, rulesets/Creator.cpp, rulesets/Character.cpp:
	  Ensure that destroyed and perceptive flags are used correctly.

2008-08-21  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/attributes.h: Remove old attribute flags used for
	  persistence from the build.

	* rulesets/Entity.h: Replace obsolete update flags with a more
	  general flags field, and define three needed to track the
	  cleanness of basic location data.

	* rulesets/Plant.cpp, rulesets/World.cpp: Remove now unused update
	  flags from property initialisation.

	* rulesets/Entity.cpp, rulesets/Thing.cpp, server/EntityFactory.cpp:
	  Replace code which updated update flags with simpler changes to
	  the new flags field.

2008-08-18  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp, server/Persistance.cpp: Implement creating
	  table for properties.

2008-08-18  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp, server/Persistance.cpp: Adjust code to take
	  into account changed return value. Add call to create Entity
	  table, and fix the query string in the implementation.

2008-08-18  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp, common/Database.h: Change the return type
	  of a method to fit the preferred convention. Add an experimental
	  API for new Entity persistence.

2008-08-18  Tamas Bates  <rhymer@gmail.com>

	* rulsets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h: Add a
	  function to easily remove a terrain mod from the terrain.

	* server/CorePropertyManager.cpp: Fix the delete handler for terrain
	  mods to correctly clear them from the terrain when their owning entity
	  is deleted.

2008-08-18  Al Riddoch  <alriddoch@googlemail.com>

	* common/Property.h, common/Property.cpp: Add two new functions to the
	  property API which facilitate using properties for default values.

2008-08-17  Tamas Bates  <rhymer@gmail.com>

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h: Fixed
	  an improperly named variable.

2008-08-17  Tamas Bates  <rhymer@gmail.com>

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h: Fixed
	  a logic issue which would have prevented some types of terrain mods 
	  from ever being parsed.

2008-08-17  Tamas Bates  <rhymer@gmail.com>

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h: Fixed
	  a number of inconsistent indentations. Avoid passing Point3D objects
	  by value in the terrain modifier parsing functions.

2008-08-17  Tamas Bates  <rhymer@gmail.com>

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h: Fix a
	  number of uninitialized variables that were causing warnings. Fix the
	  way that the position of a modifier is retrieved when parsing to avoid
	  copying it to more locations than necessary. Moved the parsing code for
	  specific modifiers into separate functions to make them easier to find
	  and to shorten the main parsing function. 

2008-08-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/server.cpp: Try out the StorageManager.

2008-08-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseWorld.h: Modify the addEntity() function so we no longer
	  need to specify whether it needs to be set up, as nowhere was ever
	  specifying.

	* server/WorldRouter.cpp, server/WorldRouter.h: Implement the modified
	  BaseWorld API, and ensure all entities are sent Setup operations
	  for now.

	* tests/TestWorld.h: Update test world so it implements the interface
	  correctly.

2008-08-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/StorageManager.cpp, server/StorageManager.h: Add a new
	  class to coordinate storing the world state in a persistent store.

2008-08-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h:
	  Avoid passing Point3D objects by value, to make the code faster.
	  Fix a crash in getTerrain(). Clean up for 80 columns, in the
	  header.

2008-08-17  Tamas Bates  <rhymer@gmail.com>

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h: Clean
	  up some commented out code. Reorganize TerrainModProperty.h so that
	  methods specific to terrain mods are more easily distinguished from 
	  those used by all properties. Change the way the terrain is searched
	  for to avoid iterating through the entire entity tree. Removed the 
	  prototype for an unused function named set().

2008-08-17  Tamas Bates  <rhymer@gmail.com>

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h: Add 
	  a member to store the pointer returned from Terrain::addMod(). Revise
	  set() to use this pointer. 

	* rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h: Update the
	  API for controlling modifiers to use the pointer returned by 
	  Terrain::addMod() when adding or updating modifiers.

	* server/CorePropertyManager.cpp: Update the handler for Move Operations
	  on terrain modifiers so that it correctly uses the new position.

2008-08-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.h: Add onUpdated() virtual method to be
	  called when the attributes of an Entity are changed.

	* rulesets/Entity.cpp, rulesets/Entity.h, rulesets/LocatedEntity.cpp,
	  rulesets/Thing.cpp, server/WorldRouter.cpp: Implement onUpdated()
	  to emit the updated signal on Entity, and change all code to
	  call onUpdated instead of emiting the signal.

2008-08-14  Al Riddoch  <alriddoch@googlemail.com>

	* common/Property.h: Make property flags writable so they can be
	  used for more versatile things. Add constants defining some flags
	  and masks.

	* tests/Propertytest.cpp: Add assertions to ensure the flags and
	  masks work as intended.

2008-08-14  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/TerrainProperty.cpp, rulesets/World.cpp: Fix the code
	  to take account of the modified semantics of Segment member
	  variable xref and yref.

	* configure.ac: Add a requirement for the latest version of
	  Mercator.

2008-08-14  Al Riddoch  <alriddoch@googlemail.com>

	Changes by Tamas Bates  <rhymer@gmail.com>

	* rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h: Add an
	  API for controlling modifiers to the terrain.

	* rulesets/TerrainModProperty.cpp, rulesets/TerrainModProperty.h:
	  Implement a new property for entities which affect the height
	  of the terrain.

	* server/CorePropertyManager.cpp: Add handlers to deal with
	  operations that manipulate the terrain when a terrain mod
	  property changes.

	* rulesets/mason/define_world.py: Add a test function for
	  terrain modification properties.

2008-08-12  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp, common/system.h: Add a function for getting
	  the time stamp from a file.

2008-08-12  Al Riddoch  <alriddoch@googlemail.com>

	* common/Identified.h: Add missing class documentation.

2008-07-10  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Makefile.am: Remove DESTDIR from moduledir directory, as
	  it meant it was getting added twice.

2008-07-01  Al Riddoch  <alriddoch@googlemail.com>

	* server/Makefile.am: Attempt to update the static libraries
	  required for a portable binary.

2008-07-01  Al Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.16

2008-06-08  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/cyphesis-setup.sh: Fix command line to su so it works.

2008-06-07  Al Riddoch  <alriddoch@googlemail.com>

	* Makefile.am, scripts/cyphesis-setup.sh: Add the setup script to the
	  build.

2008-06-05  Al Riddoch  <alriddoch@googlemail.com>

	* tests/PropertyExerciser.cpp: Use the C++ limits API, rather than
	  the C defines.

	* tests/Containertest.cpp: Add missing C headers required by more
	  recent compilers.

2008-06-04  Al Riddoch  <alriddoch@googlemail.com>

	* Makefile.am, libraries/Makefile.am: Fix the recursive rules
	  so a complete distribution package is built.

2008-06-03  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Add some doc strings.

2008-05-28  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Character.h: Remove some of the
	  obsolete handlers in the filter on ops from the mind. Stop using
	  the generic IG op switch, and write a custom one.
	  Fix a bug where Use ops were getting filtered out unintentionally.

2008-05-28  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/import_bullet: Check explicitly for source files suffixes
	  before treating them as sources. Create temporary files to avoid
	  updating Makefile.am if there is no change. Mark headers as not to
	  be installed.

2008-05-08  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/import_bullet: An experimental script.

2008-04-29  Al Riddoch  <alriddoch@googlemail.com>

	* common/log.cpp: Don't assign strings to non-const char*.

2008-04-28  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp, common/globals.cpp, common/id.cpp,
	  common/log.cpp, modules/DateTime.cpp, rulesets/Container.h,
	  rulesets/Statistics.h, server/CommListener.cpp,
	  server/CommServer.cpp, tools/cyconfig.cpp, tools/cyconvertrules.cpp:
	  Add includes required for recent compilers which include less
	  stuff implicitly in standard headers.

2008-04-19  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp, common/system.h: Add a security setup function
	  which creates a persistent server identity.

2008-04-13  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp: Add test code to generate unique cryptographic
	  server identity.

2008-03-28  Al Riddoch  <alriddoch@googlemail.com>

	* data/devices.xml: Add a second type of operation to the example
	  device.

	* rulesets/Character.cpp: Sort out the fixme so non-default actions
	  can be specified when actuating devices.

	* rulesets/basic/mind/goals/common/misc_goal.py: Clean up the
	  actuation testing goal.

2008-03-28  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/goals/common/misc_goal.py: Make the checking
	  for a list simpler. Add a test goal for exercising the device
	  activation interface.

	* rulesets/mason/define_world.py: Add client test method to try
	  out the activation goal.

2008-03-28  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_Location.cpp: Implement the repr() method of the
	  Python object protocol for this wrapper, making debugging easier in
	  scripts.

2008-03-26  Al Riddoch  <alriddoch@googlemail.com>

	* common/Actuate.h, common/Makefile.am, common/custom.cpp,
	  common/op_switch.h, common/operations.cpp: Add Actuate to the
	  cyphesis core custom operations.

	* rulesets/Entity.cpp, rulesets/Entity.h, rulesets/Character.cpp:
	  Add handlers for Actuate to the operation routing interface.

	* data/devices.xml: Add example device.

	* data/Makefile.am: Add new devices file.

	* data/operations.xml: Remove temporary soft Actuate definition.

2008-03-23  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Change the name of the attribute that stores
	  operations to be used on devices, so devices can't accidentally
	  be used as tools.

2008-03-20  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/world/statistics/Statistics.py: Use super() instead
	  of hardcoding the superclass.

2008-03-20  Al Riddoch  <alriddoch@googlemail.com>

	* data/operations.xml: Add an op definition for "actuate" to be used
	  for interacting with devices and machines.

	* rulesets/Character.cpp, rulesets/Character.h: Mock up the code for
	  processing actuate operations from the client or mind.

2008-03-12  Al Riddoch  <alriddoch@googlemail.com>

	* configure.ac, NEWS: Increment version number for release soon.

2008-01-30  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp: Add more details to comments.

	* rulesets/Character.cpp: Add a warning when an unknown up comes
	  from the mind.

2008-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseEntity.cpp, common/BaseEntity.h,
	  common/OOGThing.cpp, common/OOGThing.h: Make files as removed.

	* tests/BaseEntitytest.cpp, tests/Makefile.am, tests/OOGThingtest.cpp:
	  Remove the tests for the above removed files.

	* tests/LocatedEntitytest.cpp, tests/ThingupdatePropertiestest.cpp:
	  Update the tests to call the right base class constructors.

2008-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* client/BaseClient.cpp, common/BaseEntity.cpp, common/BaseEntity.h,
	  common/Identified.cpp, common/Identified.h, common/Makefile.am,
	  common/OOGThing.cpp, common/OOGThing.h, common/OperationRouter.cpp,
	  common/OperationRouter.h, rulesets/Character.h, rulesets/Entity.h,
	  rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h,
	  server/Account.cpp, server/Account.h, server/Admin.cpp,
	  server/CommClient.cpp, server/CommClient.h, server/Connection.cpp,
	  server/Connection.h, server/ExternalMind.cpp, server/ExternalMind.h,
	  server/ExternalProperty.cpp, server/ExternalProperty.h,
	  server/Lobby.cpp, server/Lobby.h, server/Master.cpp, server/Master.h,
	  server/Peer.cpp, server/Peer.h, server/ServerRouting.cpp,
	  server/ServerRouting.h, server/SlaveClientConnection.cpp,
	  server/SlaveClientConnection.h: Factor out the more pointless base
	  classes, in favor of simple interface. Move destroyed signal to
	  Entity, which is the only place it is needed.

2008-01-26  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseEntity.cpp, common/BaseEntity.h: Remove the code that
	  handle ID, and just inherit from Identified.

	* client/CharacterClient.cpp, client/CreatorClient.cpp,
	  common/OOGThing.cpp, rulesets/BaseMind.cpp, rulesets/Character.cpp,
	  rulesets/Creator.cpp, rulesets/Entity.cpp,
	  rulesets/LocatedEntity.cpp, rulesets/MemEntity.cpp,
	  rulesets/Plant.cpp, rulesets/Stackable.cpp, rulesets/Structure.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/Account.cpp,
	  server/Admin.cpp, server/ExternalMind.cpp, server/Lobby.cpp,
	  server/Peer.cpp, server/Player.cpp, server/ServerRouting.cpp,
	  server/SlaveClientConnection.cpp: Add calls to the virtually
	  inherited Identified constructor as required.

2008-01-23  Al Riddoch  <alriddoch@googlemail.com>

	* server/Connection.h: Add sigc::trackable back into the inheritance
	  for Connection, so it gets disconnected from signals on destruction.

2008-01-23  Al Riddoch  <alriddoch@googlemail.com>

	* valgrind-python.supp: Uncomment supressions required if Python
	  has not been re-compiled.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/Identified.cpp, common/Identified.h: Add a new base class
	  which combines Identified with OperationRouter.

	* server/CommClient.cpp, server/CommClient.h: Modify CommClient to
	  refer to it's operation routing object purely by the OperationRouter
	  interface.

	* server/Connection.cpp, server/Connection.h,
	  server/TrustedConnection.cpp: Re-factor connection routers so
	  they no longer inherit from BaseEntity, and instead inherit
	  cleanly from the minimum required interfaces.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/Identified.cpp, common/Identified.h: New base class for
	  anything that has an identity.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* tests/EntityExerciser.h, tests/IGEntityExerciser.h: Remove
	  operation calls from the operation router tests which no longer
	  exist in the interface.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/BaseMind.cpp: Remove an obsolete local variable.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseEntity.cpp, common/BaseEntity.h: Remove generic operation
	  routing code.

	* common/op_switch.h: Remove all OOG operations from the standard
	  op switch.

	* rulesets/Entity.cpp, rulesets/Entity.h: Replace generic operation
	  routing with a more specific IG routing implementation.

	* rulesets/BaseMind.cpp: Add a mind specific operation router
	  implementation.

	* server/Account.cpp, server/Account.h: Remove handling of Login,
	  which should never got to Account. Add base handler for Get,
	  as it needs to be overriden in Admin.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/Admin.cpp, server/Connection.cpp, server/Connection.h,
	  server/ServerRouting.cpp, server/ServerRouting.h: Use the much
	  simpler OperationRouter interface when handling routing operations
	  round the server.

2008-01-14  Al Riddoch  <alriddoch@googlemail.com>

	* tests/BaseEntitytest.cpp, tests/EntityExerciser.h,
	  tests/LocatedEntitytest.cpp, tests/Makefile.am,
	  tests/OOGThingtest.cpp, tests/OperationExerciser.cpp,
	  tests/OperationExerciser.h, tests/inheritancetest.cpp: Fix tests
	  to account for header changes, and the fact that some of the
	  base classes are now abstract.

2008-01-13  Al Riddoch  <alriddoch@googlemail.com>

	* client/BaseClient.cpp, client/ClientConnection.cpp,
	  common/BaseWorld.h, common/OperationRouter.h, common/TypeNode.h,
	  common/inheritance.cpp, common/inheritance.h, common/types.h,
	  rulesets/ActivePropertyFactory.h, rulesets/AtlasProperties.h,
	  rulesets/EntityPropertyFactory.h, rulesets/LocatedEntity.h,
	  rulesets/MemMap.h, rulesets/Motion.h, rulesets/Movement.h,
	  rulesets/Pedestrian.h, rulesets/PythonThingScript.cpp,
	  rulesets/Statistics.h, rulesets/Task.h, server/Account.h,
	  server/Connection.h, server/Player.h, server/ServerRouting.h,
	  server/WorldRouter.h, tests/OperationExerciser.h, tools/cycmd.cpp:
	  A major clean up and re-work in internal headers.

2008-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseEntity.cpp, common/custom.cpp, common/inheritance.cpp,
	  common/inheritance.h, common/op_switch.h, common/types.h,
	  rulesets/Character.cpp, rulesets/Creator.cpp,
	  rulesets/PythonThingScript.cpp, server/Account.cpp,
	  server/Connection.cpp, server/ExternalMind.cpp,
	  tests/OOGThingtest.cpp, tests/inheritancetest.cpp:
	  Remove a set of pointless definitions, and use the originals
	  throughout the code.

2008-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* common/OperationRouter.cpp, common/OperationRouter.h: Interface
	  class for objects when can handle or route operations.

	* common/BaseEntity.h, common/BaseEntity.cpp: Remove standard
	  implementation of operation handler, forcing class to provide
	  more specific implementations.

	* rulesets/LocatedEntity.h, rulesets/LocatedEntity.cpp: Add an
	  implementation of the OperationRouter interface, suitable for
	  IG operations.

	* server/ServerRouting.h, server/Peer.cpp, server/Peer.h,
	  rulesets/MemEntity.h: Add placeholder OperationRouter
	  implementations.

	* server/Connection.cpp: Update OperationRouter implementation to
	  be better suited.

	* server/Account.cpp, server/Account.h: Implement OperationRouter
	  for accounts.

2008-01-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.h: Add an additional template function for
	  forcing the existence of a property of the required type.

	* rulesets/Character.cpp: Make the code further simpler and more
	  readable by using the new template function to require a property
	  exist.

2008-01-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Use getSpecificProperty() to replace
	  last other dynamic_cast of property.

2008-01-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.h: Add a template function for quickly
	  querying a property of the required type.

	* rulesets/Character.cpp: Use getSpecificProperty() to improve
	  brevity and readability of some of the code.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* tests/IGEntityExerciser.h: When testing the world, ensure it has
	  a container storage, as code expect this.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* Charactertest.cpp, Creatortest.cpp, Planttest.cpp,
	  Stackabletest.cpp, Structuretest.cpp, Thingtest.cpp,
	  Worldtest.cpp: Update tests so they no longer expect the
	  contains property to be set by default.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Motion.cpp: Add more thorough assert checks.

	* tests/IGEntityExerciser.h: Ensure the containership is complete and
	  legal on entities to be tested, so collision code called from
	  update handler works correctly.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Entitytest.cpp: Update so that it no longer expects the
	  contains property to be set by default.

	* tests/EntityReftest.cpp: Fix tests so that when calling destroy
	  on an Entity, it's hierarchy is as expected.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* tests/EntityPropertytest.cpp: Fix the test to account for the
	  new dynamic nature of this property.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.h: Remove an obsolete include.

2008-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h: Add a virtual
	  function that is called when the location of an entity changes.

	* rulesets/Entity.cpp, rulesets/Entity.h: Implement the virtual
	  function called when location changes and use it to call the
	  containered signal. Remove the containered_oneshots list, and
	  make containered inherently one shot only.

	* rulesets/OutfitProperty.cpp: Remove the use of containered_oneshots
	  is this mechanism is obsolete and has been removed.

2008-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/EntityProperty.h, rulesets/EntityProperty.cpp:
	  Refactor so this property is always dynamic, and add an accessor.

	* rulesets/Character.cpp, rulesets/Character.h: Remove the hard
	  coded entity references used for wield tool, and replace with
	  a dynamic property.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Fix a missed check for m_contains being
	  null.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Fix dependencies so tests build.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp: Clean up the syntax and line length in
	  destroy() to make the code more readable.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h:
	  Don't allocated storage for m_contains by default, only
	  on demand. Add a convenience method which checks, and
	  allocates the storage if required. Set up the ID property
	  on this base class rather then Entity.

	* rulesets/Py_Thing.cpp: Remove special handling of ID attribute
	  as it is now handled by the property.

	* rulesets/Character.cpp, rulesets/Entity.cpp, rulesets/MemMap.cpp,
	  rulesets/Motion.cpp, rulesets/Py_Mind.cpp, rulesets/Py_Thing.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/WorldRouter.cpp:
	  Make sure all parts of the code where contains is used have
	  the right checks, as it could be null.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp: Use PACKAGE_BUGREPORT from autoconf for the
	  email address to report bugs to in error messages.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_Thing.cpp: Remove the world attribute on Entity
	  wrapper.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/acorn/world/objects/animals/Deer.py,
	  rulesets/acorn/world/objects/animals/Pig.py,
	  rulesets/acorn/world/objects/outdoor/Campfire.py,
	  rulesets/acorn/world/objects/plants/Tree.py,
	  rulesets/acorn/world/objects/tools/Cleaver.py,
	  rulesets/basic/world/objects/plants/Tree.py,
	  rulesets/mason/world/objects/animals/Deer.py,
	  rulesets/mason/world/objects/animals/Pig.py,
	  rulesets/mason/world/objects/clothing/Garment.py,
	  rulesets/mason/world/objects/elements/Fire.py,
	  rulesets/mason/world/objects/outdoor/Campfire.py,
	  rulesets/mason/world/objects/tools/Bow.py,
	  rulesets/mason/world/objects/tools/Bucksaw.py,
	  rulesets/mason/world/objects/tools/Cleaver.py,
	  rulesets/mason/world/objects/tools/Sword.py,
	  rulesets/mason/world/objects/tools/Tinderbox.py,
	  rulesets/mason/world/objects/tools/Torch.py,
	  rulesets/mason/world/objects/tools/Trowel.py,
	  rulesets/mason/world/tasks/Bisect.py,
	  rulesets/mason/world/tasks/Combat.py,
	  rulesets/mason/world/tasks/Cultivate.py,
	  rulesets/mason/world/tasks/Delve.py,
	  rulesets/mason/world/tasks/Dig.py,
	  rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Ram.py,
	  rulesets/mason/world/tasks/Reap.py,
	  rulesets/mason/world/tasks/Sharpen.py,
	  rulesets/mason/world/tasks/Slaughter.py,
	  rulesets/mason/world/tasks/Slice.py,
	  rulesets/mason/world/tasks/Trailblaze.py,
	  rulesets/werewolf/world/objects/tools/Gallows.py:
	  Remove code that accesses the world attribute on Entity,
	  replacing where necessary with server.world.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_World.h: Remove the pointer to the world router from
	  its wrapper, as all the wrapper code should now use the singleton
	  interface.

	* rulesets/Python_API.cpp, rulesets/Py_World.cpp,
	  rulesets/Py_Thing.cpp: Fix up all the code which uses the world
	  router pointer.

2008-01-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Python_API.cpp: Add an instance of the world wrapper to
	  the server module, which should then be used instead of the
	  world attribute on entities.

2008-01-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_World.cpp: Modify the world wrapper so it does not
	  require a pointer to the world router instance, and uses it as
	  a singleton instead.

2008-01-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/NPCMind.py: Clean up some imports, and remove
	  some legacy aliasing.

2008-01-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Python_API.cpp: Remove the server_python flag used to
	  allow scripts to run unmodified on the obsolete python prototype.

	* rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/mind/goals/animal/herd.py,
	  rulesets/basic/mind/goals/common/common.py,
	  rulesets/basic/mind/goals/common/move.py,
	  rulesets/mason/world/objects/buildings/House.py: Remove support
	  for running these scripts on the obsolete python prototype.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp, rulesets/LocatedEntity.cpp: Move cleaning
	  up properties into the LocatedEntity destructor, so none are leaked.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Entitytest.cpp: Remove the difference between attribute and
	  property checks, as all attributes are now handled by the property
	  mechanism.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Charactertest.cpp, tests/Creatortest.cpp,
	  tests/Stackabletest.cpp, tests/Structuretest.cpp,
	  tests/Thingtest.cpp, tests/Worldtest.cpp: Add TypeNode.h include.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Add TypeNode.o to tests as required.

	* tests/Planttest.cpp: Add TypeNode.h include.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp, rulesets/LocatedEntity.cpp: Move the code the
	  decremements the reference to containing entity into the
	  LocatedEntity destructor where it belongs.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp: Fix leak of m_contains.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Entity.cpp,
	  rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h,
	  rulesets/MemMap.cpp, rulesets/Motion.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Thing.cpp, rulesets/World.cpp,
	  server/WorldRouter.cpp: Change LocatedEntity::m_contains into
	  a pointer so that the majority of entities that can not contain
	  anything don't waste the storage.

2007-12-29  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp: Add code to getAttr so it looks in
	  the default properties on the TypeNode if the instances does not
	  have the property.

2007-12-29  Al Riddoch  <alriddoch@googlemail.com>

	* common/TypeNode.h: Change the type of defaults over to properties.

	* common/inheritance.cpp, common/inheritance.h: Modify the API
	  for specifying defaults on a new TypeNode to take the new
	  property based data.

2007-12-29  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h, rulesets/LocatedEntity.h: Clean up typedefs, and
	  make sure they are used from the right includes.

2007-12-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: Fix a brief and blatantly obvious comment.

2007-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/TypeNode.h, common/TypeNode.cpp: Move TypeNode into
	  its own files.

	* common/Makefile.am, common/inheritance.cpp, common/inheritance.h:
	  Add the new files to the build and remove the old implementation.

	* client/Py_CreatorClient.cpp, rulesets/Character.cpp,
	  rulesets/Entity.cpp, rulesets/MemMap.cpp,
	  rulesets/MindFactory.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Stackable.cpp,
	  server/WorldRouter.cpp: Fix up the includes for all code that
	  uses TypeNode.

2007-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.h, server/EntityFactory.cpp: Move a typedef
	  into the only cpp file where it is used.

2007-12-24  Al Riddoch  <alriddoch@zepler.org>

	* server/Persistor.cpp, server/Persistor_impl.h,
	  server/Restoration.cpp, server/Restorer.cpp,
	  server/Restorer_impl.h: Add errors to files removed from the
	  build.

2007-12-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Entity.h, rulesets/LocatedEntity.cpp,
	  rulesets/LocatedEntity.h: Remove raw atlas attributes, and use
	  properties for everything, cutting down the differences in
	  interface.

	* rulesets/Py_Thing.cpp, rulesets/Thing.cpp: Remove code that accessed
	  soft attributes directly.

2007-12-24  Al Riddoch  <alriddoch@zepler.org>

	* common/Property.h, common/Property.cpp: Add a soft property class,
	  which can take values of any type.

	* rulesets/Entity.cpp: Use soft property for any values for which
	  there is no assigned property factory, and avoid using raw atlas
	  attributes completely.

2007-12-21  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.h: Remove a nasty hack for old compilers, and
	  make the private part of Database protected.

2007-12-21  Al Riddoch  <alriddoch@zepler.org>

	* common/terrain_utils.h, common/Makefile.am: Remove the persistence
	  code used to save terrain data.

	* common/Database.cpp, common/Database.h: Remove the object
	  relational API for persisting entity data, and put the code
	  beyond use.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Remove obsolete persistence code from tests
	  that used to depend on it.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am, server/Restoration.h, server/Restorer.h,
	  server/server.cpp: Remove the counter part templated restorer
	  code from the build.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, server/Makefile.am,
	  server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h, server/Persistor.h,
	  server/Restoration.cpp, server/Restorer.cpp, server/Restorer.h,
	  server/Restorer_impl.h: Remove the templated persistor code from
	  the build.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Delete the peristance connector in
	  the right place.

	* server/PersistantThingFactory.h: Document what the persistor 
	  connector does more clearly.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Fix up the tests to use the updated
	  class names.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, server/EntityFactory.h,
	  server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h: Rename the base class for
	  Entity factories from FactoryBase to EntityKit.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, server/EntityFactory.h, server/Admin.cpp,
	  server/PersistantThingFactory.cpp, server/WorldRouter.cpp,
	  server/server.cpp: Rename EntityFactory to EntityBuilder, to make
	  it's function clearer.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyFactory.h, common/PropertyFactory_impl.h,
	  rulesets/ActivePropertyFactory.h,
	  rulesets/ActivePropertyFactory_impl.h,
	  rulesets/EntityPropertyFactory.h,
	  rulesets/EntityPropertyFactory_impl.h,
	  server/CorePropertyManager.cpp:
	  Rename all property factory classes to have PropertyFactory as the
	  suffix.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyFactory.cpp, common/PropertyFactory.h,
	  rulesets/ActivePropertyFactory.h, rulesets/EntityPropertyFactory.h,
	  server/CorePropertyManager.cpp, server/CorePropertyManager.h:
	  Rename abstract base class for property factorys to PropertyKit.

2007-12-10  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Add usage information for --help and --version
	  so that the checker does not warn about them.

	* configure.ac: Increment version.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.15

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.h, common/Database.cpp: Add a new decoder for atlas
	  objects, and use it when getting the full contents of a table
	  full of Atlas data.

	* server/Persistance.cpp, server/Persistance.h: Modify the API
	  for getting the rules table to use atlas objects rather than
	  messages.

	* server/EntityFactory.cpp: Re-enable loading rules from the
	  Database, now that the data is available from the peristence
	  API in the right format.

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.h, common/PropertyFactory.h, rulesets/Character.h,
	  rulesets/LocatedEntity.h, rulesets/MemMap.h, rulesets/Py_Location.h,
	  rulesets/Py_Thing.h, rulesets/Python_Script_Utils.h,
	  rulesets/Statistics.h, server/Connection.h, server/EntityFactory.h,
	  server/Persistance.h, server/PersistantThingFactory.h,
	  server/Persistor.h, server/Restoration.h, server/TaskFactory.h:
	  Sort forward declarations alphabetically, because alphabetical
	  is good.

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyFactory.h, server/EntityFactory.h,
	  server/TaskFactory.h: Fix up doc comments, using some more
	  Design Pattern compliant terminology.

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Persistance.cpp: Delete the Persistance instance on shutdown.

	* common/inheritance.cpp: Delete the TypeNodes in Inheritance on
	  shutdown.

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Fix conditional compilation to use UNIX
	  functionality, broken for ages. syslogging now works again.
	  Change the ident used for logging, and include the instance
	  name.

2007-12-06  Al Riddoch  <alriddoch@zepler.org>

	* common/system.h: Add a new exit status code indicating that no
	  ports were available in the dynamic range.

	* server/server.cpp, common/system.cpp: When there are no ports
	  available, write an appropriate message, and a hint describing
	  how to allocate more.

2007-12-06  Al Riddoch  <alriddoch@zepler.org>

	* server/Persistance.cpp: Change the log message so it is clearer
	  what is happening.

2007-12-06  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Remove an assert, and only shutdown the
	  database connection if one currently exists.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/Persistance.cpp: Add an information message when attempting
	  to create a new instance database.

	* server/server.cpp: Store a new value for the start of the dynamic
	  port range, if one is allocated.

	* common/globals.cpp: Force the instance name into lower case
	  alphanumeric, and underscore only. Reject it if it can't easily
	  be forced.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Fix the logic for creating per instance
	  databases.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp, common/Database.h: Add a new API for
	  attempting to bootstrap an instance database from the master.

	* server/Persistance.h, server/Persistance.cpp: Make some of the
	  functions in the persistence API non-static, so they work
	  more cleanly and consistently. Use the new return codes
	  specified in the config header. If an instance can't get a database
	  connection, use the master database to try and create one.

	* server/server.cpp: Use the persistence code the way it is
	  intended to be used.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp, common/Database.h: Remove the flag specifying
	  that the database should be created at connection time, as we
	  basically can't do this. Make the default database name depend on
	  instance name currently in use.

	* common/accountbase.cpp, tools/cydumprules.cpp, tools/cyloadrules.cpp:
	  Fix code for the change to the database API.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h: Add database error return codes.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h, common/globals.cpp: Add exported variables for
	  the names of the main config sections.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h, common/globals.cpp: Provide a separate function
	  for saving user settings back to the home directory. When
	  configuring a new instance, store the ruleset in user settings,
	  and log an informational message rather than a warning.

	* server/server.cpp: When dynamically assigning a port to a new
	  instance, store the port in user settings, and log an informational
	  message. Save the user configuration once the validity has been
	  completely verified and applied.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp: Fix up the warning message so it gives correct
	  instructions about disabling the database for instances.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Allow per-instance database configuration.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp: Make nice default to 1, so that it works the
	  same on all instances.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Move the instance configuration setting out
	  of a section, and fix the usage code so it can deal correctly with
	  this.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Fix a leak of the TXT record published
	  using avahi.

2007-12-04  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Add a new config setting for
	  the instance short name, and support per-instance configuration.
	  Add config settings for a dynamic port range.

	* server/server.cpp: Support per-instance configuration and use a
	  dynamic port for non-default instances.

2007-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Remove commented out call to
	  Subscribe_Script().

2007-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp, rulesets/BaseMind.h, rulesets/Entity.cpp
	  rulesets/Entity.h: Remove the scriptSubscribed methods which
	  were empty and unused.

	* rulesets/Python_API.cpp, rulesets/Python_Script_Utils.h: Remove
	  Subscribe_Script() as it is useless now.

	* server/ScriptFactory.cpp: Remove call to Subscribe_Script().

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/LocatedEntity.h: Update the doc strings
	  as the role of Entity has changed now that some of it's
	  functionality is in LocatedEntity.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* data/Makefile.am: Update the xml check so it works with out of
	  srcdir builds.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* tests/Areatest.cpp, tests/Charactertest.cpp, tests/Creatortest.cpp,
	  tests/Entitytest.cpp, tests/Foodtest.cpp, tests/Linetest.cpp,
	  tests/Planttest.cpp, tests/Stackabletest.cpp, tests/Structuretest.cpp,
	  tests/Thingtest.cpp, tests/Worldtest.cpp: Remove mass from the
	  attribute names assumed in the entity tests.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* data/animals.xml: Give all the animals BIOMASS.

	* data/characters.xml: Add mass to some character classes that were
	  missing it.

	* rulesets/Character.cpp, rulesets/Character.h, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/Plant.cpp, rulesets/Statistics.cpp,
	  rulesets/World.cpp, server/CorePropertyManager.cpp,
	  server/Persistor.cpp, server/Persistor_impl.h,
	  server/Restorer_impl.h: Remove the hard coded mass property from
	  Entity.

	* rulesets/mason/world/statistics/Statistics.py: Fix scripts which
	  assume entities will have mass.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Character.h, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/Plant.cpp, rulesets/Py_Thing.cpp,
	  rulesets/StatusProperty.cpp, rulesets/attributes.h,
	  server/CorePropertyManager.cpp, server/Persistor.cpp,
	  server/Persistor_impl.h, server/Restorer.cpp,
	  server/Restorer_impl.h: Remove the hard coded status property from
	  Entity, and the hard coded food property from character. Fix
	  the logic handling digestion and plants to use the new softer
	  properties.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add a test for the xmllint program.

	* data/Makefile.am: Use xmllint to make sure the rules data files are
	  ok.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Add status to the fire entity as the script needs
	  it to be there.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* tests/AllPropertytest.cpp, tests/IGEntityExerciser.h,
	  tests/Makefile.am: Fix the tests up so the build and run again.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* client/CreatorClient.cpp, client/CreatorClient.h,
	  client/Py_CreatorClient.cpp, common/BaseWorld.h, common/types.h,
	  modules/Location.cpp, modules/Location.h,
	  rulesets/AtlasProperties.cpp, rulesets/AtlasProperties.h,
	  rulesets/BaseMind.cpp, rulesets/Character.cpp, rulesets/Character.h,
	  rulesets/Entity.cpp, rulesets/Entity.h,
	  rulesets/EntityProperties.cpp, rulesets/LocatedEntity.cpp,
	  rulesets/LocatedEntity.h, rulesets/MemEntity.cpp,
	  rulesets/MemEntity.h, rulesets/MemMap.cpp, rulesets/Motion.cpp,
	  rulesets/Motion.h, rulesets/Py_Location.h, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Py_Thing.h,
	  rulesets/PythonMindScript.h, rulesets/PythonScript.h,
	  rulesets/PythonThingScript.cpp, rulesets/PythonThingScript.h,
	  rulesets/Python_API.cpp, rulesets/Script.cpp, rulesets/Script.h,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/WorldRouter.cpp,
	  server/WorldRouter.h: Refactor all the entity code so there is now
	  a new base class for entities in the world simulation, and in the
	  mind which only contains things which are trully common to both.
	  This moves a lot of functionality which should not have been
	  present in mind entities away, and makes that code safer and more
	  efficient.

	* tests/TestWorld.h: Update the test world API to match the base
	  class.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* tests/LocatedEntitytest.cpp: Add full coverage for current code
	  in LocatedEntity.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h: Make the attribute interface virtual.

	* rulesets/LocatedEntity.cpp: Add in basic implementatios without
	  properties of the attribute interface.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h:
	  Add a new base class for entities with location data and
	  attributes.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Add some checks to make sure the world
	  state is consistent.

2007-11-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Provide a more verbose error message about
	  incorrect updates.

	* rulesets/mason/define_world.py: Make sure the arguments to
	  the python builtin range() is always an integer.

2007-11-29  Al Riddoch  <alriddoch@zepler.org>

	* tests/Areatest.cpp, tests/Charactertest.cpp, tests/Creatortest.cpp,
	  tests/Entitytest.cpp, tests/Foodtest.cpp, tests/Linetest.cpp,
	  tests/Planttest.cpp, tests/Stackabletest.cpp,
	  tests/Structuretest.cpp, tests/Thingtest.cpp,
	  tests/Worldtest.cpp: Remove the STATUS and NAME properties
	  from those expected to be on all entities.

	* tests/ThingupdatePropertiestest.cpp: Comment out all the code
	  as it depends on the NAME property being hard coded.

2007-11-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/StatusProperty.cpp, rulesets/StatusProperty.h: 
	  Add a dynamic property that deletes the entity when it goes
	  below zero, removing the need for the hard coded property
	  of the same name.

	* rulesets/Makefile.am: Add the new property to the build.

	* server/CorePropertyManager.cpp: Add the new property to the system.

	* rulesets/mason/define_world.py: Add a test for setting the status
	  to below zero.

	* rulesets/Entity.cpp: Remove the hard property for status.

	* rulesets/Thing.cpp: Remove the code that checks the hard
	  status property to see if the entity needs to be deleted.

2007-11-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Fix the low threshold of the
	  sandy beach shader to be below water level.

2007-11-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/editor.py: Don't pre-pend the name on sentences
	  sent to program the AIs.

	* rulesets/basic/mind/NPCMind.py: Replace all the places where
	  the name of an entity is taken with a function which checks
	  for the name, but then uses the type if it is not present.

	* rulesets/basic/mind/panlingua/interlinguish.py: Fix the code
	  that strips the name from the beginning of sentences so that
	  it checks first.

2007-11-28  Al Riddoch  <alriddoch@zepler.org>

	* client/BaseClient.cpp, client/CharacterClient.cpp,
	  client/CharacterClient.h, client/CreatorClient.cpp,
	  client/CreatorClient.h, rulesets/BaseMind.cpp, rulesets/BaseMind.h,
	  rulesets/Character.cpp, rulesets/Entity.cpp, rulesets/Entity.h,
	  rulesets/MindFactory.cpp, rulesets/MindFactory.h, rulesets/Thing.cpp,
	  rulesets/World.cpp, server/Account.cpp, server/Connection.cpp,
	  server/EntityFactory.cpp, server/Persistor.cpp,
	  server/Persistor_impl.h, server/Restorer_impl.h,
	  server/WorldRouter.cpp: Remove the hard name attribute, now that
	  most entities don't set it.

2007-11-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h: Remove an old experimental type class, and clean
	  up includes.

	* client/Py_CreatorClient.cpp, rulesets/MemMap.cpp,
	  rulesets/MindFactory.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Stackable.cpp,
	  server/WorldRouter.cpp: Add necessary includes.

2007-11-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Move a bunch of random animals
	  to the end of world initialisation, so they don't create physics
	  load before everything else is set up.

2007-11-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/editor.py: Make the default argument of m.make
	  the type, and name optional.

	* rulesets/mason/define_world.py: Swap the type to the default
	  argument of m.make, and strip the names off most entities.

2007-11-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Creator.cpp: Clean up some attribute checks.

2007-11-26  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.cpp, common/inheritance.h: Introduce a type
	  node class as a carrier for all information, including default
	  values for a type.

	* rulesets/Entity.h, rulesets/Entity.cpp, rulesets/Character.cpp:
	  Use a TypeNode pointer rather than a string giving the type
	  of an entity.

	* client/Py_CreatorClient.cpp, rulesets/MemMap.cpp, rulesets/MemMap.h,
	  rulesets/MindFactory.cpp, rulesets/MindFactory.h,
	  rulesets/Py_Mind.cpp, rulesets/Py_Thing.cpp, rulesets/Stackable.cpp,
	  rulesets/World.cpp, server/PersistantThingFactory.h,
	  server/Restorer_impl.h, server/WorldRouter.cpp:
	  Adapt all the code that deals with types. Set the type pointer
	  up correctly in BaseMind.

	* server/EntityFactory.cpp: Initialise the TypeNode pointer on new
	  entities.

	* tests/inheritancetest.cpp: Adapt the test to cope with TypeNode.

2007-11-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp, rulesets/Makefile.am: Remove now oboleted
	  PythonMindScript from the code, and the build.

2007-11-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonMindScript.cpp, rulesets/PythonMindScript.h,
	  rulesets/PythonThingScript.cpp, rulesets/PythonThingScript.h:
	  Eliminate the difference between the code in these two classes,
	  as they really don't need to be different.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h, rulesets/BaseMind.cpp, rulesets/BaseMind.h:
	  Get rid of complicated dispatch of perception and sub operation
	  separately.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Script.h, rulesets/Script.cpp,
	  rulesets/PythonThingScript.h, rulesets/PythonThingScript.cpp,
	  rulesets/PythonMindScript.h, rulesets/PythonMindScript.cpp:
	  Modify the script interface so it now only handles one operation.

	* rulesets/BaseMind.cpp: Pass in the sub operation only for
	  sight and sound of other operations.

	* rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/mind/goals/humanoid/transaction.py: Adapt the mind
	  and goal code so it only requires one operation.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Set FROM on fake Set operations used in
	  metabolism.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Set FROM and SECONDS on Set operations generated
	  by Updates.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp: Stop using the sight op when getting
	  updates.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Rename some arguments to make
	  way for some changes to the code.

2007-11-22  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Update the entity factory tests to
	  comply with the new API, and fix pre-conditions which break
	  recently added assertions.

2007-11-22  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Clean up header
	  a little. Add some alerts for consistency. Stub out a method
	  for updating a task factory from a class description.

2007-11-22  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Rename 
	  dictionary of entity factories so that it is consistent.

2007-11-22  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Add names to
	  arguments of public member functions.

2007-11-21  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Re-order the
	  arguments to installFactory() so they are consistent with all the
	  other calls.

2007-11-21  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h: Clean up formatting, and name all the
	  arguments.

2007-11-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp: Add some asserts that proved useful in working
	  out why orientation data was sometimes uninitialised.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/MemMap.cpp: Initialise the next index when going through
	  the map checking for entities that we should remove. Avoid a lookup
	  when it is the wrong thing.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: Make sure the time is initialised in the
	  constructor.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* tools/Makefile.am, tools/cyconfig.cpp, tools/cyconvertrules.cpp:
	  Add support for --help and --version to everything.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Fix the link order now that we don't have libtool
	  to fix it for us.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/AtlasFileLoadertest.cpp: Update the tests now that the data
	  format handled by the loader has changed.

2007-11-16  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Make some checks clearer.

2007-11-15  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Store rich class
	  data for entity class types.

2007-11-15  Al Riddoch  <alriddoch@zepler.org>

	* common/AtlasFileLoader.cpp, common/AtlasFileLoader.h: Switch to
	  loading and storing the file using the Atlas Objects Decoder.

	* server/EntityFactory.cpp, server/EntityFactory.h: Switch to using
	  Atlas Objects rather than Messages in most places. Makes much of
	  the code cleaner, and allows storage of richer class data.

	* server/Admin.cpp: Update to match the modified EntityFactory API.

2007-11-14  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Modify the loadConfig
	  function so it takes usage hints, and checks the options in known
	  sections against those in the usage help.

	* client/client.cpp, server/server.cpp, tools/cyaddrules.cpp,
	  tools/cycmd.cpp, tools/cydumprules.cpp, tools/cyloadrules.cpp,
	  tools/cypasswd.cpp: Convert all calls to loadConfig to provide
	  the right hints.

2007-11-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: Task to allow players to
	  create roads is now functional.

2007-11-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: Fix _create_path to
	  generate the operation correctly.

2007-11-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: More work in progress.

2007-11-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: More work in progress.

2007-11-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: More work in progress.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: Add a new task script
	  for character defined roads. Work in progress.

	* data/tasks.xml, data/tools.xml: Add tool and task classes for
	  trailblazing.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* tools/cyaddrules.cpp, tools/cycmd.cpp: Use less verbose function
	  template to read config values.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* client/client.cpp, common/Database.cpp: Use less verbose function
	  template to read config values.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp, server/slave.cpp: Use less verbose function
	  template to read config values.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am: Update build rules so cyslave links.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h: Export the function template for making config
	  easier.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* autopackage/default.apspec.in: Update the email addresses, and tweak
	  the way man pages are included to be a little cleaner.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Add a template function that ensures config
	  values are read without having to repeat the section and key.
	  Much less verbose and more obvious. Set the default ruleset in a
	  more sane way.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.spec.in: Disable dependency tracking and use multiple CPU
	  cores when building the rpm.

	* configure.ac: Remove the need for libtool. Clean up some bit rot.

	* AUTHORS: Update email addresses, and make it clearer who did what.

	* acinclude.m4: Clean up the help text formatting in the postgresql
	  macro.

	* autogen.sh: Remove libtoolize.

2007-11-02  Al Riddoch  <alriddoch@zepler.org>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.14

2007-11-02  Al Riddoch  <alriddoch@zepler.org>

	* man/Makefile.am: Remove the man pages on maintainer-clean, so they
	  can be re-created in a maintainer rebuild.

2007-10-27  Al Riddoch  <alriddoch@zepler.org>

	* data/terrain.xml, data/mason.xml: Move some terrain related
	  definitions from mason into their own rules file.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/food.xml, data/basic.xml, data/mason.xml: Move some food types
	  from basic and mason into their own file.

	* data/construction.xml, data/basic.xml: Move a construction type from
	  basic into the right file.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/operations.xml, data/basic.xml: Move some operation definitions
	  from basic into their own rules file.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/weapons.xml, data/basic.xml: Move some weapon types
	  from basic into their own rules file.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml, data/tools.xml, data/buildings.xml: Move a bunch
	  of things from basic into the right places.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/operations.xml, data/tasks.xml: Move some operation definitions
	  from tasks into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/characters.xml, data/basic.xml: Move some character types
	  from basic into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/construction.xml, data/mason.xml: Move all the construction types
	  from mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/characters.xml, data/mason.xml: Move all the character types
	  from mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/tasks.xml, data/mason.xml: Move all the task types from
	  mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/tools.xml, data/mason.xml: Move all the tool types from
	  mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/animals.xml, data/mason.xml: Move all the animal types from
	  mason into their own rules file.

	* data/clothing.xml: Add a couple more overlooked clothing types.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/clothing.xml, data/mason.xml: Move all the clothing types from
	  mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/buildings.xml, data/mason.xml: Move all the building types from
	  mason into their own rules file.

2007-10-17  Al Riddoch  <alriddoch@zepler.org>

	* data/plants.xml: Add a fern.

2007-10-17  Al Riddoch  <alriddoch@zepler.org>

	* data/plants.xml, data/mason.xml: Move all the plant types from mason
	  into their own rules file.

2007-10-17  Al Riddoch  <alriddoch@zepler.org>

	* NEWS, configure.ac: Increment version and NEWS for release later.

2007-10-09  Al Riddoch  <alriddoch@zepler.org>

	* modules/EntityRef.h: Simplify the sigc++ signal used.

2007-10-01  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Make a missing config file no longer fatal,
	  as the default are now sane, and do work.

	* server/server.cpp: Fix up some error and status messages.

2007-10-01  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Make the default ruleset "mason" as basic
	  no longer exists in the default install. Remove some error
	  messages which no longer apply.

2007-10-01  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Remove the hard coded flag that used to disable
	  the database code.

2007-10-01  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Clean up an error message. Modify the logic
	  when rules aren't loaded, so the error messages make more sense.

2007-09-29  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Provide more coverage of the operation
	  error permutations, and add some verification of the type of
	  operation in the results.

2007-09-25  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Provide more coverage of the operation
	  error permutations, and add some verification of the type of
	  operation in the results.

2007-09-25  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Provide more coverage of the operation
	  error permutations, and add some verification of the type of
	  operation in the results.

2007-09-25  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Provide more coverage of the operation
	  error permutations, and add some verification of the type of
	  operation in the results.

2007-09-24  Al Riddoch  <alriddoch@zepler.org>

	* common/Add.h, rulesets/SolidProperty: Fill out some more doc
	  comments.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Pedestrian.cpp: Move a calculation into an if clause, to
	  save a few cycles.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.h, rulesets/Pedestrian.cpp, rulesets/Pedestrian.h:
	  Change the movement API so update Location is const when passed to
	  generateMove.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyManager.h, rulesets/Movement.h,
	  rulesets/Pedestrian.cpp, server/EntityFactory.h, server/Peer.cpp,
	  server/Peer.h, server/PersistantThingFactory.h, server/Player.cpp:
	  Fill out some more doc comments, and add some more FIXME notes.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Clean up formatting, and make
	  the code more readable.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Return correctly from the event log testing
	  function.

	* tools/cydumprules.cpp: Remove obsolete usage reporting function.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile, Doxyfile-python: Bring doxygen config files up to date
	  with the latest version.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile-python: Remove some obsolete python directories from
	  those scanned for documentation.

2007-09-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Define shader parameters as a map
	  of named values. Shader types and parameters are now 100% compatible
	  with the interface offered by Mercator::ShaderFactories so it should
	  no longer be necessary for clients to do lots of work discovering
	  which shaders to instance.

2007-09-18  Al Riddoch  <alriddoch@zepler.org>

	* scripts/cyphesis-setup.sh: Clarify the message when a database
	  account is found to already exist.

2007-09-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h:
	  Add storage for terrain.surfaces subproperty.

	* rulesets/mason/define_world.py: Add some surface settings to the
	  default moraf terrain.

2007-09-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/panlingua/interlinguish.py: Add the list verb.

	* rulesets/basic/mind/Goal.py: Add a __repr__() method to make it
	  more intuitive to get a text representation of a goal.

	* rulesets/basic/mind/NPCMind.py: Add a handler for the list verb
	  that causes all the matching knowledge to be listed.

2007-09-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Clean up the deer test.

2007-09-04  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp: Remove debug output.

	* client/BaseClient.h, client/BaseClient.cpp: Add a logout method
	  so that the client can be disconnected.

	* client/client.cpp: Once the client is complete, call logout to
	  ensure all messages sent to the server have been processed.
	  Logout waits for the server to acknowledge that the connection is
	  is complete.

2007-09-04  Al Riddoch  <alriddoch@zepler.org>

	* client/client.cpp: Delete the observer client once it is
	  is finished with.

	* client/ClientConnection.cpp, client/ClientConnection.h: Add
	  a method to make the socket stay around for plenty of time
	  on close to ensure all the data is sent.

2007-08-20  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMetaClient.cpp: Get rid of the header file for metaserver
	  protocol constants, as it is not consistently licensed with the rest
	  of the code.

	* server/protocol_instructions.h, server/Makefile.am: Remove the
	  obsolete metaserver protocol header from the build.

2007-08-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp: Make sure collision flag is initialised,
	  so that calls to Update are deterministic.

2007-08-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp: Initialise motion pointer to zero, so
	  so tests know whether it is there.

	* rulesets/Thing.cpp: Don't attempt to do a movement update if
	  LOC is zero. It is a sign something not quite right is going on.

	* tests/IGEntityExerciser.h: Check motion is not null before using
	  it.

2007-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h: Add an accessor for the motion object.

	* tests/IGEntityExerciser.h: Add more coverate for Set and Update
	  ops.

2007-08-01  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Don't try and refer to the entity
	  parent if the entity being tested is the world.

2007-08-01  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Treat entities with ID 0 a little
	  differently as they should be rigged up as the world for testing.

	* tests/Creatortest.cpp, tests/Worldtest.cpp: Remove the test world
	  is it is now set up in the exerciser.

2007-08-01  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Add more test coverage for operations
	  to trigger errer detection in Thing.MoveOperation.

	* tests/TestWorld.h: Add test code to allow entities to be added to
	  the test world.

2007-07-31  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Expand the operations injected into
	  IG entity classes, to try and trigger every error message.

2007-07-30  Al Riddoch  <alriddoch@zepler.org>

	* client/Py_CreatorClient.cpp, common/Database.cpp,
	  common/accountbase.cpp, common/system.cpp, rulesets/Character.cpp,
	  rulesets/Motion.cpp, rulesets/Plant.cpp, rulesets/Py_Location.cpp,
	  rulesets/Py_Mind.cpp, rulesets/Py_Operation.cpp,
	  rulesets/Py_Point3D.cpp, rulesets/Py_Statistics.cpp,
	  rulesets/Py_Task.cpp, rulesets/Py_TerrainProperty.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Py_Vector3D.cpp,
	  rulesets/Py_WorldTime.cpp, rulesets/Python_API.cpp,
	  rulesets/TerrainProperty.cpp, server/Admin.cpp,
	  server/CommServer.cpp, server/Connection.cpp,
	  server/EntityFactory.cpp, server/WorldRouter.cpp,
	  tools/cycmd.cpp, tools/cyconvertrules.cpp, tools/cyctrl.cpp:
	  Remove unnecessary () from conditional expressions, where operator
	  binding is clear.

2007-07-30  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add an activation for the combat task, as we now
	  require it.

2007-07-30  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, server/EntityFactory.h: Major overhaul of
	  error reporting when installing rules, covering many new cases, and
	  reporting errors more clearly.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/MemMap.cpp, rulesets/Motion.cpp,
	  rulesets/Python_API.cpp, rulesets/TerrainProperty.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp: Don't use camel casing for
	  local variables or function arguments.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Don't use camel casing for local
	  variables or function arguments.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* common/AtlasFileLoader.cpp, common/AtlasFileLoader.h: Fix a leaked
	  codec object.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Remove some left over debug output.
	  Fix a directory object leaked.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp, common/log.h, common/BaseEntity.cpp,
	  common/BaseEntity.h: Switch to taking a C++ string reference rather
	  than a char *, for the rest of the logging and error related
	  calls.

	* common/Database.cpp, common/log.cpp, common/log.h,
	  rulesets/PythonMindScript.cpp, server/Account.cpp,
	  server/Admin.cpp, server/Connection.cpp, server/Player.cpp,
	  tools/cyisoload.cpp: Convert over to using the new API correctly.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Add a world entity to all IG entities
	  before testing, to ensure they are apropriatly rigged up for testing.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp, common/log.h: Switch to taking a C++ string reference
	  rather than a char *, as it is not really an optimisation, and it
	  makes the code simpler to read and write.

	* client/BaseClient.cpp, client/ClientConnection.cpp,
	  common/AtlasFileLoader.cpp, common/BaseEntity.cpp,
	  common/Database.cpp, common/globals.cpp, common/id.cpp,
	  common/inheritance.cpp, common/log.cpp, common/log.h,
	  rulesets/Character.cpp, rulesets/Creator.cpp, rulesets/Entity.cpp,
	  rulesets/MemMap.cpp, rulesets/Motion.cpp, rulesets/Pedestrian.cpp,
	  rulesets/Py_Object.cpp, rulesets/Py_RootEntity.cpp,
	  rulesets/PythonMindScript.cpp, rulesets/PythonThingScript.cpp,
	  rulesets/Python_API.cpp, rulesets/Thing.cpp, server/Account.cpp,
	  server/Admin.cpp, server/ArithmeticFactory.cpp,
	  server/CommClient.cpp, server/CommListener.cpp,
	  server/CommMDNSPublisher.cpp, server/CommServer.cpp,
	  server/Connection.cpp, server/EntityFactory.cpp,
	  server/Persistance.cpp, server/Restoration.cpp,
	  server/ScriptFactory.cpp, server/TaskFactory.cpp,
	  server/WorldRouter.cpp, server/server.cpp: Convert over to using
	  new API correctly.

	* data/mason.xml: Add biomass and transient to fircone, making its
	  script obsolete:


2007-07-26  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Add a new active property handler,
	  that schedules the destruction of an entity after a timeout.

	* data/mason.xml: Add biomass and transient properties to Acorn,
	  making most of the script obsolete.

	* rulesets/mason/world/objects/plants/seeds/Acorn.py: Remove handlers
	  for eating and handling decay from the script, now that this
	  functionality is taken by properties.

2007-07-26  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Improve the
	  mechanism for identifying rules which have broken dependencies.

2007-07-24  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Remove and disable debug output.

2007-07-17  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Complete the code that populates
	  operations on a tool based on the task activations in the
	  ruleset, removing the need for world builders to synchronise
	  this data manually.

	* data/basic.xml, data/mason.xml: Remove operations from all tools
	  that only use them for activating tasks, now that this is handled
	  automatically.

2007-07-17  Al Riddoch  <alriddoch@zepler.org>

	* common/debug.cpp: Add template specialisation for dumping lists.

	* server/EntityFactory.cpp: Add part completed code for adding tool
	  operations dynamically to tools.

2007-07-17  Al Riddoch  <alriddoch@zepler.org>

	* autopackage/default.apspec.in: Explicitly enable binreloc for
	  autopackage builds.

	* server/Makefile.am, tools/Makefile.am: Link a couple more libraries
	  statically.

2007-07-16  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Fix a race condition in the code that
	  loads rules that depend on other rules.

2007-07-11  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.spec.in: Update dependencies now that rpms are included in
	  in major distributions under a slightly more sensible name.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.13

2007-07-09  Al Riddoch  <alriddoch@zepler.org>

	* scripts/cyphesis-setup.sh: Complete the database setup script
	  functionality. Clean up the output, and polish.

	* server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h: Partially specialise the non
	  persistent entity factory so we can register the persistor database
	  tables for the world object when persistence is disabled, so the
	  state of this entity can be restored.

	* server/server.cpp: Tidy up the startup output.

	* server/EntityFactory.cpp: Don't try and set up world persistence if
	  it is turned off.

2007-07-08  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove a few pointless entity scripts.

2007-07-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Cultivate.py: Add new task script for
	  cultivating plants from seed.

	* data/mason.xml: Add task class for cultivate. Add GERMINATES
	  property to all seed classes. Remove germinate operation definition
	  and trowel script.

2007-07-07  Al Riddoch  <alriddoch@zepler.org>

	* Makefile.am, scripts/cyphesis-setup.sh: Get the script for setting
	  up database working fairly smoothly.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: When processing a new task rule, check
	  that the operation and tool classes referenced have been installed.
	  If not, make the class pending on those classes.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: When moving, check if the entity has
	  LOC set. If not, print an error, and assert. This may be a
	  valid way to check for the TLVE, rather than relying on the
	  world class.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: When deleting, check if the entity has
	  LOC set. If not, print an error, and assert. This may be a
	  valid way to check for the TLVE, rather than relying on the
	  world class.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py: Don't use "with"
	  as a variable name as it is about to become a reserved word in
	  Python 2.6.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Add a temporary fix that removes the top
	  level module init file for basic/world so old installations of the
	  rulesets code don't mess up a new one.

2007-07-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Area.cpp, rulesets/Area.h, rulesets/Food.cpp,
	  rulesets/Food.h, rulesets/Line.cpp, rulesets/Line.h:
	  Remove these unused core entity classes from the build.

	* rulesets/attributes.h, server/EntityFactory.cpp,
	  server/PersistantThingFactory.cpp, server/Persistor.cpp,
	  server/Persistor.h, server/Persistor_impl.h, server/Restoration.cpp,
	  server/Restorer.cpp: Remove the unused classes above from the
	  persistence code.

	* tests/Makefile.am: Remove tests for the removed classes.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Delve.py,
	  rulesets/mason/world/tasks/Dig.py: Use the right coordinates for
	  checking position on the terrain, and abort the task if
	  there is nothing there to dig or delve.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Provide entirely data driven definitions for Cut
	  and Chop ops.

	* common/Chop.h, common/Cut.h, common/Makefile.am, common/custom.cpp,
	  common/operations.cpp, common/types.h, tests/Makefile.am,
	  tests/Tasktest.cpp, tests/allOperations.h,
	  tests/inheritancetest.cpp: Remove the hard coded Cut and Chop op
	  definitions completely from the build.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityExerciser.h, tests/Makefile.am, tests/allOperations.h:
	  Remove Delve, Dig and Mow from the tests.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Strip entity scripts off pickaxe and shovel.

	* rulesets/World.h, rulesets/World.cpp: Remove handlers used to
	  to implement pickaxe and shovel, which are now handled as tasks.

	* common/Delve.h, common/Dig.h, common/Mow.h, common/custom.cpp,
	  common/operations.cpp: Remove a bunch of operations from the build
	  which were only used to do things in an over simple hard coded way.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Delve.py: Handle delving up ice as well,
	  and make it more data driven.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: New task class for shovel.

	* rulesets/mason/world/tasks/Dig.py: Add new task script for using
	  a shovel to get piles of material like sand and mud from the ground.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: New task class for pickaxe. Remove useless script
	  from rope.

	* rulesets/mason/world/tasks/Delve.py: Add new task for using a
	  pickaxe to get rock from the terrain.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove the script for scythe as it is no longer
	  used.

	* rulesets/World.cpp: Remove mow operation from World, as this is now
	  handled by a task.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Property.h, rulesets/Py_Property.cpp,
	  rulesets/Py_TerrainProperty.cpp, rulesets/Makefile.am,
	  rulesets/Python_API.cpp: Complete implementation of terrain
	  property wrapper.

	* rulesets/mason/world/tasks/Reap.py: Check the surface to make sure
	  it is grass. Remove deubg output.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_TerrainProperty.cpp: New wrapper for terrain property.
	  Work in progress.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Property.h, rulesets/Py_Property.cpp: Add handling
	  for a Python wrapper for terrain property.

	* rulesets/TerrainProperty.h, rulesets/TerrainProperty.cpp:
	  Copy functions from World for getting information about surface
	  and height from the terrain property.

	* tests/Makefile.am: Update the linker options for the flags now that
	  the core property code references the mercator terrain library.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* modules/Location.h, rulesets/Py_BBox.h, rulesets/Py_Point3D.h,
	  rulesets/Py_Quaternion.h, rulesets/Py_Vector3D.h,
	  server/CommMDNSPublisher.cpp: Use double quotes not angle brackets
	  when including headers out of the cyphesis source tree.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Reap.py: New task to implement reaping
	  grass with a scythe.

	* server/EntityFactory.cpp: Report an error more clearly.

	* data/mason.xml: Fix a bug in the gravestone rule.

	* date/mason.xml: Add new reap task class.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h, rulesets/Character.cpp, rulesets/Character.h:
	  Strip all the negative matching out of the filter for operations
	  going from world to mind, instead only dispatch those that pass, or
	  need to be checked.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Remove some long obsolete comments.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Remove the script from cleaver as all the
	  functionality is now tasks.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Remove factory for food core base class,
	  as it is no longer used.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Remove scripts from pig and deer which are made
	  obsolete by new Slaughter task.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml, data/mason.xml: Add type information for venison
	  from deer.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Set the mass of ham to 1 by default.

	* rulesets/mason/world/tasks/Slaughter.py: Finish task for
	  slaughtering animals for meat.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Slaughter.py: Work in progress.

2007-06-30  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove the explicit class for butcher, and just use
	  the settler class. Character appearance should not be determined by
	  class.

	* data/mason.xml: Add a new slaughter task class, work in progress.

	* rulesets/mason/world/tasks/Slaughter.py: Incomplete script for
	  slaughter task.

	* rulesets/mason/define_world.py: The butcher is now an instance of
	  settler.

2007-06-28  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h, common/custom.cpp,
	  common/op_switch.h, rulesets/BaseMind.cpp, rulesets/Character.cpp,
	  rulesets/Character.h, rulesets/Thing.cpp, rulesets/Thing.h,
	  tests/EntityExerciser.h: Remove the long obsolete Action op from
	  the core code.

2007-06-28  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h, common/BaseEntity.cpp, common/BaseEntity.h,
	  rulesets/Character.cpp, rulesets/Character.h: Remove Cut operation
	  from the core code.

2007-06-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/objects/outdoor/Gravestone.py: Make sure
	  velocity is not set on skeleton parts found in a grave.

2007-06-26  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove the script from sword, as it does nothing
	  useful.

2007-06-25  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/objects/outdoor/Gravestone.py, data/mason.xml:
	  Remove the multiple gravestone classes, in favor of using style
	  to differentiate between them.

	* rulesets/mason/define_world.py: Use the new styled gravestone
	  class, and also use style to add variety to the fir trees.

2007-06-25  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h, common/op_switch.h,
	  rulesets/Character.cpp, rulesets/Character.h: Remove the chop
	  operation completely from the core code. Remove some OOG
	  operations from the world to mind filter, as they should never
	  occur.

	* rulesets/BaseMind.cpp, rulesets/Plant.cpp: Remove some obsolete
	  operation header includes.

	* tests/EntityExerciser.h: Remove Chop from the test for entity.

2007-06-22  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml, data/mason.xml: Remove inheritance from food class,
	  as food is now entirely property based.

2007-06-22  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, tools/cyaddrules.cpp,
	  tools/cyloadrules.cpp: Remove some directory walking debug output.

2007-06-22  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h, common/op_switch.h,
	  rulesets/Character.cpp, rulesets/Character.h, rulesets/Food.cpp,
	  rulesets/Food.h, rulesets/World.cpp, rulesets/World.h,
	  tests/EntityExerciser.h: Purge the burn operation from the core
	  operation handling code. One down, many still to go.

2007-06-22  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Finish installing the burn speed
	  property, now tested.

	* rulesets/Thing.cpp, rulesets/Thing.h: Remove legacy Burn operation
	  handler.

2007-06-21  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Add a new active dynamic property
	  "burn_speed" for things that can burn.

2007-06-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ActivePropertyFactory.h,
	  rulesets/ActivePropertyFactory_impl.h: Add a new type of property
	  builder than can install multiple operation handlers.

	* server/CorePropertyManager.cpp: Add a new active dynamic property
	  "biomass" for things which can be eaten, which handles the Eat
	  operation.

	* rulesets/Food.cpp, rulesets/Food.h: Remove the old Eat operation
	  handler.

	* data/basic.xml, data/mason.xml: Give all the food entity rules
	  some biomass.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version.

	* rulesets/Plant.cpp, rulesets/Plant.h: Remove the chop operation
	  handler, now completely obsolete as that functionality is done
	  by the task script.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* tools/cydumprules.cpp: Re work the rule dumper to use the ruleset
	  column more correctly.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.spec.in: Fix up the rpm spec for the new layout of config
	  files and script directories.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Ensure the basic code now omitted from
	  rulesets is distributed.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Change the type and name
	  of the ruleset list to a string.

	* rulesets/Python_API.cpp, server/EntityFactory.cpp,
	  server/server.cpp, tools/cyaddrules.cpp, tools/cydumprules.cpp,
	  tools/cyloadrules.cpp: Switch to using single ruleset config
	  variable.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Remove loading config data for inherited
	  rulesets.

	* rulesets/Python_API.cpp: Add the python path for mind code
	  manually, and only add one path for the ruleset.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/world/objects/buildings/House.py,
	  rulesets/basic/world/objects/buildings/StoneHouse.py,
	  rulesets/basic/world/objects/buildings/__init__.py,
	  rulesets/basic/world/objects/elements/Fire.py,
	  rulesets/basic/world/objects/elements/__init__.py,
	  rulesets/basic/world/objects/tools/Axe.py,
	  rulesets/basic/world/objects/tools/Bow.py,
	  rulesets/basic/world/objects/tools/Pickaxe.py,
	  rulesets/basic/world/objects/tools/Scythe.py,
	  rulesets/basic/world/objects/tools/Shovel.py,
	  rulesets/basic/world/objects/tools/Sword.py,
	  rulesets/basic/world/objects/tools/__init__.py:
	  Remove files that are no longer used from here, and have
	  been duplicated in the mason ruleset.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Remove the messy import hooks that make
	  inherited rulesets work, but screw up module reloading.

	* rulesets/acorn/mind/SkelMind.py,
	  rulesets/acorn/world/objects/Weather.py,
	  rulesets/acorn/world/objects/animals/Crab.py,
	  rulesets/acorn/world/objects/animals/Deer.py,
	  rulesets/acorn/world/objects/animals/Pig.py,
	  rulesets/acorn/world/objects/animals/Squirrel.py,
	  rulesets/acorn/world/objects/animals/Wolf.py,
	  rulesets/acorn/world/objects/buildings/FarmHouse1.py,
	  rulesets/acorn/world/objects/buildings/FarmHouse2.py,
	  rulesets/acorn/world/objects/buildings/FarmHouse3.py,
	  rulesets/acorn/world/objects/buildings/FarmStand.py,
	  rulesets/acorn/world/objects/buildings/FishShop.py,
	  rulesets/acorn/world/objects/buildings/House1.py,
	  rulesets/acorn/world/objects/buildings/House2.py,
	  rulesets/acorn/world/objects/buildings/House3.py,
	  rulesets/acorn/world/objects/buildings/House4.py,
	  rulesets/acorn/world/objects/buildings/House5.py,
	  rulesets/acorn/world/objects/buildings/Inn1.py,
	  rulesets/acorn/world/objects/buildings/Inn2.py,
	  rulesets/acorn/world/objects/buildings/ItemShop.py,
	  rulesets/acorn/world/objects/buildings/Mansion.py,
	  rulesets/acorn/world/objects/buildings/MetalShop.py,
	  rulesets/acorn/world/objects/buildings/Ruin.py,
	  rulesets/acorn/world/objects/buildings/Shack.py,
	  rulesets/acorn/world/objects/buildings/Stall.py,
	  rulesets/acorn/world/objects/buildings/Sty.py,
	  rulesets/acorn/world/objects/buildings/VacantShop1e.py,
	  rulesets/acorn/world/objects/buildings/VacantShop1w.py,
	  rulesets/acorn/world/objects/buildings/VacantShop2.py,
	  rulesets/acorn/world/objects/outdoor/Campfire.py,
	  rulesets/acorn/world/objects/plants/Tree.py,
	  rulesets/acorn/world/objects/plants/seeds/Acorn.py,
	  rulesets/acorn/world/objects/plants/seeds/Apple.py,
	  rulesets/acorn/world/objects/plants/seeds/Seed.py,
	  rulesets/acorn/world/objects/tools/Cleaver.py,
	  rulesets/acorn/world/objects/undead/Arm.py,
	  rulesets/acorn/world/objects/undead/Pelvis.py,
	  rulesets/acorn/world/objects/undead/Ribcage.py,
	  rulesets/acorn/world/objects/undead/Shin.py,
	  rulesets/acorn/world/objects/undead/Skull.py,
	  rulesets/acorn/world/objects/undead/Thigh.py,
	  rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/world/objects/Pile.py,
	  rulesets/basic/world/objects/animals/Animal.py,
	  rulesets/basic/world/objects/buildings/House.py,
	  rulesets/basic/world/objects/buildings/StoneHouse.py,
	  rulesets/basic/world/objects/elements/Fire.py,
	  rulesets/basic/world/objects/plants/Tree.py,
	  rulesets/basic/world/objects/tools/Axe.py,
	  rulesets/basic/world/objects/tools/Bow.py,
	  rulesets/basic/world/objects/tools/Pickaxe.py,
	  rulesets/basic/world/objects/tools/Scythe.py,
	  rulesets/basic/world/objects/tools/Shovel.py,
	  rulesets/basic/world/objects/tools/Sword.py,
	  rulesets/mason/world/objects/Pile.py,
	  rulesets/mason/world/objects/Weather.py,
	  rulesets/mason/world/objects/animals/Deer.py,
	  rulesets/mason/world/objects/animals/Pig.py,
	  rulesets/mason/world/objects/buildings/House.py,
	  rulesets/mason/world/objects/buildings/House3.py,
	  rulesets/mason/world/objects/buildings/StoneHouse.py,
	  rulesets/mason/world/objects/clothing/Garment.py,
	  rulesets/mason/world/objects/elements/Fire.py,
	  rulesets/mason/world/objects/outdoor/Campfire.py,
	  rulesets/mason/world/objects/outdoor/Gravestone.py,
	  rulesets/mason/world/objects/plants/Fir.py,
	  rulesets/mason/world/objects/plants/seeds/Acorn.py,
	  rulesets/mason/world/objects/plants/seeds/Apple.py,
	  rulesets/mason/world/objects/plants/seeds/Fircone.py,
	  rulesets/mason/world/objects/plants/seeds/Seed.py,
	  rulesets/mason/world/objects/tools/Axe.py,
	  rulesets/mason/world/objects/tools/Bow.py,
	  rulesets/mason/world/objects/tools/Bucksaw.py,
	  rulesets/mason/world/objects/tools/Cleaver.py,
	  rulesets/mason/world/objects/tools/Pickaxe.py,
	  rulesets/mason/world/objects/tools/Rope.py,
	  rulesets/mason/world/objects/tools/Scythe.py,
	  rulesets/mason/world/objects/tools/Shovel.py,
	  rulesets/mason/world/objects/tools/Sword.py,
	  rulesets/mason/world/objects/tools/Tinderbox.py,
	  rulesets/mason/world/objects/tools/Torch.py,
	  rulesets/mason/world/objects/tools/Trowel.py,
	  rulesets/mason/world/objects/undead/Skeleton.py,
	  rulesets/mason/world/tasks/Bisect.py,
	  rulesets/mason/world/tasks/Combat.py,
	  rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Ram.py,
	  rulesets/mason/world/tasks/Sharpen.py,
	  rulesets/mason/world/tasks/Slice.py,
	  rulesets/mason/define_world.py:
	  Convert rulesets over to inheriting from the Thing class in
	  the new non ruleset specific location.
	  
	* rulesets/basic/mind/goals/animal/domestic.py: Add file missing from
	  previous commit.

2007-06-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/trigger.py: Generic common trigger
	  goals, starting with a trigger base chase goal.

	* rulesets/basic/mind/goals/animal/domestic.py: Trigger goals specific
	  to domesticated animals, starting with goals for pig herding.

	* rulesets/basic/mind/goals/__init__.py: Add the two new files of
	  trigger goals.

	* rulesets/mason/mind/PigMind.py, rulesets/mason/mind/SkelMind.py,
	  rulesets/mason/mind/WolfMind.py, rulesets/mason/mind/__init__.py:
	  Remove special mind classes for pig, skeleton and wolf, as it
	  should be possible to do it more cleanly with trigger goals.

	* rulesets/mason/define_world.py: Add trigger goals for pig and
	  skeleton to replace the behavior that used to be in special purpose
	  mind classes.

2007-06-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Add a new directory to the python path
	  containing non ruleset specific code that is required by any
	  normal python scripts.

	* rulesets/Makefile.am: Install non ruleset specific python code
	  that was historically in common into a separate place.

	* irulesets/mason/define_world.py: Import the editor functionality
	  from the new location.

2007-06-16  Al Riddoch  <alriddoch@zepler.org>

	* data/Makefile.am: Install the xml files for mason into the mason.d
	  subdir, as the rule loading code now prefers.

	* server/EntityFactory.cpp, tools/cyaddrules.cpp,
	  tools/cyloadrules.cpp: Modify the way rule xml files are loaded
	  so files from the ruleset specific subdirectory are loaded first,
	  and the legacy way of doing it is done if this files, with a warning
	  message.

2007-06-15  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Check for dirent.h.

	* common/AtlasFileLoader.cpp: Report duplicate IDs when loading rule
	  data.

	* data/basic.xml: Remove obsolete old overriden rules, as we will
	  no longer be doing rules that way.

	* server/EntityFactory.cpp: When loading rulesets directly from
	  files, also load all files in ruleset.d.

2007-06-14  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Add some warnings when task classes linked
	  to other classes may be suspect.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Remove the tool script for the bucksaw class, as
	  we now depend entirely on task scripts for bucksaw functionality.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add a meat property to the pig class, so the
	  rules for butchering can be made more generic.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove the tool script for the axe base class, as
	  we now depend entirely on task scripts for axe functionality.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/objects/tools/Bucksaw.py: Add an error message
	  if this code gets called, as it should no longer be.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp: Add a message reporting when a rule is not
	  uploaded because it has been overridden.

2007-06-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Logging.py: Implement logging entirely
	  in the task, instead of relying on functionality in the plant
	  class.

	* rulesets/Py_Quaternion.cpp: Implement rotation method as in the
	  the wfmath class, as required for Logging.

	* rulesets/Plant.cpp: Add an error message if the old plant
	  functionality gets called.

	* rulesets/basic/world/objects/tools/Axe.py: Add an error message
	  noting that this method should not be called.

2007-05-30  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Add support for SIGINFO on BSD systems and
	  report something vaguely useful.

2007-05-30  Al Riddoch  <alriddoch@zepler.org>

	* scripts/Info.plist: Correct the syntax.

2007-05-28  Al Riddoch  <alriddoch@zepler.org>

	* server/CommUnixListener.cpp: Remove unused and misleading definition
	  for maximum unix socket address path length.

2007-05-28  Al Riddoch  <alriddoch@zepler.org>

	* scripts/Info.plist: Add package list spec.

	* scripts/gen_mac_app.sh: Use pre-created package list rather than
	  trying to generate it on the fly.

2007-05-28  Al Riddoch  <alriddoch@zepler.org>

	* scripts/gen_mac_app.sh: Script to configure cyphesis in a way
	  it just might be able to run as a Mac application.

2007-05-28  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add experimental check for some platform specific
	  libraries.

2007-05-08  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add two stubb classes for dealing with construction.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Fix the namespacing of the access system call.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Fix the check_tmp_path() function, so it is
	  actually checking the path it has been given, add an access check
	  so we detect a temporary directory that exists but does not have
	  right permissions. Fix the error reporting when both paths fail.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add a check to make sure tar takes the --mode
	  flag.

	* rulesets/Makefile.am: Use tar mode flag only if configure has
	  detected the capability.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Use find expressions to omit CVS control
	  directories from the installed python tree. Clean up the directories
	  the contain the python source during uninstall.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Revise the way python files are installed
	  so that directories are created with the right permissions,
	  ruleset names are referred to in only one place, uninstall does
	  not delete any source files which are not present in the source
	  tree, and potentially dangerous commandlines are aborted if
	  critical directories are missing.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Add options to tar to ensure that python
	  source files are installed with the right permissions.

2007-05-06  Al Riddoch  <alriddoch@zepler.org>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.12

2007-05-03  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Use the configured port number, not
	  a hard coded default when advertising the service.

2007-05-01  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Add version and help options to the usage
	  information.

2007-05-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Logging.py: Comment out broken attempt
	  at re-wrting this task and revert the original obsolete
	  implementation.

2007-04-29  Al Riddoch  <alriddoch@zepler.org>

	* tests/globalstest.cpp: Add a test covering the function that reports
	  usage information.

	* scripts/run_massif: Add a script with all the necessary arguments
	  to get meaningful results out of the valgrind massif tool.

2007-04-29  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h, common/globals.cpp: Flag the usage data for
	  cycmd and database tools. Add an additional argument to the
	  usage function for programs which take additional non-varconf
	  arguments.

	* tools/cyaddrules.cpp, tools/cycmd.cpp, tools/cydumprules.cpp,
	  tools/cyloadrules.cpp: Add usage to the rest of the tools.

	* client/client.cpp: Add additional argument usage information.

2007-04-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Make sure money transfers are only
	  detected if the NPC is not picking up the money themselves.

	* rulesets/mason/world/tasks/Logging.py: Half written broken re-write
	  of the way the logging task handles causing the tree to fall over.

	* tests/Makefile.am: Fix depencies in the tests affected by version
	  reporting code.

2007-04-28  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h, common/globals.cpp: Break option data down into
	  sections, fix scoping, and fill out most of the options used.

	* client/client.cpp: Add version and usage reporting calls.

2007-04-28  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Add interfact and mechanism
	  for showing usage data for all the programs given one central
	  location for the data.

	* server/server.cpp: Test out the usage function.

	* tools/cypasswd.cpp: Display usage using the old mechanism.

2007-04-28  Al Riddoch  <alriddoch@zepler.org>

	* commong/globals.h, common/globals.cpp: Add definitions for different
	  error codes from reading the config file, in particular codes that
	  indicate that the user has requested version, help or usage
	  information. Add a function for reporting the version of tools.

	* server/server.cpp: Add support for version or usage arguments,
	  including specific reporting of the server build number, which is
	  does not apply when reporting the version of other components.

	* tools/Makefile.am: Fix the globals modules dependency on consts.

	* tools/cypasswd.cpp: Add support for version or usage arguments.

2007-04-24  Al Riddoch  <alriddoch@zepler.org>

	* tools/cypasswd.cpp: Improve the usage documentation.

	* common/globals.cpp: Add a varconf parameter lookup to allow
	  shorthand arguments to be used to request usage information.

2007-04-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py,
	  rulesets/basic/mind/goals/common/move.py,
	  rulesets/basic/mind/goals/humanoid/construction.py,
	  rulesets/mason/define_world.py: Fix most goals so they no longer
	  require a reference to the owning mind object on initialisation,
	  meaning they are now more stateless.

2007-04-23  Al Riddoch  <alriddoch@zepler.org>

	* tests/randomtest.cpp: More thoroughly check that the random number
	  generators are producing what is expected.

2007-04-23  Al Riddoch  <alriddoch@zepler.org>

	* tests/systemtest.cpp: Cover security check function, and priority.

2007-04-23  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.h: Expose flush() method for testing.

	* common/inheritance.cpp: Improve error messages, and include
	  the operation dictionary in the data structures cleared by flush().

	* tests/logtest.cpp: Add more cases to cover the logging functions
	  for libc errno reporting.

	* tests/inheritancetest.cpp: Add many more cases to cover previously
	  untested methods, and verify everything is as it should be when
	  the class is cleared using flush().

2007-04-22  Al Riddoch  <alriddoch@zepler.org>

	* common/log.h, common/log.cpp: Expose a new function to set up the
	  event log system for testing.

	* tests/logtest.cpp: Add test cases for the event log calls.

2007-04-22  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment to new version for release one of these
	  days.

2007-04-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/move.py: Expire the accompany goal
	  used by mercenaries when the person they are working for no longer
	  exists.

2007-04-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Have the warriors for hire gather
	  up all the junk that is left around when unused characters die.

2007-04-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py,
	  rulesets/basic/mind/goals/common/move.py,
	  rulesets/basic/mind/goals/humanoid/construction.py:
	  Re-write goals relating to gathering things off the ground
	  to be clearer, more efficient, and to deal with lists of types.

	* rulesets/mason/define_world.py: Use warrior test to test gathering
	  lists of types.

2007-04-02  Al Riddoch  <alriddoch@zepler.org>

	* autopackage/default.apspec.in: Re-enable static linking of C++
	  libraries for the autopackage.

2007-04-02  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Improve error reporting when dealing with
	  persistence tables.

2007-04-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Oplist.cpp, rulesets/Py_Operation.cpp: Use the python
	  hex version, as its more reliable for comparison when setting up
	  typedefs for older python versions.

	* common/random.h: Use the C++ version of stdlib.h.

2007-03-20  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Try and be smarter about the temporary directory
	  used for logging and socket files so that it works on centrally
	  installed autopackages.

2007-03-19  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Use "basic" if no ruleset is specified in the
	  config.

2007-03-19  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Use a supported date format on Windows.

2007-01-26  Al Riddoch  <alriddoch@zepler.org>

	* tests/TestDataSet.cpp, TestDataSet.h: New class to handle a large
	  set of test Atlas data to throw at various code that accepts Atlas
	  data from the wire.

	* tests/Makefile.am: Add network libs to a unit test, so it will
	  build on platforms where gethostname is in the network libs.

2007-03-08  Al Riddoch  <alriddoch@zepler.org>

	* Makefile.am: Remove GNU echo isms.

	* rulesets/basic/mind/goals/common/move.py: Modify the pick_up_focus()
	  goal so it clears the focus. gather() now gathers things
	  indefinitely.

	* rulesets/mason/define_world.py: Add a test script for warriors to
	  gather stuff.

2007-02-20  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp: Clean up database error messages, and add
	  hint about disabling the database if this is required.

2007-02-20  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Improve the presentation of Database error
	  messages.

	* server/server.cpp: If connecting to the database fails, just
	  disable it, and report plenty of error information.

2007-02-20  Al Riddoch  <alriddoch@zepler.org>

	* data/cyphesis.vconf: Add default value for database config flag.

2007-02-20  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Add a config flag
	  to control whether database code is enabled.

	* server/EntityFactory.cpp, server/EntityFactory.h,
	  server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h, server/Persistor.cpp:
	  Re-work the persistence code so that persistent or non-persistent
	  versions of entity factories are installed at startup, removing
	  the need to check whether the database is enabled during
	  runtime.

	* common/newid.cpp, server/Connection.cpp, server/server.cpp:
	  Replace the const that used to control whether the database
	  was used with the config flag.

2007-02-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/panlingua/interlinguish.py: Add nouns for a
	  number of tools, by Max Randor.

	* rulesets/mason/define_world.py: Make many more tools available for
	  sale, by Max Randor.

2007-02-17  Al Riddoch  <alriddoch@zepler.org>

	* scripts/cyphesis-setup.sh: Add new untested script that automates
	  setting up a database account for cyphesis.

	* Makefile.am: Add a message to the end of the install output
	  informing that the setup script needs to be run to sort out
	  the database access.

2007-02-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Add function by Max Randor to
	  plant a field full of vegetables. Use it to populate the village
	  fields with carrots and turnips.

2007-02-13  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Make some of the error messages a little more verbose,
	  and consistent.

2007-02-10  Al Riddoch  <alriddoch@zepler.org>

	* autopackage/default.apspec.in: Update autopackage spec to latest
	  features.

2007-02-08  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Update all the tests to report their failure in
	  a clean and readable way, with as much information as possible
	  to help the user if they fail.

2007-02-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Don't complain about unknown tick types.

	* tools/cycmd.cpp: Use a cleaner more consistent way to identify
	  tick ops that are for this client.

2007-02-07  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: All add_agent command to specify avatar type,
	  so cycmd is usable with non-priveleged accounts.

2007-02-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.h: Remove m_world as it no longer has to mask
	  Entity::m_world.

2007-02-05  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Correct the spelling of visibility.

2007-01-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/objects/Weather.py: Add visibility to
	  the weather object, used to control the distance of the fogging.

2007-01-31  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add new visibility property to weather, and clamp
	  it to ten metres for testing.

2007-01-31  Al Riddoch  <alriddoch@zepler.org>

	* FIXME: Clearly mark the fixed ones.

	* data/mason.xml: Put a nice enormous huge bbox so its always
	  visible. Make the box non-solid for collision purposes.

	* rulesets/mason/world/objects/Weather.py: Make rain shorter on
	  average, and make the ammount of rain more variable.

2007-01-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/panlingua/interlinguish.py: Add some clothing
	  types to the vocabulary.

	* rulesets/mason/define_world.py: Add a tailor stall to the village.

2007-01-28  Al Riddoch  <alriddoch@zepler.org>

	* server/ExternalMind.cpp: Make sure hungry and starving hints only
	  make it when they apply to this character, not to others.

2007-01-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ActivePropertyFactory_impl.h: Correct the header guard
	  comments.

	* rulesets/SolidProperty.cpp, rulesets/SolidProperty.h: New property
	  to handler whether an entities bbox is solid or not.

	* rulesets/EntityPropertyFactory.cpp, rulesets/EntityPropertyFactory.h,
	  rulesets/EntityPropertyFactory_impl.h: New property factory
	  for properties the contructor of which takes an entity pointer of
	  the owning entity.

	* server/CorePropertyManager.cpp: Install the SOLID property on demand.

	* data/basic.xml: Make area entities non-solid by default, so you don't
	  collide with them.

2007-01-27  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Fix the bounding box size for the pair of boots.

2007-01-27  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Remove the hack that ensures players always
	  create a settler if they try and create a character that does not
	  exist. Handle setting initial attributes unique to player characters
	  here, rather than setting the defaults on the classes.

	* data/mason.xml: Remove initialising status to a ery low value to
	  make settlers and goblins starve easily.

	* data/basic.xml: Set the mass of a arrow to something sane.

2007-01-22  Al Riddoch  <alriddoch@zepler.org>

	* data/werewolf.xml: Fix the syntax of werewolf rule objects.

	* rulesets/Character.cpp: Document what mindSetOperation will have to
	  do once security is locked down.

2007-01-21  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Fix the creation of entities
	  as a result of the decays property so they don't get velocity
	  and bbox from the entity that spawned them.

2007-01-19  Al Riddoch  <alriddoch@zepler.org>

	* server/ExternalMind.cpp: Implement a filter point for all remote
	  controlled characters where hints and other helpful emotes can
	  be inserted. Use it to inform characters of imminent starvation.

2007-01-18  Al Riddoch  <alriddoch@zepler.org>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.11

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Fix linking tests.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Back off accidentally commited change.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp: Remove some debugging output.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Set argument names on
	  some methods. Add a new method allowing a property to be set
	  externally.

	* server/ExternalProperty.cpp, server/ExternalProperty.h: Add a new
	  property which reflects whether an entity is connected to the
	  outside world via an external mind.

	* server/Connection.cpp, server/Connection.h: Add a new method which
	  hooks up an avatar to the connection, installing an ExternalProperty
	  if necessary.

	* server/Account.cpp: Use the new Connection method to hook up
	  existing avatars.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Fix the name of character inventory items.

	* server/Connection.cpp: Stop any movement when the client
	  disconnects.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Use isDefaultFoo() rather than
	  hasAttrFlag(FOO) for brevity and readability.

2007-01-16  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Adjust the bbox on the knife like a whole load.

	* server/Account.cpp: Hack some clothes into the startup inventory.

2007-01-16  Al Riddoch  <alriddoch@zepler.org>

	* common/type_utils.h: Properlly check for Atlas data type when
	  converting data to objects.

	* tests/AllPropertytest.cpp: Enable LineProperty test now that the
	  type checking is good enough.

2007-01-15  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Make goblin playable.

2007-01-15  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am: Remove avahi libraries from the static build
	  as they create more hassle than it is worth.

2007-01-14  Al Riddoch  <alriddoch@zepler.org>

	* common/Property.cpp: Add some specialisations that are useful
	  to cover in the tests, even though we are not using them in
	  the server yet.

	* common/inheritance.h: Provide an accessor for the dictionary of
	  class objects for testing purposes.

	* rulesets/AreaProperty.cpp: Use Map() rather than isMap() once we
	  have already tested it.

	* rulesets/Entity.cpp: Remove some debug output.

	* server/CorePropertyManager.cpp: Remove some debug output.

	* tests/PropertyExerciser.h, tests/PropertyExerciser.cpp: Fill out
	  the functionality of the property tester. Add functions to get
	  random values. Use vector for value storage to make it easier
	  to generate the random values.

	* tests/AllPropertytest.cpp: Cover all the property classes we can
	  test.

	* tests/Makefile.am: Add mercator libraries to the property test,
	  as we are now testing the terrain property.

2007-01-13  Al Riddoch  <alriddoch@zepler.org>

	* tests/PropertyExerciser.cpp: Expand the coverage of the tests.

2007-01-13  Al Riddoch  <alriddoch@zepler.org>

	* tests/PropertyExerciser.cpp, tests/PropertyExerciser.h: Expand the
	  coverage of the tests.

2007-01-13  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp: Remove debug output.

	* rulesets/Character.cpp: Remove debug output.

2007-01-13  Al Riddoch  <alriddoch@zepler.org>

	* tests/PropertyExerciser.cpp: Add the required assert header.

2007-01-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_BBox.cpp, rulesets/Py_Location.cpp, rulesets/Py_Map.cpp,
	  rulesets/Py_Mind.cpp, rulesets/Py_Object.cpp,
	  rulesets/Py_Operation.cpp, rulesets/Py_Oplist.cpp,
	  rulesets/Py_Optime.cpp, rulesets/Py_Quaternion.cpp,
	  rulesets/Py_RootEntity.cpp, rulesets/Py_Task.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Py_World.cpp,
	  rulesets/Python_API.cpp: Replace calls to PyMem_DEL with calls
	  to PyObject_Free. Thanks to Kai for doing most of the digging
	  on this one.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* tests/PropertyExerciser.h, tests/PropertyExerciser.cpp:
	  New class which thoroughly exercises any property class via its
	  base interface.

	* tests/AllPropertytest.cpp: Start passing all property classes
	  through the as yet incomplete exerciser.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp: Add the connection to the entities
	  deleted signal to those to be removed when the entity is containered
	  or a garment will be connected to its wearer forever, even after
	  it has been removed.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.h, rulesets/OutfitProperty.cpp: Add
	  arguments to methods, so the owner of this property is available
	  in important parts of the code. Trigger an Update when clothing
	  is removed, so the property change is propagated.

	* rulesets/Character.cpp: Call OutfitProperty with a pointer to
	  the Character, so it knows where to send the update.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ActivePropertyFactory_impl.h: Remove debug output.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Fix my broken idea of what ISO date was supposed
	  to look like, in the logs and standard output.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Modify DECAYS Delete handler so
	  that the parent entity handles the creation of entities that
	  have resulted from the decay.

	* rulesets/Character.cpp: Call Entity::operation() from operation()
	  to ensure operation handlers are called, and all future
	  modifications get picked up too.

	* data/basic.xml, data/mason.xml: Add a DECAYS property leaving a
	  skull to all humanoid classes.

2007-01-10  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h: Add an entity pointer to the handler function
	  pointer arguments.

	* rulesets/ActivePropertyFactory_impl.h: Fix the guard comment.

	* rulesets/Character.cpp: Remove debugging output.

	* rulesets/Entity.cpp: Fix new property code so it now sets the
	  value. Improve the debug reporting when dealing with op handlers.

	* rulesets/mason/define_world.py: Test the decays property.

	* server/CorePropertyManager.cpp: Add a DECAYS property and a
	  test handler for it.

2007-01-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Oplist.cpp: Correct Python 2.5 fix to the right
	  function.

2007-01-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Oplist.cpp, rulesets/Py_Operation.cpp:
	  Fix function fingerprints so they are compatible with Python 2.5.

2007-01-09  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Implement the delete command for in game
	  entities.

2007-01-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Delete entities if their status has gone
	  below zero when an update is processed.

2007-01-08  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Set default mass on bottle entity.

	* tools/cycmd.cpp: Add help for upcoming delete command. Improve
	  readability by using available typedefs.

	* rulesets/Thing.cpp: Hide some debug output.

2007-01-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h: Fix broken doc comments on constants for
	  metabolism.

	* rulesets/Character.cpp: Switch metabolism code over to use the
	  update mechanism, to remove race conditions. Re-write the
	  math so that nothing can stay alive for ages by consuming all their
	  mass. Tune constants so a well fed character will take a month.

	* data/mason.xml: Set up goblin and settler class so that by
	  default they will starve to death in a few hours, and need to find
	  food to avoid this.

	* common/const.h: Oops. Database got disabled again by accident.
	  Turn it back on.

2007-01-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Operation.cpp: Fix formatting of comments.

	* rulesets/Py_Oplist.cpp: Adapt sequence methods to be compatible
	  with the new interface typedefs in Python 2.5

2007-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Add a mechanism to make
	  signal connection to Entity::containered single shot only.

	* rulesets/OutfitProperty.cpp: Make the connect to garments
	  containered signal single shot, to avoid having to disconnect it.

2007-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp: Remove a FIXME comment fixed in the
	  previous commit.

2007-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp, rulesets/OutfitProperty.h:
	  Add a virtual destructor, for strict correctness.

	* rulesets/Entity.cpp: Clean up variable names in destroy().
	  Moving moving contents into LOC on destruction, remove the
	  ref counts to the destroyed entity held by its contents.
	  This means Characters can now get deleted.

2007-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp, rulesets/OutfitProperty.h: Make this
	  property sigc++ trackable, and add a method to handle signals
	  indicating that the entity has been removed from the outfit.

	* rulesets/mason/define_world.py: Add a test function for messing
	  with outfit.

	* rulesets/Character.cpp: Make sure the "outfit" property really is
	  an OutfitProperty.

2007-01-04  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add Python 2.5 to the versions detected by configure.

	* rulesets/Py_Operation.cpp: Adapt sequence methods to be compatible
	  with the new interface typedefs in Python 2.5

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Character.h: Remove SEX property
	  from Character.

	* rulesets/attributes.h, server/Persistor_impl.h, server/Restorer.cpp:
	  Remove SEX property from the persistence code.

	* tests/Charactertest.cpp, tests/Creatortest.cpp: Remove SEX attribute 
	  from the tests, as it is no longer there.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Update dependencies of tests to include new
	  properties.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Get rid of a warning about a missing
	  return value.

	* tests/AtlasFileLoadertest.cpp: Fix a warning about comparing signed
	  and unsigned integers.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/AtlasProperties.cpp, rulesets/AtlasProperties.h:
	  Add 3 custom property classes used to handle very commonly
	  used properties that are hard coded in Atlas more efficiently.

	* rulesets/Entity.cpp: Use the new performance property code in
	  Entity.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/LineProperty.cpp, rulesets/LineProperty.h: Fix the
	  copyright dates with reference to the cvs log.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add rules for new garments, and set the properties
	  on existing properties so they can be worn.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.h, rulesets/OutfitProperty.cpp: Ensure that
	  removed garments or equipment get reported as empty IDs, and provide
	  a function to clean them up. Provide a direct function for adding
	  garments, without needing to go through the slower standard interface.

	* rulesets/mason/define_world.py: Add a quick hacked in test garment.

	* rulesets/Character.cpp: Implement adding OUTFIT property on demand,
	  and adding to it anything wielded that has a WORN attribute.

2007-01-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Fix dist-hook so an out-of srcdir invocation
	  of dist does not miss out all the python.

2007-01-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Creator.cpp, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/Pedestrian.cpp, rulesets/Py_Thing.cpp,
	  rulesets/Stackable.cpp, rulesets/Thing.cpp, rulesets/World.cpp:
	  Remove m_world member variable from all Entity classes, and
	  access the world manager object as a singleton.

2006-12-31  Al Riddoch  <alriddoch@zepler.org>

	* common/Type.h, physics/VectorPol.h, rulesets/Combat.cpp,
	  rulesets/Missile.h, rulesets/ThingFactory.cpp,
	  server/CommIdleSocket.cpp, tests/utilitytest.cpp:
	  Mark a bunch of files that were probably removed from the build
	  ages ago.

2006-12-31  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Replace asserts with critical error messages,
	  so tests can run without a Database connection.

	* tests/EntityPropertytest.cpp: Re-write test cases to deal with
	  modified behavoir if the Entity reference is null.

2006-12-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.h, rulesets/Thing.cpp: Make updateProperties
	  const for the time being. Only treap Update operations as
	  generic updates if they don't have a refno. Improve the
	  Update operation handler comments.

2006-12-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/EntityProperty.cpp: Modify EntityProperty so it
	  shows its value as an empty ID if it is not set to anything,
	  and clears its reference if it is set to an empty string.

	* rulesets/Character.cpp: Fix the code that handles an empty wield
	  argument, so it clears the wielded entity correctly and efficiently.

2006-12-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/attributes.h, server/Persistor_impl.h,
	  server/Restorer.cpp: Remove right_hand_wield from the
	  persistence layer, pending its complete removal.

	* rulesets/EntityProperty.h, rulesets/EntityProperty.cpp:
	  Make EntityProperty a more normal property by making it hold
	  a reference to its value, not the value itself.

	* rulesets/Character.cpp, rulesets/Character.h: Use EntityProperty
	  for right_hand_wield attribute, so it stores the value long term
	  which I think is more efficient.

2006-12-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Add some debug instrumentation to the new
	  Property update mechanism.

	* rulesets/Character.cpp: Re-write the Wield handling code to use
	  Update ops.

2006-12-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp, rulesets/Thing.h: Add a new method to
	  generate a Sight(Set) for a designated set of modified attributes.

	* ThingupdatePropertiestest.cpp: Add a test for the new method.

2006-12-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp, rulesets/OutfitProperty.h:
	  Remove the flags constructor argument, as this type of property
	  doesn't work that way.

	* server/CorePropertyManager.cpp: Add OUTFIT property to the
	  dynamic properties handled by the property manager.

2006-12-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/GuiseProperty.h, rulesets/GuiseProperty.cpp,
	  rulesets/OutfitProperty.h, rulesets/OutfitProperty.cpp,
	  rulesets/Makefile.am: Rename "guise" to "outfit" as had
	  been agreed quite a while ago on irc, but I forgot. History
	  preserved using cvs repository hackery.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am: Add buildid.cpp to the files removed by
	  distclean. Update the dependencies for buildid.cpp to include
	  ChangeLog which is used as the source of the build number.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/Makefile.am: Fix include directories to include the top
	  of the build directory in non relocatable builds, so that out
	  of directory non relocatable builds work.

	* server/Makefile.am: Exclude buildid.cpp from distributed sources
	  and from its own deps to fix some warnings and errors.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* Makefile.am: Include buildid script in the distributed sources.

	* tests/consttest.cpp: Remove buildTime and buildDate from the unit
	  test as they are now defined in server/buildid.cpp.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Add declaration for buildid, an incrementing
	  build number to give finer version tracking of development code.

	* server/ServerRouting.cpp: Add buildid to the server status
	  made available to all clients. Fix entity count in server status
	  as it wasn't fully added in the last change.

	* server/Makefile.am, scripts/gen_buildid.py: Implement buildid
	  by pulling the RCS revision number out of ChangeLog from its
	  embedded RCS Id entry.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/const.cpp: Remove build time and date, because they almost
	  never get updated here.

	* scripts/gen_buildid.py: New script to generate a source file
	  to note the build time and date.

	* server/Makefile.am: Create a new file that depends on all server
	  sources that contains the build time and data, and will contain
	  the build number.

	* server/ServerRouting.cpp: Add number of entities in the world
	  to the server info.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/GuiseProperty.cpp, rulesets/GuiseProperty.h:
	  New property class to handle guise data. I think we had decided
	  to call this property something else, but I can't remember what.

	* common/Property.h, rulesets/EntityProperty.h,
	  rulesets/LineProperty.h: Regularise argument names in property
	  classes, to make checking easier and reduce chance of mimatched
	  overriding.

2006-12-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp: Add inline documentation.

2006-12-26  Al Riddoch  <alriddoch@zepler.org>

	* client/CharacterClient.cpp, client/ClientConnection.h,
	  rulesets/Character.cpp, rulesets/Character.h, tools/cyaddrules.cpp,
	  tools/cyconfig.cpp, tools/cyconvertrules.cpp, tools/cydumprules.cpp,
	  tools/cyloadrules.cpp, tools/cypasswd.cpp:
	  Add inline documentation.

	* client/CharacterClient.h, client/CharacterClient.cpp: Remove
	  overriden sight operation handlers, as they are no longer
	  present in the base class, and will never be called.

	* client/ClientConnection.h: Remove obsolete unimplemented template
	  declaration.

	* rulesets/Entity.cpp: Remove documentation for an argument that was
	  never there.

	* tools/cyctrl.cpp: Mark as removed from the build.

	* Add a FIXME about removing hard coded gender property

2006-12-26  Al Riddoch  <alriddoch@zepler.org>

	* client/BaseClient.cpp, client/BaseClient.h,
	  client/ClientConnection.cpp, common/AtlasFileLoader.cpp,
	  common/AtlasFileLoader.h, common/BaseEntity.cpp, common/BaseEntity.h,
	  common/Property.h, common/accountbase.cpp, common/accountbase.h,
	  rulesets/ActivePropertyFactory.h,
	  rulesets/ActivePropertyFactory_impl.h, rulesets/Area.cpp,
	  rulesets/Area.h, rulesets/AreaProperty.cpp, rulesets/AreaProperty.h,
	  rulesets/BaseMind.cpp, rulesets/BaseMind.h, server/Account.cpp,
	  server/Admin.cpp, server/Admin.h, server/ArithmeticFactory.h,
	  tests/Makefile.am, tools/AdminClient.cpp, tools/AdminClient.h,
	  tools/cycmd.cpp: Add inline documentation.

	* rulesets/ActivePropertyFactory.h: Use handler function pointer
	  typedef for readability.

	* rulesets/AreaProperty.cpp, rulesets/AreaProperty.h: Fix PropertyBase
	  overriding by adding const to the right methods.

2006-12-24  Al Riddoch  <alriddoch@zepler.org>

	* client/BaseClient.h, client/Py_CreatorClient.h,
	  common/BaseEntity.cpp, common/PropertyFactory.h,
	  common/PropertyManager.cpp, common/PropertyManager.h,
	  rulesets/ArithmeticScript.h, rulesets/Py_BBox.h,
	  rulesets/Py_EntityWrapper.h, rulesets/Py_Location.h,
	  rulesets/Py_Map.h, rulesets/Py_Mind.h, rulesets/Py_Object.h,
	  rulesets/Py_Operation.h, rulesets/Py_Oplist.h, rulesets/Py_Point3D.h,
	  rulesets/Py_Property.h, rulesets/Py_Quaternion.h,
	  rulesets/Py_RootEntity.h, rulesets/Py_Task.h, rulesets/Py_Thing.h,
	  rulesets/PythonArithmeticScript.cpp,
	  rulesets/PythonArithmeticScript.h, rulesets/PythonThingScript.cpp,
	  rulesets/PythonThingScript.h, server/Account.h,
	  server/ArithmeticFactory.cpp, server/ArithmeticFactory.h,
	  server/Player.h, server/ServerRouting.cpp, server/ServerRouting.h,
	  server/TaskFactory.h: Add more inline documentation. Harmonise
	  argument names, and move documentation comments into base classes
	  as necessary.

	* FIXME: More notes on a factory related fixme.

	* TODO: Add more stuff to do.

2006-12-24  Al Riddoch  <alriddoch@zepler.org>

	* index.dox, common/BaseWorld.cpp, common/BaseWorld.h,
	  common/PropertyFactory.h, common/PropertyManager.h, common/const.h,
	  rulesets/ActivePropertyFactory.h, rulesets/Entity.h,
	  rulesets/Py_Vector3D.h, rulesets/Py_World.h, rulesets/Py_WorldTime.h,
	  rulesets/PythonMindScript.cpp, rulesets/PythonMindScript.h,
	  rulesets/PythonScript.h,
	  rulesets/PythonThingScript.h, rulesets/PythonWrapper.cpp,
	  rulesets/PythonWrapper.h, rulesets/Script.cpp, rulesets/Script.h,
	  server/ArithmeticFactory.h, server/CommServer.h, server/CommSocket.h,
	  server/ScriptFactory.cpp, server/TaskFactory.cpp,
	  server/TaskFactory.h, server/WorldRouter.cpp, tools/AdminClient.h,
	  tools/cyaddrules.cpp, tools/cycmd.cpp, tools/cyconfig.cpp,
	  tools/cydumprules.cpp, tools/cyloadrules.cpp:
	  Add a truck load of inline docs.

	* tools/cywatchdog.cpp: Mark obsolete file as removed from the build.

	* tools/cyloadrules.cpp, tools/cyconfig.cpp, tools/cyaddrules.cpp:
	  Rename some overly generic types so they have more indicative
	  and unique names.

	* FIXME, server/ScriptFactory.cpp, server/TaskFactory.h: Add a couple
	  of formal FIXMEs to sort out the code for loading modules and
	  classes.

	* rulesets/PythonThingScript.h: Remove some commented out code.

2006-12-22  Al Riddoch  <alriddoch@zepler.org>

	* server/CommClient.h, server/CommListener.h, server/CommLocalClient.h,
	  server/CommMDNSPublisher.h, server/CommMaster.h,
	  server/CommMetaClient.h, server/CommPSQLSocket.h,
	  server/CommPeer.h, server/CommPeerListener.h,
	  server/CommRemoteClient.h, server/CommServer.h,
	  server/CommSlaveClient.h, server/CommSlaveListener.h,
	  server/CommSocket.cpp, server/CommSocket.h,
	  server/CommUnixListener.h: Add a documentation group for socket
	  classes.

	* rulesets/Py_BBox.h, rulesets/Py_EntityWrapper.h,
	  rulesets/Py_Location.h, rulesets/Py_Map.h, rulesets/Py_Mind.h,
	  rulesets/Py_Object.h, rulesets/Py_Operation.h,
	  rulesets/Py_Oplist.h, rulesets/Py_Optime.h, rulesets/Py_Point3D.h,
	  rulesets/Py_Property.h, rulesets/Py_Quaternion.h,
	  rulesets/Py_RootEntity.h, rulesets/Py_Task.h, rulesets/Py_Thing.h,
	  rulesets/Py_Vector3D.h, rulesets/Py_World.h, rulesets/Py_WorldTime.h,
	  rulesets/Python_API.cpp: Add documentation group for Python wrapper
	  types.

	* rulesets/Container.h, rulesets/PythonScript.cpp,
	  server/ScriptFactory.h, server/ScriptFactory.cpp:
	  Add more inline documentation comments.

2006-12-19  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Re-enable database for accounts and rules.

	* data/mason.xml: Make loaf inherit from food.

2006-12-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Script.cpp, rulesets/Structure.cpp:
	  Add some inline documentation.

2006-12-12  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile: Add tools to the documented code.

	* index.dox: Update documentation index.

	* tools/cycmd.cpp: Add a document page for this tool.

	* common/DynamicProperty.h, common/Property.cpp, common/Property.h,
	  rulesets/AreaProperty.h, rulesets/CalendarProperty.h,
	  rulesets/EntityProperty.h, rulesets/LineProperty.h,
	  rulesets/StatisticsProperty.h, rulesets/TerrainProperty.h:
	  Add all property classes into a property group.

2006-12-12  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version.

	* common/const.h: Declare a doxygen group for all the consts.

	* common/operations.cpp, common/Add.h, common/Attack.h, common/Burn.h,
	  common/Chop.h, common/Connect.h, common/Cut.h, common/Delve.h,
	  common/Dig.h, common/Drop.h, common/Eat.h, common/Monitor.h,
	  common/Mow.h, common/Nourish.h, common/Pickup.h, common/Setup.h,
	  common/Tick.h, common/Unseen.h, common/Update.h:
	  Declare a doxygen group for all custom operations.

	* rulesets/Area.h, rulesets/Character.h, rulesets/Creator.h,
	  rulesets/Entity.h, rulesets/Food.h, rulesets/Line.h,
	  rulesets/Missile.h, rulesets/Plant.h, rulesets/Stackable.h,
	  rulesets/Structure.h, rulesets/World.h: Declare a doxygen group
	  for in game entity classses.

	* common/Property.h, common/Property_impl.h, server/ScriptFactory.cpp,
	  server/ScriptFactory.h, server/SlaveClientConnection.cpp,
	  server/SlaveClientConnection.h: Add some more inlined documentation.

2006-12-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Container.cpp, rulesets/Container.h: Document some
	  methods.

2006-12-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Container.h, rulesets/Stackable.cpp, rulesets/Stackable.h,
	  rulesets/Statistics.cpp, rulesets/Statistics.h,
	  rulesets/StatisticsProperty.cpp, rulesets/StatisticsProperty.h,
	  rulesets/TaskScript.cpp, rulesets/TaskScript.h, server/TaskFactory.h:
	  Add inline documentation.

2006-12-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Entity.h, rulesets/Task.h,
	  rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/TrustedConnection.cpp,
	  server/WorldRouter.cpp: Add inline documentation.

2006-12-08  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am: Remove unused header from the build.

2006-12-07  Al Riddoch  <alriddoch@zepler.org>

	* debugtest.cpp: Add a test for debug macro, and atlas dump function.

	* common/debug.cpp: Tweak the indenting when outputting map items
	  in a list.

2006-12-07  Al Riddoch  <alriddoch@zepler.org>

	* tests/OOGThingtest.cpp: Fill out unit tests for constructor,
	  destructor and others.

2006-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/accountbase.h: Fix the destructor so it does not assume the
	  database has been initialised.

	* accountbasetest.cpp: Add a minimal unit test for accountbase.

2006-12-06  Al Riddoch  <alriddoch@zepler.org>

	* tests/idtest.cpp: Add a unit test for the ID conversion functions
	  in common/id.cpp.

2006-12-06  Al Riddoch  <alriddoch@zepler.org>

	* tests/Databasetest.cpp: Add a unit test for the features of
	  Database that can be checked without an RDBMS to connect to.

	* common/Database.h, common/Database.cpp: Provide a function to
	  cleanup the Database singleton, for easier testing.

	* common/Database.cpp: Assert that the connection to the database
	  has been created before calling any functions in the database
	  client lib using that connection.

2006-12-06  Al Riddoch  <alriddoch@zepler.org>

	* tests/BaseWorldtest.cpp: Add a comprehensive unit test for all
	  non virtual parts of the BaseWorld class.

2006-12-06  Al Riddoch  <alriddoch@zepler.org>

	Changes submitted by Kai Blin  <kai.blin@gmail.com>

	* data/mason.xml: Grow the gateway so it fits into the castle wall.

	* rulesets/mason/define_world.py: Add the castle peninsula.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Add prefix.o to one test, or it fails to link
	  if binreloc is enabled.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/AtlasFileLoadertest.cpp, tests/AtlasFileLoadertest.h:
	  Add assert header include as required by some compilers.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityExerciser.h: Fill out the functionality to include tests
	  for the virtual functions that convert an entity into Atlas data.

	* tests/BaseEntitytest.cpp: Use the extended EntityExerciser, and
	  cover all the non-virtual functions in BaseEntity.

	* tests/AtlasFileLoadertest.cpp: Add a test for the file loader
	  class.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* client/Makefile.am, tests/Makefile.am: Add top_buildir to includes,
	  to get config.h in an out-of-tree build.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* OperationExerciser.cpp, OperationExerciser.h: Template class to
	  exercise and test custom operation classes.


	* Attacktest.cpp, Burntest.cpp, Choptest.cpp, Connecttest.cpp,
	  Cuttest.cpp, Delvetest.cpp, Digtest.cpp, Droptest.cpp,
	  Eattest.cpp, Monitortest.cpp, Mowtest.cpp, Nourishtest.cpp,
	  Pickuptest.cpp, Setuptest.cpp, Ticktest.cpp, Unseentest.cpp,
	  Updatetest.cpp: Use OperationExerciser on all current custom op
	  classes.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityPropertytest.cpp: Add a complete set of unit tests for
	  EntityProperty.

	* rulesets/EntityProperty.cpp: Fix and instrument the code based
	  on the findings from the unit test.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityReftest.cpp: Expand the unit tests to completely cover
	  the EntityRef class.

2006-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/EntityProperty.cpp, rulesets/EntityProperty.h: Add a
	  property class that handles a weak reference to another entity.

2006-12-04  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.cpp, common/BaseWorld.h: Add instance method, so
	  code anywhere can get a pointer to the world.

2006-12-04  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h: Add a first attempt at defining what kind of result
	  should be returned by operation handler functions.

	* rulesets/mason/define_world.py: Add a test function for testing
	  attachments, and the active property mechanism.

2006-12-04  Al Riddoch  <alriddoch@zepler.org>

	* modules/EntityRef.cpp, modules/EntityRef.h: Add a new class to handle
	  a weak reference to an Entity.

	* tests/EntityReftest.cpp: Test the weak reference class.

2006-12-03  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h: Add a function pointer type, and related
	  typedefs for functions which handle an operation.

	* rulesets/Entity.cpp, rulesets/Entity.h: Add a map of operation
	  handlers so that any operation type can be handled by data
	  defined handlers.

	* rulesets/ActivePropertyFactory.cpp, rulesets/ActivePropertyFactory.h,
	  rulesets/ActivePropertyFactory_impl.h: Add a new type of property
	  factory, which installs a handler when the property is added to
	  an entity.

	* server/CorePropertyManager.cpp: Test out the new property factory
	  and handler mechanism with a new property called "attachment".

2006-11-05  Al Riddoch  <alriddoch@zepler.org>

	* tools/Makefile.am: Add the network libraries to cypasswd as they
	  are needed on some platforms for gethostname.

	* tests/Makefile.am: Ensure the tests link correctly.

	* tests/Creatortest.cpp, tests/Charactertest.cpp: Remove test for
	  drunkness property, as it has been removed from the Character
	  entity class.

2006-11-05  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp: Leave out local connection functionality
	  on systems that don't have unix sockets.

2006-11-03  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add check for arpa/inet.h header.

	* server/CommListener.cpp: Include arpa/inet.h if available, for
	  inet_ntop.

	* server/CommUnixListener.cpp: Include common/system.h to get
	  closesocket().

2006-11-03  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add tests for more optional functions and headers.

	* client/ObserverClient.cpp: Use alternative on systems which don't
	  have usleep().

	* common/system.cpp: Implement gettimeofday for systems which don't
	  have it.

	* server/CommListener.cpp: Add a note about supporting alternatives
	  to inet_ntop.

	* server/CommUnixListener.cpp, server/server.cpp: Disable the unix
	  listen socket on systems which don't have it.

	* tests/systemtest.cpp: Fix the test to work on systems without fork()
	  or kill(), and add a test for the substitute gettimeofday
	  implementation.

2006-11-01  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp, server/CommPeerListener.cpp,
	  server/CommUnixListener.cpp:
	  Use closesocket to close sockets, so that it works on systems
	  which do not use the same namespace for files and sockets.
	  Use typedefs provided by skstream to ensure platform neutral
	  handling of socket related types. Disable code that stores
	  presentation version of client address on systems which don't
	  have inet_ntop.

	* server/CommServer.cpp: Use skstream to get the right header
	  for select system call, and use skstream typedefs.

	* server/WorldRouter.cpp: Use common/system.h to get getimeofday
	  on systems which don't provide it.

2006-11-01  Al Riddoch  <alriddoch@zepler.org>

	* common/system.h: Add prototypes for required C library functions
	  we implement on systems where they are missing.

	* common/system.cpp: Adapt the system specific code for systems
	  which are missing libc functions are system calls, including
	  uname, getuid, nice, fork, kill and some of the signals.

2006-11-01  Al Riddoch  <alriddoch@zepler.org>

	* common/log.h, common/log.cpp: Some systems have defines in their
	  headers which conflict with cyphesis log levels, so make sure they
	  are undefed before the enum, and add more tightly namespaced
	  versions for files which need those headers. Adapt the logging
	  code for systems without syslog() or reentrant localtime().

2006-11-01  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add checks for functions and headers that may or may
	  not exist on more obscure systems. Relax some tests so that they
	  only warn if they fail, as they may not be fatal.

2006-10-29  Al Riddoch  <alriddoch@zepler.org>

	* acinclude.m4: Add AM_PATH_GCRYPT macro so that less errors occur.

2006-10-26  Al Riddoch  <alriddoch@zepler.org>

	* Add RCS Id keywords to every file, for better version tracking.

2006-10-26  Al Riddoch  <alriddoch@zepler.org>

	* common/Makefile.am, server/Makefile.am: Remove a couple of obsolete
	  headers from the build.

2006-10-24  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Clean up output of the two MDNS service discovery
	  libraries, so it is obvious what has happened when the checks fail.

2006-10-24  Al Riddoch  <alriddoch@zepler.org>

	* man/Makefile.am: Add rules to create man pages for every command,
	  which refer to the combined pages for all commands.

	* man/cyaddrules.1, man/cyconvertrules.1, man/cydumprules.1,
	  man/cyloadrules.1, man/cypasswd.1: Generate new pages as described
	  above.

	* man/cycmd.sgml: Fix argument name in cycmd man page.

	* man/cyclient.1, man/cycmd.1, man/cycmd.sgml, man/cyphesis-tools.1,
	  man/cyphesis.1: Re-generate existing man pages.

	* common/PropertyFactory.h, common/PropertyFactory_impl.h: Pass in
	  pointer to the entity when creating a new property using the
	  factory.

	* server/CorePropertyManager.cpp: Make sure the entity pointer is
	  passed to the property factory as required.

2006-10-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Add doc strings to some key methods.

2006-10-21  Al Riddoch  <alriddoch@zepler.org>

	* acinclude.m4: Update pkgconfig macros to more efficient later
	  versions.

	* configure.ac: Use newer pkgconfig macro to check for pkgconfig
	  first.

2006-10-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Clean out unused keyword handling in debug
	  functions, fix code to comply with style. Ensure debug calls have
	  minimal cost if debugging is disabled.

2006-10-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Add debug hooks for the python API, to
	  help debug scripts.

2006-10-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Add doc strings to a number of
	  functions.

2006-10-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h, rulesets/Character.cpp: Remove hacky
	  hardcoded drunkness implementation.

	* rulesets/attributes.h, server/Persistor_impl.h, server/Restorer.cpp:
	  Remove persistence hooks for drunkness.

2006-10-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Block attempts at admin operations from the
	  mind interface, and therefore the client.

2006-10-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/dynamic/DynamicGoal.py:
	  Add a doc string to the class.

2006-09-26  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version number.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.10

2006-09-26  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.init: Fix the options for scripts that create postresql
	  accounts and database, so they don't block expecting interaction
	  from the user.

2006-09-24  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add check for poll system call, as it would probably
	  bast to implement poll, making select a worst case fallback
	  option.

2006-09-24  Al Riddoch  <alriddoch@zepler.org>

	* common/log.h, common/log.cpp: Add a new function to rotate
	  the logs, eliminate duplicate code by breaking out log opening
	  code into a static function.

	* common/system.cpp: Add a HUP system call handler to rotate the logs.

2006-09-20  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: When creating a daemon, create the new session
	  earilier, and change current working directory to / to ensure the
	  daemon does not interfere with the system.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Add FIXME notes about appear/disappear
	  generating code.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp, server/CommUnixListener.cpp: Clean up
	  the code layout a little.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp, server/CommUnixListener.cpp:
	  Re-write isOpen() to use the is_open method of the overlying
	  socket object, rather than always returning true. This issue may
	  never arise, but it ensures that all socket objects should
	  return isOpen() == false before they return -1 as a socket fd,
	  which prevents memory corruption in the select code.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp: Remove hardcoded value for the
	  maximum path length for a unix socket, and use the size of
	  the data structure member instead. This fixes an issue caused
	  by the behavoir of strncpy on MacOSX.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Re-write isOpen so that it checks
	  the socket fd is not -1.

2006-08-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Change the entity_new constructor used
	  by define world scripts so that it takes an optional "pos" argument
	  rather than the long obsolete "xyz".

	* rulesets/mason/define_world.py, rulesets/werewolf/define_world.py:
	  Modify the most relevant define_world scripts to use the changed API.

	* rulesets/basic/mind/goals/common/move.py: Remove a long obsolete
	  commented out debug line.

2006-08-30  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp: Don't include config.h, as this file doesn't
	  use anything from it.

2006-08-24  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version number.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.9

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp, client/ClientConnection.cpp: Re-work poll()
	  methods in client code that call select(2), so that they don't
	  ignore errors, or get stuck waiting for data that has not yet
	  arrived by doing so.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h, rulesets/Character.cpp, common/op_switch.h:
	  Ensure that unseen operations are passed to the mind.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: When calling select while waiting for user input,
	  don't specify a timeout for select, as no timing is occuring in
	  the program.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Check the return value of select, and only check
	  file descriptors if an error has not occured.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* tests/distancetest.cpp: Add assertions to distance test that
	  ensure correct behavoir.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Quaternion.cpp: Rename valid() method to is_valid()
	  for API consistency.

	* rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py: Update scripts to the changes
	  API.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: In Python Entity constructor, tighten
	  up checks so exceptions are thrown for initialisers of the wrong
	  type. Convert xyz sequence more directly to C++ vector for
	  efficiency.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Object.cpp: Avoid calling python list length
	  function every loop iteration, for efficiency.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_RootEntity.cpp: Add more warnings if strange types
	  are set as attributes.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Object.h, rulesets/Py_Object.cpp: Remove redundant
	  functions from the header, and make them static. Add a flag to
	  conversion function, to specify the function should return
	  early if the result will be a map or a list.

	* rulesets/Py_Mind.cpp: Indicate that converted python objects
	  being used to set attributes should only be converted to non
	  sequence data, to avoid the wasted copy and conversion.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_RootEntity.cpp: Simplify the check for unconvertible
	  values.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Mind.cpp: Put back restriction on map and list
	  attributes on mind, and force them to be handled as native
	  python objects.

2006-08-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Ensure operation_new return value is set
	  to null if an exception is generated in addToArgs().

2006-08-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_BBox.cpp, rulesets/Py_Statistics.cpp,
	  rulesets/Python_API.cpp: Replace calls to the cyphesis log
	  system with Python exceptions.

	* rulesets/Py_Mind.cpp: Accept map and list atlas attributes on
	  the mind object.

	* rulesets/Py_Property.cpp: Improve the wording of some log messags.

	* rulesets/Py_RootEntity.cpp: Assert that attributes work correctly.

	* rulesets/Plant.cpp: Add FIXME about an issue with plants eating
	  people.

2006-08-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Fell.cpp: Exclude from the build, and doxygen.

2006-08-14  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: Only call idlers once every second, and
	  still only when the server is not busy of congested with network
	  traffic.

2006-08-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h, rulesets/Character.cpp: Re-write 
	  findInInventory to recurse into inventory containers.

2006-08-09  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Add a further customisation to the prompt so it
	  shows the type of server being connected to.

	* TODO: Add a note about a possible re-work of the database
	  world persistence model.

2006-08-09  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Customise the prompt so it indicates the
	  name of the server connected to, the username authenticated
	  and the privelege level.

2006-08-08  Al Riddoch  <alriddoch@zepler.org>

	* tests/type_utilstest.cpp: Expand tests to cover lists of
	  vectors and quaternions, and confirm the resultings lists contain
	  objects with the right value.

2006-08-08  Al Riddoch  <alriddoch@zepler.org>

	* client/CharacterClient.cpp: Remove pointless class scope when
	  acessing member variable.

	* tools/cycmd.cpp: Don't wait forever for responses from the
	  server to commands.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp, server/CommClient.cpp: Clarify the
	  error messages about non operation objects on the wire, and
	  use the same messages in the client.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Delete all the property
	  factories on shutdown, to keep the memory usage clean.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Rename some variables to clearer meanings.
	  Only send confirmation of subscription on entity creation if
	  the entity created is a character. Otherwise it is still created,
	  and can be manipulated, but not directly controlled by the
	  client.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Only add initial inventory items if the entity
	  being created is a character. Add some comments.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.h, server/Connection.cpp: Change disconnectObject
	  to removePlayer to make it clearer what the return value means,
	  and return a pointer to the removed object if it is a player account.

	* server/Connection.cpp: When removing an account which has been
	  logged out, remove all its characters which are not currently in
	  use from the connections list.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommSlaveClient.cpp, server/CommSlaveClient.h: Require an
	  ID to be passed into the constructor for a slave connection.

	* server/CommSlaveListener.cpp: Generate an ID for client connections
	  to a slave server, and pass it into the CommSlaveClient constructor.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/slave.cpp: Remove duplicate line added accidentally.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: Remove FIXME and replace with comments
	  explaining the choice of value for epoll_create(). Check if
	  epoll_wait is returning the maximum events possible, so we know
	  if we should enlarge the array.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Report a warning if avahi frees
	  a watch data structure, which is currently not implemented.
	  Move checks on the event type avahi requires to the callback
	  called by avahi, so it is only checked once. Ensure that no
	  events are flagged once the events have been processed.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp: Report socket errors when accepting a
	  new connection.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Admin.cpp: Remove obsolete FIXME.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommClient.cpp: Fully report the parent and objtype of
	  spurious objects received on the network.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Report an error if a logout is received by
	  an account which is not connected.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.h, server/Connection.cpp: Move the code that
	  decouples an object from the subscribed connection into its
	  own function, so the same code is invoked from two different
	  places.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: More thoroughly and accuratly report the
	  failure if epoll doesn't work.

2006-08-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Raise.py: Move the check which ensures
	  that task is not attempting to move the world is placed earlier.
	  Add a check that the item being affected is non-zero distance from
	  the character, ensuring the rotation maths don't give weird errors.
	  A recently commited fix to wfmath should ensure that corruption
	  does not occur again, but this check is still a good idea.

2006-08-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Expose wfmath's epsilon as a const value
	  to python.

	* rulesets/Py_Point3D.cpp: Expose isValid() method on WFMath::Point<3>
	  to python.

	* tests/distancetest.cpp: Add test to confirm that distanceTo
	  determines distance to inventory items correctly.

2006-08-03  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp: Ensure that that world does not obtain
	  position or orientation when being restored from the database.

2006-08-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Fix the size of the world bbox
	  being set when terrain is defined.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* scripts/compile_python.py: Add a new script which compiles python
	  files.

	* cyphesis.spec.in: Modify spec to compile installed python
	  scripts, and remove original source for runtime performance
	  and compact package size.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile-python: Add a new doxyfile for building separate docs
	  for the python scripts.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* common/Use.h, common/Wield.h, common/Generic.h: Mark unused files
	  as removed from the build.

	* common/Attack.h, common/Burn.h, common/Chop.h, common/Connect.h,
	  common/Cut.h, common/Delve.h, common/Dig.h, common/Drop.h,
	  common/Eat.h, common/Monitor.h, common/Mow.h, common/Nourish.h,
	  common/Pickup.h, common/Setup.h, common/Tick.h, common/Unseen.h,
	  common/Update.h: Add class documentation to all the custom
	  properties.

	* common/DynamicProperty.h, client/ClientPropertyManager.h,
	  server/CorePropertyManager.h, server/PersistantThingFactory.h,
	  server/ScriptFactory.h, server/WorldRouter.cpp: Add documentation
	  to some places where it is missing.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp: Modify Burn to inherit from Affect, as it is
	  is not a pure action.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile, client/define_world.cpp, client/define_world.h,
	  common/CustomOp.cpp, common/CustomOp.h, common/CustomOp_impl.h,
	  common/Load.h, common/Save.h, common/inheritance_impl.h,
	  common/operations.h, common/refno.h, common/utility.cpp,
	  common/utility.h, rulesets/Combat.h, rulesets/Entity_getLocation.h,
	  rulesets/Fell.h, rulesets/MemMap_methods.h, rulesets/Py_Optime.cpp,
	  rulesets/Py_Optime.h, rulesets/ThingFactory.h,
	  server/CommIdleSocket.h, server/ServerRouting_methods.h,
	  tools/Formatter.cpp, tools/Formatter.h, tools/cydbload.cpp,
	  tools/cyisoload.cpp: Make doxygen skip code that has been removed
	  and is just left in cvs for reference.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: If Look op is from something that can't be
	  found, report an error rather than carrying on.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp, rulesets/World.h, rulesets/mason/define_world.py:
	  Remove the special handling of Set ops in world which prevented
	  setting status below zero from generating a Delete op. Add a test
	  function to define_world which attempts to destroy the world by
	  setting its status to -1.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h, rulesets/Character.h, rulesets/Character.cpp:
	  Add Update to the poll op handlers in the world2mind interface,
	  removing the special case.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h: Remove all ops but Create, Delete, Move and
	  Set from the sub op switch used in mind code.

	* rulesets/BaseMind.cpp, rulesets/BaseMind.h: Remove vast virtual
	  perception handling interface as overriding is now handled centrally
	  and base mind only handles 4 sub types of sight.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp, rulesets/Character.h,
	  rulesets/Character.cpp: Remove now empty operation methods.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp, rulesets/Character.cpp, rulesets/Food.cpp,
	  rulesets/Plant.cpp, rulesets/Stackable.cpp, rulesets/Thing.cpp:
	  Remove script override calls from the individual C++ operation
	  methods, as script overrides are now done centrally.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp: Remove script override calls from the
	  individual C++ operation methods, as script overrides are
	  now done centrally.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Add a override of
	  BaseEntities operation() method which handles calling
	  script operation handlers directly, rather than relying
	  on the C++ handlers to check for them later.

	* rulesets/Character.cpp, rulesets/BaseMind.cpp: Check for script
	  operation handlers centrally in Character and BaseMind too.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: Use class numbers rather than names to
	  determine operation handler.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp: Move all script overrides so the override
	  and are called before the mind checks to see if the character
	  is awake.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Add script hooks to Wield and Nourish
	  handlers.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Move the script hook for Character
	  to the beginning of the Tick op handler.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Don't call upper_bound in a loop
	  as it is return by value, and expensive to call.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Add script override code to the
	  imaginary and talk operation handlers.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* common/debug.h: Add a macro to print out function name when
	  debugging.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: Add checks that operations have the class
	  number expected, so that this section can be converted to work on
	  class numbers.

2006-07-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Moved increment on m_seq to later in the
	  function, to make sure its only incremented when the entity
	  has really been updated. Scripts will be required to update
	  now.

2006-07-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Thing.cpp, rulesets/Thing.h:
	  Move Look and Create handlers into Thing from Entity, so Entity is
	  a more abstract for all IG entities.

2006-07-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.h, rulesets/Thing.cpp, rulesets/Plant.h,
	  rulesets/Plant.cpp: Remove SetupOperation from Thing
	  and implement in Plant, as not all entities need a starting
	  tick, but plants do.

	* rulesets/basic/world/objects/elements/Fire.py,
	  rulesets/mason/world/objects/Weather.py: Add setup_operation
	  handlers as these scripts require ticks.

2006-07-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Remove Appearance from SetupOperation
	  in Character too.

2006-07-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp, server/WorldRouter.cpp: Remove broadcasting
	  an appearance from Setup handlers, and put it WorldRouter when
	  the entity is added to the world, to take out the special case
	  from the Setup operation handler.

2006-07-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Add note about updating m_seq in SetOperation
	  Correct function name in an error message.

2006-07-19  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Make coin inherit from stackable.

	* rulesets/Character.cpp, rulesets/Stackable.cpp: Add debug output
	  to new combine op handlers.

2006-07-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Stackable.cpp: Report an error if a divide op has
	  args with the wrong ID.

	* rulesets/Character.h, rulesets/Character.cpp: Add function
	  to check if an entity is in the characters inventory.

	* rulesets/Character.cpp: First pass at implementing filters
	  for combine and divide ops from the client.

2006-07-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Stackable.cpp: Fix some bugs and finish implementing
	  combine and divide on stacked entities.

2006-07-13  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Use != for logical exclusive or on bools.

	* physics/Collision.cpp: Re-write complete excluseive or
	  implementation and replace with !=.

2006-07-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp, rulesets/MemMap.cpp, rulesets/MemMap.h:
	  Remove commented out lookId code. Re-write findByLocation to
	  require a type as well, and use a more efficient search to find
	  the entities requested.

	* rulesets/Py_Map.cpp: Re-write find_by_location wrapper to handle
	  the extra type argument.

	* rulesets/basic/mind/Memory.py: Re-write recall_place so that
	  type and radius are now required, and make sure all types listed
	  are checked for.

	* rulesets/basic/mind/goals/common/move.py: Check if recall_place
	  has returned anything at all.

2006-07-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/MemMap.h, rulesets/MemMap.cpp: Replace lookId() with
	  sendLooks() which sends a look to all required entities in
	  one batch more efficiently.

	* rulesets/Py_Map.cpp: Remove bindings for Map.look_id, as its not
	  used.

	* rulesets/BaseMind.cpp: Use MemMap.sendLooks() instead of
	  MemMap.lookIds() to look at the world.

2006-07-11  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Use the flag check to see if TO is set on
	  an operation, rather than checking if TO is empty.

2006-07-11  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h: Remove opEnumerate
	  method as its now a trivila call to another method.

	* rulesets/BaseMind.cpp, rulesets/Character.cpp, rulesets/Creator.cpp:
	  Replace calls to opEnumerate with direct calls to getClassNo().

2006-07-10  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Improve test
	  for task classes by checking if the class parent has already been
	  installed as a class.

2006-07-10  Al Riddoch  <alriddoch@zepler.org>

	* tests/Fell.cpp: Remove obsolete FIXME.

2006-07-10  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Implement improved error reporting.
	  Remove related FIXMEs.

2006-07-10  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp: Implement improved error reporting.
	  Remove related FIXMEs.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Re-order checks for increased robustness.
	  Add more error reports.

	* server/CommMDNSPublisher.cpp: Remove a redundant FIXME.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Use class number to check for delete ops.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp, server/WorldRouter.h: Remove now obsolete
	  object list.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.h, server/WorldRouter.cpp: Re-write the way
	  broadcasts are handled, so the code is cleaner, and non
	  perception operations are properlly broadcast without the
	  need to store an explicit list of all entities in the world.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Re-write check for broadcast op types to
	  use numeric class number instead of string parents.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Remove undocumented FIXME.

	* server/WorldRouter.cpp: Move an assert into a better place
	  where it covers more.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Remove obsolete FIXME about feature already
	  implemented.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Creator.cpp, server/WorldRouter.cpp,
	  server/WorldRouter.h: Remove obsolete code to handle omnipresent
	  entities.

	* common/const.h: Remove obsolete flag enabling omnipresent
	  entities.

	* tests/consttest.cpp: Remove test for omnipresent flag.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Remove obsolete config option to disable
	  range checks and calculations.

	* client/ObserverClient.cpp, rulesets/Movement.cpp,
	  server/Admin.cpp, tools/AdminClient.h, tools/cycmd.cpp:
	  Remove const.h from files which no longer require it.

	* rulesets/Python_API.cpp: Remove python bindings for obsolete
	  constants.

	* rulesets/Thing.cpp, rulesets/World.cpp, server/WorldRouter.cpp:
	  Remove obsolete rotten code for handling sight without ranges.

	* tests/consttest.cpp: Remove tests for removed constants.

2006-07-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/LineProperty.h: Remove obsolete FIXMEs.

2006-07-07  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Remove FIXME about nice option which has already
	  been implemented.

2006-07-07  Al Riddoch  <alriddoch@zepler.org>

	* common/AtlasFileLoader.cpp, common/AtlasFileLoader.h: Modify
	  the class so that fundamentally it can handle any atlas codec.

2006-07-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp: Remove debug output.

	* server/CorePropertyManager.cpp: Remove more debug output.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* Release 0.5.8

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Add a missing header.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h, tests/TestPropertyManager.cpp,
	  tests/TestPropertyManager.h: Add a dummy property manager, and
	  install it before testing any IG entity classes.

	* tests/Areatest.cpp, tests/Charactertest.cpp,
	  tests/Creatortest.cpp, tests/EntityFactorytest.cpp,
	  tests/Entitytest.cpp, tests/Foodtest.cpp, tests/IGEntityExerciser.h,
	  tests/Linetest.cpp, tests/Planttest.cpp, tests/Stackabletest.cpp,
	  tests/Structuretest.cpp, tests/Thingtest.cpp, tests/Worldtest.cpp: 
	  Switch to new hasAttr getAttr setAttr method names.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyManager.cpp: When the PropertyManager is deleted,
	  set the instance variable to 0.

	* server/EntityFactory.cpp, server/EntityFactory.h: Add a destructor
	  so the property manager can be deleted at shutdown.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientPropertyManager.cpp, client/ClientPropertyManager.h:
	  Fix formatting and remove obsolete typedefs.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* client/Py_CreatorClient.cpp, rulesets/Character.cpp,
	  rulesets/Entity.cpp, rulesets/Entity.h, rulesets/Food.cpp,
	  rulesets/Pedestrian.cpp, rulesets/Plant.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Thing.cpp, server/WorldRouter.cpp:
	  Rename Entity members get(), set() and has() to getAttr(), setAttr()
	  and hasAttr().

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientPropertyManager.cpp, client/ClientPropertyManager.h:
	  A new class as a dummy property manager for the client side.
	  Never creates property objects.

	* client/client.cpp: Instantiate the client property manager
	  during client initialisation.

	* server/EntityFactory.cpp: Instatiate the server property manager
	  during server intialisation.

	* common/PropertyManager.h: Add the singletons accessor, and
	  make the addProperty member return a pointer to the property.

	* server/CorePropertyManager.h, server/CorePropertyManager.cpp:
	  Implement creating properties for server side entity objects.

	* rulesets/Entity.cpp: Use the property manager singleton to
	  create properties if a new attribute is set which is not already
	  a property, and its also not already a soft attribute.

2006-06-30  Al Riddoch  <alriddoch@zepler.org>

	* FIXME, Makefile.am: Add new FIXME file which documents FIXMEs in
	  the code.

	* server/EntityFactory.cpp: Remove the terrain feature classes
	  implemented as hard coded classes.

	* data/basic.xml: Add the terrain feature classes as soft data
	  defined classes.

2006-06-29  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Add properties for START_INTERSECTIONS
	  and END_INTERSECTIONS.

2006-06-29  Al Riddoch  <alriddoch@zepler.org>

	* common/DynamicProperty.h, common/DynamicProperty_impl.h:
	  Add a second dynamic property template which can wrap any
	  property class, not just instances of Property<>.

	* server/CorePropertyManager.cpp: Install a property factory for
	  COORDS, to handle the coordinates in a line.

	* common/DynamicProperty.cpp, common/PropertyFactory.cpp: Remove
	  unnecessary template instanciations.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, server/Account.cpp, server/Admin.cpp,
	  server/Connection.cpp, server/EntityFactory.h,
	  server/Persistor_impl.h, tools/cycmd.cpp: 
	  Switch from using deprecated sigc++ 1.2 headers to the right
	  sigc++ 2.0 equivalents.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* common/DynamicProperty.cpp, common/DynamicProperty.h,
	  common/DynamicProperty_impl.h: New property class for handling
	  properties or attributes added on the fly which need to store the
	  value.

	* common/PropertyFactory.cpp, common/PropertyFactory_impl.h,
	  server/CorePropertyManager.cpp: Use DynamicProperty in the
	  property factories for properties created on the fly.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add check for recent gcc versions, and turn of
	  strict aliasing on versions which have trouble with python
	  pointer casting.

	* common/PropertyFactory_impl.h, server/CorePropertyManager.cpp:
	  Return safe values from function stubs to get rid of compiler
	  warnings.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* common/Makefile.am: Add missing reference to header file.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyFactory.cpp, common/PropertyFactory.h,
	  common/PropertyFactory_impl.h, common/PropertyManager.cpp,
	  common/PropertyManager.h: Add new classes to automate the
	  creation of property objects for known property types.

	* server/CorePropertyManager.cpp, server/CorePropertyManager.h:
	  Manager object that will coordinate creating properties
	  when they are added to entities.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Bisect.py: Starting point for task
	  for cutting chunks of material in half.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Slice.py: Clean out some unused code.

2006-06-21  Al Riddoch  <alriddoch@zepler.org>

	* common/debug.h, common/debug.cpp: Add interface template for a
	  function which dumps a representation of a type to stdout, and
	  add a specialisation for dumping Atlas message data.

2006-06-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Slice.py: Fix shape of boards, and add
	  appropriate position offset.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Slice.py: The basics of cutting lumber
	  into boards is now working.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Task.cpp: Add "progress" and "rate" to Task.getattr
	  for python.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Task.cpp: Allow progress to be set as an integer from
	  a task script.

	* data/mason.xml, rulesets/mason/world/tasks/Slice.py: Add a new
	  slice task for sawing logs into boards.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py: Fix some issues
	  with code that assumed op.from and op.to where entities rather
	  than entity IDs.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Don't forward ops to the mind blindly if
	  we don't know what they are.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add classes for raw building materials.

2006-06-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Re-write comments about sending ops from
	  mind to world.

2006-06-08  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Add a message to the crash handlers giving
	  an email address to report bugs to.

2006-06-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp: Ensure collision prediction returns move_tick
	  when a collision is not predicted. Remove pointless assignments.
	  Clarify error message.

2006-06-06  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, rulesets/Character.cpp, rulesets/Creator.cpp,
	  server/Account.cpp, server/Admin.cpp, server/Connection.cpp,
	  server/Lobby.cpp, server/WorldRouter.cpp: Don't bother with serial
	  numbers on ops generated inside the server. They just leak and upset
	  clients.

2006-06-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Creator.cpp, common/BaseEntity.cpp:
	  Catch the last few places, and ensure refno is only set if
	  serialno is set on the causing op.

2006-06-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Add a function to handle
	  all the changes required when the LOC or container of an entity
	  changes.

	* rulesets/Motion.cpp, rulesets/Thing.cpp: Use changeContainer()
	  rather than repeating the code in three places.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Add some assert checks when altering the
	  container of an entity.

	* rulesets/Motion.cpp: Fix the code in collision resolution that
	  handler container changes so it does reference counting,
	  inserting and removing from contains lists, and flagging entity
	  changes.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac, NEWS: Increment version for forthcoming release.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Don't add a settler to the deer
	  test scanario, as its not required.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Update the linked modules for the tests so that
	  they build against the new movement code.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/move.py: Make deer run further
	  when they are scared, thus making their movement smoother.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Clear out movement debug output.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.h: Add method to check if a target position has
	  been specified.

	* rulesets/Character.cpp: Don't return a tick for movement if no
	  target is specified, as the old movement object has no further
	  role to play.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Re-work the movement code so it never relies
	  on external serial numbers, but will use internal op serialnos
	  if they are available, or use its own refnos if not.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp, server/CommClient.cpp, server/Account.cpp:
	  Only set refnos on ops if the client has set a serial number.

	* rulesets/Character.cpp: Simplify handling the transfer of
	  operations from client to in-game. Don't give new operations
	  serial numbers at this point.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Only set the refno on an op if the original
	  had a serilno. Don't bother setting serialno on internal ops.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp, rulesets/Motion.h: Add method and storage
	  to note what the reference number of the next update op should
	  be.

	* rulesets/Thing.cpp: Note the current serialno as the refno of the
	  expected update op, and ignore all others obsolete update ops.

2006-06-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp, rulesets/Thing.cpp: Disable debug flags.

2006-06-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.h, rulesets/Movement.cpp, rulesets/Pedestrian.cpp:
	  Remove old obsolete collision code.

2006-06-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.h: Rename to clearCollision() to adhere to
	  convention.

	* rulesets/Motion.cpp: Implicitly clear a pending collision whenever
	  one is resolved.

	* rulesets/Thing.cpp: Cut in the new collision resolution code.

2006-06-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp, rulesets/Motion.h: Initial implementation of
	  collision resolution code.

2006-06-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.h: Add method to clear the collision flag.

	* rulesets/Thing.cpp: Clear the collision flag once it has been
	  handled, and improve code harmonisation between MoveOp and
	  UpdateOp handlers.

2006-06-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Plant.cpp: Fix nourish handler to check for a script
	  handler first.

2006-06-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Pedestrian.cpp: Disable old collision detection code.

	* rulesets/Thing.cpp: First working version of entity based collision
	  code.

2006-06-01  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Add op to notify client when account object
	  is modified.

2006-06-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.h, rulesets/Motion.cpp: Add flag and time to sore
	  info about collisions.

	* rulesets/Thing.cpp: Rambling messy code to detect and act on
	  predicted collisions.

2006-06-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.h, rulesets/Motion.cpp: Add method to check for
	  collisions.

	* rulesets/Thing.cpp: Use Motion::checkCollisions to output debug
	  data about collisions.

2006-05-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Implement basic movement updates.

	* rulesets/Pedestrian.cpp: Disable updatePos as it is no longer
	  required.

	* TODO: Add notes on further refactoring of movement code.

2006-05-31  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Add new constant for period between movement updates.

	* rulesets/Pedestrian.cpp: Don't update entity movement timestamp
	  here.

	* rulesets/Thing.cpp: Add comments about movement code. Update
	  movement timestamp when move op is handled. Use movement update
	  interval for update ops.

2006-05-30  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp: Add Update operation type to those registered
	  with Atlas.

2006-05-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.h, rulesets/Thing.cpp: Create a function to hold
	  visibility checking code, and remove it from MoveOperation, calling
	  the function instead.

2006-05-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/TaskScript.h: Add accessor for the script object associated
	  with a task.

	* rulesets/Py_Task.cpp: Add a function to wrap a task which uses the
	  tasks existing python object if it has one.

2006-05-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Add function to test matrixing
	  deer.

2006-05-23  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp: Remove debug output.

2006-05-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonMindScript.cpp: Report an error if one occurs
	  running a hook function in a script.

	* rulesets/Statistics.cpp: Remove an obsolete FIXME.

2006-05-18  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.h, rulesets/Creator.cpp, rulesets/World.cpp,
	  server/WorldRouter.cpp, server/WorldRouter.h, tests/TestWorld.h:
	  Pass perceptive entities to the world by pointer rather than
	  by ID, avoiding a lookup in the dictionary.

2006-05-16  Al Riddoch  <alriddoch@zepler.org>

	* server/ExternalMind.cpp: Don't remove object from connection
	  as it may be required again, and it will be removed anyway if the
	  entity is destroyed.

2006-05-16  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp: Don't remove characters from the connection
	  when they are logged out.

